;=================================
;Project : TriggerSystem
;Version : 0.1
;Author : H@non ɍ
;Contact : hanon90@gmail.com
;Visit : http://demon-soul.at.ua
;=================================
Type TriggerInfo
	Field x#, y#, z#
	Field pitch#, yaw#, roll#
	Field HandleTrig
	Field Tow
End Type

Type TriggerSphere
	Field radius#
	Field mesh
End Type

Global TrigEnt

Function InitTrigger()
	TrigEnt = CreatePivot()
End Function

Function AddTrigSphere.TriggerInfo(Debug=False, x#, y#, z#, radius#=1)
	Local t.TriggerInfo = New TriggerInfo
	t\x=x : t\y=y : t\z=z
	Local ts.TriggerSphere = New TriggerSphere
	If Debug = True Then
		ts\mesh = CreateSphere(16)
		ScaleMesh ts\mesh, radius, radius, radius
		PositionEntity ts\mesh, t\x, t\y, t\z
		EntityAlpha ts\mesh, 0.1
	EndIf
	ts\radius = radius*radius
	t\HandleTrig = Handle (ts)
	
	Return t
End Function

Function CheckEntityInTrig( ent, t.TriggerInfo)
	Local dx#, dy#, dz#
	Local Dist#
	Local ts.TriggerSphere
	
	dx = EntityX(ent,1) - t\x
	dy = EntityY(ent,1) - t\y
	dz = EntityZ(ent,1) - t\z
	Dist = (dx*dx + dy*dy + dz*dz)
	ts.TriggerSphere = Object.TriggerSphere( t\HandleTrig )
	If Dist <= ts\radius Then Return True
		
	Return False
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D