Include "Include\AShadow.bb"
Include "Include\TrigMain.bb"
Include "Include\WayPoints.bb"

Type EnemyType
	Field ent
	Field name$
	Field speed#
	Field health
	Field healthmax
	Field way
End Type

Type TowerType
	Field ent
	Field name$
	Field x
	Field y
	Field z
	Field dect
End Type

AGraphics3D 800,600,32,1
SetBuffer BackBuffer()
HidePointer

AmbientLight 128,128,128

InitShadowLib()
ShAlpha#=0.5
InitTrigger()

Const PoleSize=64
If PoleSize=64 Then PoleDiv=52
If PoleSize=128 Then PoleDiv=100

Dim Pole(PoleSize,PoleSize)

Global CamX,CamY,CamZ
CamX=PoleSize/2
CamY=25
CamZ=8

Camera=CreateCamera()
PositionEntity Camera,CamX,CamY,CamZ
RotateEntity Camera,80,0,0

Light=CreateLight(2)
LightColor Light,128,128,128
PositionEntity Light,PoleSize/2,PoleSize/3,PoleSize/2
SetSLight(Light,2)

; ***  ***
Global Terrain=LoadTerrain("Data\Textures\HeightmapB.bmp",0)
PositionEntity Terrain,0,.1,0
ScaleEntity Terrain,1,10,1
Grass=LoadTexture("Data\Textures\Ground.jpg")
ScaleTexture Grass, 30, 30
TerrainAdd=LoadTexture("Data\Textures\GroundAdd.bmp")
ScaleTexture TerrainAdd,PoleSize,PoleSize
TerrainShadow=LoadTexture("Data\Textures\CloudsShadow.bmp")
ScaleTexture TerrainShadow,PoleSize,PoleSize
EntityTexture Terrain,Grass
EntityTexture Terrain,TerrainAdd,0,1
;EntityTexture Terrain,TerrainShadow,0,3
EntityPickMode Terrain,2
NameEntity Terrain,"Terrain"

; ***  WayPoint- ***
Local vp1 = AddVayPoint(PoleSize/2, 0, PoleSize/2)
Local vp2, n
For n = 1 To 5
	vp2 = AddVayPoint(Rnd(1, PoleSize), 0, Rnd(1, PoleSize))
	AddNextVP(vp1, vp2)
	vp1 = AddVayPoint(Rnd(1, PoleSize), 0, Rnd(1, PoleSize))
	AddNextVP(vp2, vp1)
Next

Global vp.VayPoint = First VayPoint
AddNextVP(vp1, Handle(vp))

; ***   ***
Box=LoadTexture("Data\Textures\Crate.jpg")

; ***   ***
Mouse3D=LoadMesh("Data\Tube.3DS")

Cube=ACreateCube(0,2)
HideEntity Cube

TowerGengon=ALoadMesh("Data\Gengon.3DS",0,2)
HideEntity TowerGengon

; ***   ***
For i=1 To 8
	Enemy.EnemyType=New EnemyType
	Enemy\ent=ACopyMesh(TowerGengon,0,2)
	EntityTexture Enemy\ent,Box
	PositionEntity Enemy\ent,i*2,0,i*4
	Enemy\speed=0.1
	Enemy\health=100
	Enemy\healthmax=100
	Enemy\way = AddEntityToVP(Enemy\ent,0.9,Enemy\speed)
	SetEntityVP(Enemy\way, Handle(vp))
Next

; ***   ***
For i=0 To PoleSize
	For j=0 To PoleSize
		Pole(i,j)=0
	Next
Next

; ***   ***
Tower.TowerType=New TowerType
Tower\ent=ACopyMesh(TowerGengon,0,2)
EntityTexture Tower\ent,Box
PositionEntity Tower\ent,PoleSize/2,0,4
CheckTerrainY(Terrain,Tower\ent,Tower\x,0,Tower\z)
Tower\dect=False
TowRadar.TriggerInfo=New TriggerInfo
TowRadar = AddTrigSphere(False, PoleSize/2, EntityY(Tower\ent), 4, 8)
TowRadar\Tow=Handle(Tower)

period = 1000 / 60
time = MilliSecs () - period

While Not KeyDown(1)

Repeat
	elapsed = MilliSecs () - time
Until elapsed
ticks = elapsed / period
tween# = Float (elapsed Mod period) / Float (period)

For framelimit = 1 To ticks
If framelimit = ticks Then CaptureWorld
time = time + period

MousePick=CameraPick(Camera,MouseX(),MouseY())
If MousePick<>0 Then
	If EntityName(MousePick)="Terrain" Then
		Mouse3Dx=PickedX()
		Mouse3Dz=PickedZ()
		If Mouse3Dx<1 Then Mouse3Dx=1
		If Mouse3Dx>PoleSize-1 Then Mouse3Dx=PoleSize-1
		If Mouse3Dz<1 Then Mouse3Dz=1
		If Mouse3Dz>PoleSize-1 Then Mouse3Dz=PoleSize-1
	End If
End If

If MouseHit(1)=True Then
	;If EntityName(Picked)="Terrain" Then
	
	; ***     ***
	If DrawObject(Mouse3Dx,Mouse3Dz,1)=1 Then
		Tower.TowerType=New TowerType
		Tower\ent=ACopyMesh(TowerGengon,0,2)
		EntityTexture Tower\ent,Box
		PositionEntity Tower\ent,Mouse3Dx,0,Mouse3Dz
		CheckTerrainY(Terrain,Tower\ent,Mouse3Dx,0,Mouse3Dz)
		Tower\dect=False
		Local TempY=EntityY(Tower\ent)
		TowRadar.TriggerInfo=New TriggerInfo
		TowRadar = AddTrigSphere(False, Mouse3Dx, TempY, Mouse3Dz, 10+(TempY/2))
		TowRadar\Tow=Handle(Tower)
	End If
End If

If MouseDown(2)=True Then
	PaintBlood(TerrainAdd,Mouse3Dx,64-Mouse3Dz,1)
EndIf

; ***   ***
PositionEntity Mouse3D,Mouse3Dx,10,Mouse3Dz
CheckTerrainY(Terrain,Mouse3D,Mouse3Dx,0,Mouse3Dz)

; ***  ***
If KeyDown(203) Then ;
	If CamX>12 Then CamX=CamX-1
End If
If KeyDown(205) Then ;
	If CamX<PoleDiv Then CamX=CamX+1
End If
If KeyDown(200) Then ;
	If CamZ<PoleDiv Then CamZ=CamZ+1
End If
If KeyDown(208) Then ;
	If CamZ>6 Then CamZ=CamZ-1
End If

PositionEntity Camera,CamX,CamY,CamZ

; ***  WayPoint   ***
UpdateVP()

; ***     ***
For TowRadar.TriggerInfo=Each TriggerInfo
	TempTower.TowerType = Object.TowerType(TowRadar\Tow)
	If TempTower<>Null Then
		TempTower\dect=False
		
		For Enemy.EnemyType=Each EnemyType
			CheckTerrainY(Terrain,Enemy\ent,EntityX(Enemy\ent),0,EntityZ(Enemy\ent))
			If CheckEntityInTrig(Enemy\ent,TowRadar)=True Then TempTower\dect=True
		Next
		
		If TempTower\dect=True Then 
			EntityColor TempTower\ent,255,0,0
		Else
			EntityColor TempTower\ent,255,255,255
		End If
	End If
Next

Next 
ARenderWorld(Camera,1,ShAlpha#)

;CameraProject(Camera,EntityX(Enemy\ent),EntityY(Enemy\ent),EntityZ(Enemy\ent))
;Text ProjectedX#()-16,ProjectedY#()+8,Enemy\health+"\"+Enemy\healthmax

Text 5,5,Mouse3Dx
Text 5,15,Mouse3Dz

Flip
Wend

End

; *** CheckTerrainY ***
Function CheckTerrainY(terr,entity,x#,y#,z#)
	terra_y#=TerrainY(terr,x#,y#,z#)+.1
	PositionEntity entity,EntityX(entity),terra_y#,EntityZ(entity)
End Function

; ***     ***
Function DrawObject(x,z,s)
	Draw=0
	Select s
		Case 1
			If (Pole(x,z)=0) And (x>0) And (x<PoleSize) And (z>0) And (z<PoleSize) Then
				Pole(x,z)=1
				Draw=1
			EndIf
		Case 2
			If (x>0) And (x+1<PoleSize) And (z>0) And (z+1<PoleSize) Then
			If (Pole(x,z)=0) And (Pole(x+1,z)=0) And (Pole(x,z+1)=0) And (Pole(x+1,z+1)=0) 
				Pole(x,z)=1
				Pole(x+1,z)=1
				Pole(x,z+1)=1
				Pole(x+1,z+1)=1
				Draw=1
			End If
			End If
		Case 3
			If (x-1>0) And (x+1<PoleSize) And (z-1>0) And (z+1<PoleSize) Then
			If (Pole(x+1,z-1)=0) And (Pole(x-1,z)=0) And (Pole(x-1,z-1)=0) And (Pole(x,z-1)=0) And (Pole(x+1,z-1)=0) Then
			If (Pole(x,z)=0) And (Pole(x+1,z)=0) And (Pole(x,z+1)=0) And (Pole(x+1,z+1)=0) Then
				Pole(x+1,z-1)=1
				Pole(x-1,z)=1
				Pole(x-1,z-1)=1
				Pole(x,z-1)=1
				Pole(x+1,z-1)=1
				Pole(x,z)=1
				Pole(x+1,z)=1
				Pole(x,z+1)=1
				Pole(x+1,z+1)=1
				Draw=1
			End If
			End If
			End If
	End Select
		
	Return Draw
End Function

; ***     ***
Function PaintBlood(tex,x,y,rad)
	SetBuffer TextureBuffer(tex)
	
	maxwidth  = TextureWidth(tex)
	maxheight = TextureHeight(tex)
	
	red# = Rand(140,200)
	grn# = 0
	blu# = 0
	WritePixel x,y,blu Or (grn Shl 8) Or (red Shl 16)
	
	SetBuffer BackBuffer()
End Function