
;====================================[FX Library by ANDREYman]====================================


Const ShadowLibraryVersion$="1.3.6.6.6" ; Satan has you :)
Const S_AShadowDLLvers% = 1089

Global DrawProgress=1; drawing progress for processing caster's geometry

Const MaxCountTrisToCaster=10500 ; maximum poligons in caster's mesh ( important! ) - changeable value [0,65535]

Global Stencil_DebugMode=1 ;Debug mode for this system ;)

;Global VolumeBuildMethod = 0; Method for building a shadow volumes, 0 - detailed, but slower, 1 - fast, but simply (don't work!)

Global TimeShadow ;time for making shadow volumes
Global ShadowTris ;Triangles in shadow volumes
Global RenderTris ;Triangles in scene (analogue TrisRendered() )

;Color shadow For ZPass (only visible shadows)
Global ZPassColorR=0
Global ZPassColorG=255
Global ZPassColorB=0

;Color shadow For ZFail (only visible shadows)
Global ZFailColorR=255
Global ZFailColorG=0
Global ZFailColorB=0

Global ShowActiveCasters=1 ; Changing Color(above, below) for Active and Static casters
Global SoftSelfShading=0 ; global mode for Soft Self Shading
Global ShadowFrustumCulling=1; global mode for shadow Frustum Culling (test of shadow visibly to the camera)
Global ZfailMode=1 ;Global mode for ZFail technology; for advanced users :)
Global ShadowVolumeAlpha#=0 ;Alpha in shadow volumes, if value>0 then volumes rendered in color buffer(visible)
Global DefaultSRange#=100 ; default shadow range for Directional light

;     functions For simplification of the integrations!
;######################################################################################################################
;ShadowMode:
Const FullBright =  0; - Object is Not shadowed
Const Receiver =   1; - Object is shadowed (Default)
Const Caster =      2; - Object is Caster!
Const InLight =     3; - Object is seen in the Field of light only, in shadow - is Not seen.
Const InShadow = 4; - Object is seen in the Field of shadow only, on light - is Not seen.

;If value "-1", that it will remain former Or is inherited(ACopyEntity).
Function AGraphics3D ( width, heightm, depth=32, mode=1)
Graphics3D  width, heightm, depth, mode
InitShadowLib()
End Function

Function ACreateTerrain(grid_size=1,parent=0,ShadowMode=1)
AS_entity=CreateTerrain(grid_size,parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
EndIf
Return AS_entity
End Function

Function ALoadTerrain(file$,parent=0,ShadowMode=1)
AS_entity=LoadTerrain(file$,parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
EndIf
Return AS_entity
End Function

Function ACreatePlane(sub_divs=1,parent=0,ShadowMode=1)
AS_entity=CreatePlane(sub_divs,parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
EndIf
Return AS_entity
End Function

Function ACreateCone(segments=8,solid=1,parent=0,ShadowMode=1,ShadowRange#=0, SoftSelfShadingMODE=0)
AS_entity=CreateCone(segments,solid,parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
ElseIf ShadowMode=2
CreateCaster(AS_entity,0,ShadowRange,1,1, SoftSelfShadingMODE)
EndIf
Return AS_entity
End Function

Function ACreateCube(parent=0,ShadowMode=1,ShadowRange#=0, SoftSelfShadingMODE=0)
AS_entity=CreateCube(parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
ElseIf ShadowMode=2
CreateCaster(AS_entity,0,ShadowRange,1,1, SoftSelfShadingMODE)
EndIf
Return AS_entity
End Function 

Function ACreateSphere(segments=8,parent=0,ShadowMode=0,ShadowRange#=0, SoftSelfShadingMODE=0)
AS_entity=CreateSphere(segments,parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
ElseIf ShadowMode=2
CreateCaster(AS_entity,0,ShadowRange,1,1, SoftSelfShadingMODE)
EndIf
Return AS_entity
End Function

Function ACreateCylinder(segments=8,solid=1,parent=0,ShadowMode=1,ShadowRange#=0, SoftSelfShadingMODE=0)
AS_entity=CreateCylinder(segments,solid,parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
ElseIf ShadowMode=2
CreateCaster(AS_entity,0,ShadowRange,1,1, SoftSelfShadingMODE)
EndIf
Return AS_entity
End Function

Function ACreateSprite(parent=0)
AS_entity=CreateSprite(parent)
CreateReceiver(AS_entity,0)
Return AS_entity
End Function 

Function ALoadSprite(tex_file$,tex_flag=0,parent=0 )
AS_entity=LoadSprite(tex_file$,tex_flag,parent )
CreateReceiver(AS_entity,0)
Return AS_entity
End Function 

Function ACreateMesh(parent=0,ShadowMode=1,ShadowRange#=0)
AS_entity=CreateMesh(parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
ElseIf ShadowMode=2
CreateCaster(AS_entity,0,ShadowRange)
EndIf
Return AS_entity
End Function 

Function ALoadMesh(file$,parent=0,ShadowMode=1,ShadowRange#=0, SoftSelfShadingMODE=0)
AS_entity=LoadMesh(file$,parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
ElseIf ShadowMode=2
CreateCaster(AS_entity,file$,ShadowRange,1,1, SoftSelfShadingMODE)
EndIf
Return AS_entity
End Function

Function ALoadAnimMesh(file$,parent=0,ShadowMode=1,ShadowRange#=0, SoftSelfShadingMODE=0)
AS_entity=LoadAnimMesh(file$,parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
ElseIf ShadowMode=2
CreateAnimCaster(AS_entity,file$,ShadowRange#,1,1, SoftSelfShadingMODE)
EndIf
Return AS_entity
End Function

Function ALoadBSP( file$, gamma_adjust#, parent=0, ShadowMode=1 )
AS_entity=LoadBSP(file$, gamma_adjust#)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
EndIf
Return AS_entity
End Function

Function ALoadMD2( md2_file$, gamma_adjust#, parent=0, ShadowMode=1 )
AS_entity=LoadMD2(md2_file$, gamma_adjust#)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
EndIf
Return AS_entity
End Function

Function ACopyEntity(dest_entity,parent=0,ShadowMode=-1,ShadowRange#=-1, SoftSelfShadingMODE=-1)
AS_entity=CopyEntity(dest_entity,parent)


If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=2

CopyCaster(AS_entity , dest_entity ,ShadowRange,1,1, SoftSelfShadingMODE)
S_FindALLChildren AS_entity
For S_SEntityChild.S_SEntityChildren=Each S_SEntityChildren
	S_child= S_SEntityChild\Entity
	CarrentMesh = RetI(S_child + S_ShadowStructOffset)
	If Not CarrentMesh=0 CopyCaster(S_child , CarrentMesh ,ShadowRange,1,1, SoftSelfShadingMODE)
Next

ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
Else
CreateReceiver(AS_entity,0)
EndIf
Return AS_entity

End Function 

Function ACopyMesh(dest_entity,parent=0,ShadowMode=1,ShadowRange#=-1, SoftSelfShadingMODE=-1)
AS_entity=CopyMesh(dest_entity,parent)
If ShadowMode=0
CreateReceiver(AS_entity,0)
ElseIf ShadowMode=1
CreateReceiver(AS_entity,1)
ElseIf ShadowMode=2
CopyCaster(AS_entity,dest_entity,ShadowRange,1,1, SoftSelfShadingMODE)
ElseIf ShadowMode=3
CreateReceiver(AS_entity,3)
ElseIf ShadowMode=4
CreateReceiver(AS_entity,4)
Else
CreateReceiver(AS_entity,0)
EndIf
Return AS_entity
End Function 

Function AFreeEntity(AS_entity)
If EntityClass$(AS_entity)="Light"
  For SShadowLight.SShadowLights=Each SShadowLights
   If SShadowLight\entity=AS_entity  Delete SShadowLight
  Next
Else
	If DeleteCaster(AS_entity)
	Else
	 Deletereceiver(AS_entity)
	EndIf
EndIf
FreeEntity(AS_entity)
End Function

Function ARenderWorld(S_cam,S_tween#=1.0, ShadowMode_Alpha#=0)
Stencil_Error=0
If StencilShadowLight=0
If Stencil_DebugMode=1 RuntimeError "ERROR: Light is not seted!"
Stencil_Error=1
EndIf
If S_cam=0
If Stencil_DebugMode=1 RuntimeError "ERROR: Camera is not exist!"
Stencil_Error=1
Else
If Not EntityClass(S_cam)="Camera"
If Stencil_DebugMode=1 RuntimeError "ERROR: Entity is not Camera!"
Stencil_Error=1
EndIf
EndIf
If Stencil_Error=0
	
If ShadowMode_Alpha#>0
RenderSceneStage1(S_cam,S_tween#,1)
 	UpdateShadows(S_cam)
RenderVolums(S_cam,S_tween#)
DrrawShadow ShadowMode_Alpha#
RenderAlpha(S_cam,S_tween#)
Else
RenderSceneStage1(S_cam,S_tween#,0)
 	UpdateShadows(S_cam)
RenderVolums(S_cam,S_tween#)
RenderSceneStage2(S_cam,S_tween#,1)
RenderAlpha(S_cam,S_tween#)
EndIf

EndIf
End Function
;if ShadowMode_Alpha>0 then ShadowMode="Fake", else - ShadowMode="Realistic"

Function AEnd()

Free_ALLSystems()

End Function



Function AEnableAnistropicFilter( lbias#=-.2, sloy=8 ) 
             BBSetTextureStageState( 21 ,sloy,3) 
             BBSetTextureStageState( 16 ,sloy, 5) 
             BBSetTextureStageState( 17 ,sloy, 3) 
             BBSetTextureStageState( 18 ,sloy, 3) 
             BBSetTextureStageState( sloy, 19, BBF2DW(lbias) )
End Function


;######################################################################################################################

Function Free_ALLSystems()

FreePostProcess()
FreeWaters ()
FreeShadows()

End Function



Dim TrisResult(32500)
;Dim VertResult(MaxCountTrisToCaster*2)
Dim trisma(100)
Dim trismb(100)
Dim trismc(100)

Type TypeHandles
Field TypeHandle
End Type

Type SShadowLights
	Field entity%; light
	Field LType; light type
	Field Range#; light range
	Field R%
	Field G%
	Field B%
	Field hiden%
End Type

Type ShadowReceivers
	Field entity%; receiver's entity
	Field hiden%
	Field Shadowed%; shadowed mode
	Field Alpha#
	Field BrushStart%
	Field BrushEnd%
	Field caster%
End Type

Type UserShadowVolumes
	Field entity%; User shadow volume mesh
	Field hiden%
	Field Ztech%; Z-technology
	Field Alpha#; Alpha of volume ( visible in color for value>0)
End Type

Type ShadowCasters
	Field ThisCasterHandle
	Field PersonalLight
    Field PersonalLType
    Field PersonalLRange#
    Field parentCaster%
	Field TypeHandle.TypeHandles
	Field entity% ; entity of caster
;	Field ShadowFile$
	Field hiden%
	Field Alpha# ;Caster's entity alpha
	Field culling
	Field adres%; Handle in shadow volume's type
	Field recAdr%; Handle in receiver's type
	Field ShadowVolume; Shadow volume mesh
	Field ShadowUpperAndLowerHats; for advanced users 
	Field ShadowBackShapka
	Field ShadowLowerSurface
	Field BildShapka
	Field shadowTris
	Field shadowVerts
	Field Zfail ; ZFail mode for caster at the moment
	Field ZfailOFF ;ZFail disable mode
	Field SoftSelfShadingMODE; SoftSelfShading mode for this caster
	Field S_range#; shadow length
	Field offt
	Field Active
	Field N
	Field copy
	Field on ; Enable/Disable shadow
	Field NoUpdate ; Mode for disabling shadow volume updating 
	Field InZone
	Field DrawOFF
	Field GeomUpdate ; Update tris normals at next update's step
	Field dx#
	Field dy#
	Field dz#
	Field Deltap#
	Field Deltay#
	Field Deltar#
	Field scalex#
	Field scaley#
	Field scalez#
	Field Lx#
	Field Ly#
	Field Lz#
	Field Nx#
	Field Ny#
	Field Nz#
	Field Radius#
	Field bbox
	Field Dest#
	Field ProgressTime% ;Time of progress for processing caster geometry
End Type

Global ACullMode=3
Global DirectionalLightBackTrisOFF=0
Global TimeRender
Global AWireFrame=3
Global S_cullm=3
Global StencilShadowType=1746836
Global SoftSelfShDraw
Global FirstStencilBBox

Const ShadowAnimFileVersion$="1.0.5" 

Type S_SEntityChildren
	Field entity
 End Type

Type RectSize 
   Field S_x1% 
   Field S_y1% 
   Field x2% 
   Field y2% 
End Type 

Type lpSecurityAttributes
End Type
Attribut.lpSecurityAttributes=New lpSecurityAttributes

Global AppHWND
Global Direct3DDevice7
Global  Direct3DDraw7
Global Stencil_CarrentCamera
Global S_FirstEntity
Global S_LastEntity
Global S_TimeCR
Global S_sizex#
Global S_sizey#
Global S_sizez#
Global S_sizex1#
Global S_sizey1#
Global S_sizez1#
Global S_EntityRadius#
Global CameraZnear#
Global CountCS
Global ZfailBrushON
Global ZfailBrushOFF
Global SLibInitialized=0
Global AlphaFixedMesh
Global Ashadowplane
Global S_StencilSysPivot
Global Sshp_ColorR
Global Sshp_ColorG
Global Sshp_ColorB
;Global Sshp_alpha#
Global Sshp_Blend
Global No_texture
Global Simple_texture
Global Screen_TextureSystemRT1=0
Global Screen_TextureSystemRT2=0
Global S_ShadowStructOffset = 240
Global S_LightBrushStart
Global S_LightBrushEnd
Global S_StencilSysMesh

Global S_ReceiversPivot
Global S_CastersPivot
Global S_ReceiversInLightPivot
Global S_ReceiversInShadowPivot
Global S_NotReceiversPivot

Global S_GoDest=2000
Global FrontDraw=1

Global CLS_COLOR=$4080f0

Global BackBafferTex

Type TrisMassiv
    Field n
	Field na
	Field nb
	Field nc
	Field S_a%[100]
	Field S_b%[100]
	Field S_c%[100]
End Type

Type ShadowVolumes
	Field Ta%[MaxCountTrisToCaster]
	Field Tb%[MaxCountTrisToCaster]
	Field Tc%[MaxCountTrisToCaster]
	Field Tnx#[MaxCountTrisToCaster]
	Field Tny#[MaxCountTrisToCaster]
	Field Tnz#[MaxCountTrisToCaster]
	Field CounCasters%
End Type

Global ClearSize.RectSize=New RectSize

Global StencilShadowLight
Global Stencil_LightType
Global Stencil_LightRange
Global Stencil_LNx#
Global Stencil_LNy#
Global Stencil_LNz#

Global S_LigtCount

Function ShadowDebug ( Mode% )
Stencil_DebugMode=Mode
End Function

Function InitShadowLib()
If SLibInitialized=0

S_GettingAShadowDLLvers = GetAShadowDLLVersion()
If S_AShadowDLLvers > S_GettingAShadowDLLvers
RuntimeError "User Lib version(v."+S_GettingAShadowDLLvers+") is Not correct, you must update Ashadow.dll (v."+S_AShadowDLLvers+")"
EndIf

ClearSize.RectSize=First RectSize
ClearSize\S_x1=0 
ClearSize\S_y1=0 
ClearSize\x2=GraphicsWidth() 
ClearSize\y2=GraphicsHeight()

Direct3D7=SystemProperty$("Direct3D7")
Direct3DDevice7=SystemProperty$("Direct3DDevice7")
Direct3DDraw7=SystemProperty$("DirectDraw7")
AppHWND=SystemProperty$("AppHWND")
AppHINSTANCE=SystemProperty$("AppHINSTANCE")

If Direct3D7=0 RuntimeError "FATAL ERROR: Can't get access to Drect3DDevice!"

BBSetSystemControl (Direct3D7,Direct3DDevice7,Direct3DDraw7)


BBGetCaps()
BUMPENVMAP_SUPPORT = CheckBumpSupport(0)
BUMPENVMAPLUMINANCE_SUPPORT = CheckBumpSupport(1)

 
 S_FirstEntity = CreateCamera()
 CameraProjMode S_FirstEntity,0

S_StencilSysPivot = CreatePivot()
HideEntity S_StencilSysPivot
;CutEntity( S_StencilSysPivot )

FirstStencilBBox = CreateBox4()
CutEntity( FirstStencilBBox )
 
No_texture = CreateTexture(2,2)
Simple_texture = CreateTexture(2,2, 9)
TextureBlend No_texture,0
EndIf

If AlphaFixedMesh=0
	AlphaFixedMesh=CreateMesh()
	AFMsurf = CreateSurface(AlphaFixedMesh)
	AddVertex  AFMsurf, 100, 100, 100
	AddVertex  AFMsurf, -100, -100, -100
	EntityOrder AlphaFixedMesh,-99
	EntityAlpha AlphaFixedMesh,0.0001
	EntityColor AlphaFixedMesh,10,10,10
	EntityFX AlphaFixedMesh,1+8
	AHideEntity AlphaFixedMesh
EndIf

;S_StencilSysMesh = CreateMesh()
;EntityBlend S_StencilSysMesh,1
;S_LightBrushStart = reti ( S_StencilSysMesh+145*4)
;S_LightBrushEnd = reti ( S_StencilSysMesh+146*4)
;cutentity S_StencilSysMesh
;;S_LightBrush = CreateBrush(255,255,255)
;;S_TextureBrush = CreateBrush(255,255,255)
;;BrushBlend S_LightBrush,3
;;BrushBlend S_TextureBrush,3

SLibInitialized=1

End Function 

Function FreeShadows()

If SLibInitialized
If No_texture FreeTexture No_texture
No_texture=0

If Simple_texture FreeTexture Simple_texture


If AlphaFixedMesh FreeEntity AlphaFixedMesh

PasteEntity( FirstStencilBBox )
If FirstStencilBBox FreeEntity FirstStencilBBox


If S_StencilSysPivot  FreeEntity S_StencilSysPivot

  Delete Each TrisMassiv
  Delete Each ShadowVolumes
  Delete Each ShadowCasters
  Delete Each UserShadowVolumes
  Delete Each ShadowReceivers
  Delete Each SShadowLights

  If S_FirstEntity FreeEntity S_FirstEntity

SLibInitialized=0
EndIf

End Function 

Function CreateSLight(LType=1, Range=100, R=255 ,G=255, B=255)
StencilShadowLight=CreateLight(LType)
Stencil_LightType=LType
If LType=3 Stencil_LightType=2
Stencil_LightRange=range
LightRange StencilShadowLight,range
LightColor StencilShadowLight,R,G,B

SS_Light.SShadowLights=New SShadowLights
SS_Light\entity=StencilShadowLight
SS_Light\LType=LType
SS_Light\Range#=Range
SS_Light\R%=R
SS_Light\G%=G
SS_Light\B%=B

Return StencilShadowLight
End Function

Function SetSLight(entity,LType=1,Range=100, R=255 ,G=255, B=255)
StencilShadowLight=entity
Stencil_LightType=LType
Stencil_LightRange=range
SS_Light.SShadowLights=New SShadowLights
SS_Light\entity=entity
SS_Light\LType=LType
SS_Light\Range#=Range
SS_Light\R%=R
SS_Light\G%=G
SS_Light\B%=B
;For SS_Light.SShadowLights=Each SShadowLights
;If SS_Light\entity=entity Delete light
;Next
End Function

Function GlobalSLight(entity,LType=2,Range=100)
StencilShadowLight=entity
Stencil_LightType=LType
Stencil_LightRange=range
End Function

Function CreateReceiver(Entity,Shadowed=1)
S_ReceiveNO=0
For StencilReceiver.ShadowReceivers=Each ShadowReceivers
If entity=StencilReceiver\entity S_ReceiveNO=1
Next
If S_ReceiveNO=0
StencilReceiver.ShadowReceivers= New ShadowReceivers
StencilReceiver\entity=Entity
StencilReceiver\hiden=StencilEntityHidden(Entity)
StencilReceiver\Shadowed=Shadowed
	
EndIf
End Function
;============================================================================================
;0 - Object is Not shadowed (AlphaBlend)
;1 - Object is shadowed (Default)
;2 - Reserved. (for caster)
;3 - Object is seen in the Field of light only, in shadow - is Not seen. (Specular objects)
;4 - Object is seen in the Field of shadow only, on light - is Not seen.
;============================================================================================

Function ChangeReceiver(Entity,Shadowed=1)
For StencilReceiver.ShadowReceivers= Each ShadowReceivers
If StencilReceiver\entity=entity StencilReceiver\Shadowed=Shadowed
Next
End Function

Function Deletereceiver(Entity)
Stencil_Return=0
For StencilReceiver.ShadowReceivers= Each ShadowReceivers
If StencilReceiver\entity=entity
Delete StencilReceiver
Stencil_Return=1
EndIf
Next
Return Stencil_Return
End Function

Function DeleteCaster(Entity)
Stencil_Return=0
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=entity

If Not StencilCaster\copy=0
Delete StencilCaster
Else
ten.ShadowVolumes=Object.ShadowVolumes(StencilCaster\adres)
ClearVolume(StencilCaster\ShadowVolume)
FreeEntity StencilCaster\ShadowVolume

StencilReceiver.ShadowReceivers=Object.ShadowReceivers( StencilCaster\recAdr )
Delete StencilReceiver

If ten\CounCasters=1
Delete ten
Else
ten\CounCasters=ten\CounCasters-1
EndIf

Delete StencilCaster
EndIf
Stencil_Return=1
EndIf
Next
Return Stencil_Return
End Function

Function ClearVolume(Entity)
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=entity
For S_i=1 To CountSurfaces(StencilCaster\ShadowVolume)
ClearSurface GetSurface(StencilCaster\ShadowVolume,S_i),1,1
Next
EndIf
Next
End Function

Function ShadowVolumesAlpha(alpha#=0)

ShadowVolumeAlpha#=alpha#
End Function 

Function ShadowAlpha(alpha#=0)

ShadowVolumeAlpha#=alpha#
End Function 

Function AEntityAlpha(Entity,Alpha#=0)
For StencilReceiver.ShadowReceivers=Each ShadowReceivers
If StencilReceiver\Entity=Entity
EntityAlpha StencilReceiver\entity,alpha#
StencilReceiver\Alpha#=alpha#
EndIf
Next
End Function 

Function SetEntityAlpha(Entity,Alpha#=0)
AEntityAlpha Entity,Alpha#
End Function 

Function CreateCaster(mesh,Stencil_FileS$=0,S_range=0,on=1,S_MeshAlpha#=1, SoftSelfShadingMODE=0, ZfailOFF=0)

Stencil_Error=0
If mesh
For SS_j=1 To CountSurfaces(mesh)
SS_s=GetSurface(mesh,SS_j)
SS_countTris=SS_countTris+CountTriangles(SS_s)
Next
If SS_countTris>MaxCountTrisToCaster
If Stencil_DebugMode=1 RuntimeError "ERROR: "+"Caster "+(CountCS+1)+". Limit Exceed! Entity CountTriangles("+SS_countTris+") > "+MaxCountTrisToCaster
Stencil_Error=1
EndIf
If Not EntityClass(mesh)="Mesh"
If Stencil_DebugMode=1 RuntimeError "ERROR: "+"Caster "+(CountCS+1)+". Entity is not Mesh!"
Stencil_Error=1
EndIf

Else
If Stencil_DebugMode=1 RuntimeError "ERROR: "+"Caster "+(CountCS+1)+". Entity is ''0''!"
Stencil_Error=1
EndIf

If Stencil_Error=0

StencilCaster.ShadowCasters= New ShadowCasters
StencilCaster\entity=mesh

WriteI ( mesh + S_ShadowStructOffset, mesh)

StencilCaster\Alpha#=S_MeshAlpha
StencilCaster\hiden=StencilEntityHidden(mesh)

StencilReceiver.ShadowReceivers= New ShadowReceivers
StencilReceiver\entity=mesh
StencilReceiver\hiden=StencilEntityHidden(mesh)
StencilReceiver\Shadowed=2
StencilCaster\recAdr=Handle(StencilReceiver.ShadowReceivers)
StencilReceiver\alpha#=S_MeshAlpha

S_ii=0
S_jj=0
CountCS=CountCS+1
StencilCaster\N=CountCS
StencilCaster\on=on
StencilCaster\S_range=S_range
StencilCaster\ZfailOFF= ZfailOFF
StencilCaster\SoftSelfShadingMODE=SoftSelfShadingMODE
S_adr=Handle(StencilCaster.ShadowCasters)
StencilCaster\ThisCasterHandle=S_adr

If VolumeBuildMethod=0 ;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

If Stencil_FileS$=0
SadowMesh=CreateVolume(S_adr)
StencilCaster\ProgressTime=S_TimeCR
CreateSbox(S_adr,CameraZnear)
EntityFX SadowMesh,17

Else

S_ILen=0
S_LeftOtstup=0
While Not S_ILen=Len(Stencil_FileS$) Or S_simvol$="."
S_ILen=S_ILen+1
S_simvol$=Mid(Stencil_FileS$,S_ILen,1)
If S_simvol$="." Exit
S_MFileName$=S_MFileName$+S_simvol
Wend

Stencil_FileZ$=S_MFileName$+".mst"

S_filem=OpenFile (Stencil_FileZ)
If S_filem=0

SadowMesh=CreateVolume(S_adr)
CreateSbox(S_adr,CameraZnear)

;Attribut.lpSecurityAttributes=First lpSecurityAttributes
;Stencil_fils=api_CreateFile(Stencil_FileZ, 0, 0, Attribut, 0, 0, 0)
Stencil_fils=WriteFile (Stencil_FileZ)

ten.ShadowVolumes=Object.ShadowVolumes(StencilCaster\adres)
For S_jj=1 To CountSurfaces(mesh)
S_s=GetSurface(mesh,S_jj)
For S_ii=0 To CountTriangles(S_s)-1
WriteInt(Stencil_fils,ten\Ta[S_ct+S_ii])
WriteInt(Stencil_fils,ten\Tb[S_ct+S_ii])
WriteInt(Stencil_fils,ten\Tc[S_ct+S_ii])
Next
S_ct=S_ct+CountTriangles(S_s)+1
Next
WriteInt(Stencil_fils,S_TimeCR)
StencilCaster\ProgressTime=S_TimeCR
CloseFile Stencil_fils

Else

Stencil_fils=ReadFile (Stencil_FileZ)

ten.ShadowVolumes = New ShadowVolumes
StencilCaster\adres=Handle(ten.ShadowVolumes )

StencilCaster\ShadowVolume=CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowVolume,"StencilShadow_volume"
EntityAlpha StencilCaster\ShadowVolume,0.0001
StencilCaster\ShadowUpperAndLowerHats=CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowUpperAndLowerHats,"StencilShadow_volume"
EntityAlpha StencilCaster\ShadowUpperAndLowerHats,0;.0001
EntityFX StencilCaster\ShadowUpperAndLowerHats,1
StencilCaster\ShadowLowerSurface=CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowLowerSurface,"StencilShadow_volume"
EntityAlpha StencilCaster\ShadowLowerSurface,0
EntityFX StencilCaster\ShadowLowerSurface,1
HideEntity StencilCaster\ShadowLowerSurface

S_sm=StencilCaster\ShadowVolume
S_sSp=StencilCaster\ShadowUpperAndLowerHats
S_sSh=StencilCaster\shadowBackShapka

EntityFX S_sm,17
S_ss=CreateSurface(S_sm)
S_ss2=CreateSurface(S_sSp);StencilCaster\ShadowUpperAndLowerHats)
;S_ss3=CreateSurface(S_sm)
S_ss4=CreateSurface(S_sSp)
S_ss5=CreateSurface(StencilCaster\ShadowLowerSurface)
For S_jj=1 To CountSurfaces(mesh)
S_s=GetSurface(mesh,S_jj)
For S_ii=0 To CountTriangles(S_s)-1
ten\Ta[S_ct+S_ii]=ReadInt(Stencil_fils)
ten\Tb[S_ct+S_ii]=ReadInt(Stencil_fils)
ten\Tc[S_ct+S_ii]=ReadInt(Stencil_fils)
Next
S_ct=S_ct+CountTriangles(S_s)+1
Next
S_adr=Handle(StencilCaster.ShadowCasters)
StencilCaster\ThisCasterHandle=S_adr
CreateSbox(S_adr,CameraZnear)
UpdateTrisNormals(S_adr)
S_TimeCR=ReadInt(Stencil_fils)
StencilCaster\ProgressTime=S_TimeCR
CloseFile Stencil_fils
SadowMesh=S_sm
EndIf
EndIf

Else;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

SadowMesh=CreateVolume(S_adr)
StencilCaster\ProgressTime=S_TimeCR
CreateSbox(S_adr,CameraZnear)
EntityFX SadowMesh,17

EndIf;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


	StencilCaster\dx#=EntityX(mesh) - 1
	StencilCaster\dy#=EntityY(mesh) - 1
	StencilCaster\dz#=EntityZ(mesh) - 1
	
CasterHandle=Handle(StencilCaster.ShadowCasters)
Return CasterHandle

EndIf
End Function

Function CreateAnimCaster(AnimEntity,Stencil_FileS$=0,S_range=0,on=1,S_MeshAlpha#=1, SoftSelfShadingMODE=0, ZfailOFF=0)

If AnimEntity=0
If Stencil_DebugMode=1 RuntimeError "ERROR: "+"Caster "+(CountCS+1)+". Entity is ''0''!"
Stencil_Error=1
EndIf
If Stencil_Error=0

S_FindALLChildren(AnimEntity)

If VolumeBuildMethod=1 ;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

For S_SEntityChild.S_SEntityChildren=Each S_SEntityChildren
mesh = S_SEntityChild\Entity

S_dfe=1

If mesh
If EntityClass(mesh)="Mesh"

SS_countTris=0
For SS_j=1 To CountSurfaces(mesh)
SS_s=GetSurface(mesh,SS_j)
SS_countTris=SS_countTris+CountTriangles(SS_s)
Next

If SS_countTris>MaxCountTrisToCaster
If Stencil_DebugMode=1 RuntimeError "ERROR: Limit Exceed!, Entity CountTriangles > "+MaxCountTrisToCaster
Else


StencilCaster.ShadowCasters= New ShadowCasters
StencilCaster\entity=mesh

WriteI ( mesh + S_ShadowStructOffset, mesh)

StencilCaster\Alpha#=S_MeshAlpha#
StencilCaster\hiden=StencilEntityHidden(mesh)

StencilReceiver.ShadowReceivers= New ShadowReceivers
StencilReceiver\entity=mesh
StencilReceiver\hiden=StencilEntityHidden(mesh)
StencilReceiver\Shadowed=2
StencilCaster\recAdr=Handle(StencilReceiver.ShadowReceivers)
StencilReceiver\Alpha#=S_MeshAlpha#

S_ii=0
S_jj=0
CountCS=CountCS+1
StencilCaster\N=CountCS
StencilCaster\on=on
StencilCaster\S_range=S_range
StencilCaster\ZfailOFF= ZfailOFF
StencilCaster\SoftSelfShadingMODE=SoftSelfShadingMODE

StencilCaster\on=on
S_adr=Handle(StencilCaster.ShadowCasters)
StencilCaster\ThisCasterHandle=S_adr
SadowMesh=CreateVolume(S_adr)
CreateSbox(S_adr,CameraZnear)
EntityFX SadowMesh,17

EndIf

EndIf
EndIf
Next

Else;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


If Stencil_FileS$=0

;RABOTAYET=RABOTAYET+1

For S_SEntityChild.S_SEntityChildren=Each S_SEntityChildren
mesh = S_SEntityChild\Entity

S_dfe=1

If mesh
If EntityClass(mesh)="Mesh"

SS_countTris=0
For SS_j=1 To CountSurfaces(mesh)
SS_s=GetSurface(mesh,SS_j)
SS_countTris=SS_countTris+CountTriangles(SS_s)
Next

If SS_countTris>MaxCountTrisToCaster
If Stencil_DebugMode=1 RuntimeError "ERROR: Limit Exceed!, Entity CountTriangles > "+MaxCountTrisToCaster
Else


StencilCaster.ShadowCasters= New ShadowCasters
StencilCaster\entity=mesh

WriteI ( mesh + S_ShadowStructOffset, mesh)

StencilCaster\Alpha#=S_MeshAlpha#
StencilCaster\hiden=StencilEntityHidden(mesh)

StencilReceiver.ShadowReceivers= New ShadowReceivers
StencilReceiver\entity=mesh
StencilReceiver\hiden=StencilEntityHidden(mesh)
StencilReceiver\Shadowed=2
StencilCaster\recAdr=Handle(StencilReceiver.ShadowReceivers)
StencilReceiver\Alpha#=S_MeshAlpha#

S_ii=0
S_jj=0
CountCS=CountCS+1
StencilCaster\N=CountCS
StencilCaster\on=on
StencilCaster\S_range=S_range
StencilCaster\ZfailOFF= ZfailOFF
StencilCaster\SoftSelfShadingMODE=SoftSelfShadingMODE

StencilCaster\on=on
S_adr=Handle(StencilCaster.ShadowCasters)
StencilCaster\ThisCasterHandle=S_adr
SadowMesh=CreateVolume(S_adr)
CreateSbox(S_adr,CameraZnear)
EntityFX SadowMesh,17

EndIf

EndIf
EndIf
Next

Else

S_ILen=0
S_LeftOtstup=0
While Not S_ILen=Len(Stencil_FileS$) Or S_simvol$="."
S_ILen=S_ILen+1
S_simvol$=Mid(Stencil_FileS$,S_ILen,1)
If S_simvol$="." Exit
S_MFileName$=S_MFileName$+S_simvol
Wend


Stencil_FileZ$=S_MFileName$+".amst"

Stencil_fils=OpenFile (Stencil_FileZ)

If  Stencil_fils=0
S_OffFile=1
Else
S_OffFile=0
Stencil_fils=ReadFile(Stencil_FileZ$)

S_version$=ReadLine(Stencil_fils)

 If Not S_version=ShadowAnimFileVersion S_OffFile=1
EndIf


If S_OffFile=1; Or S_version$=ShadowAnimFileVersion

;Attribut.lpSecurityAttributes=First lpSecurityAttributes
;If Stencil_fils=0 Stencil_fils=api_CreateFile(Stencil_FileZ, 0, 0, Attribut, 0, 0, 0)
Stencil_fils=WriteFile (Stencil_FileZ)

WriteLine(Stencil_fils,ShadowAnimFileVersion)

For S_SEntityChild.S_SEntityChildren=Each S_SEntityChildren
mesh = S_SEntityChild\Entity

If mesh
If EntityClass(mesh)="Mesh"

SS_countTris=0
For SS_j=1 To CountSurfaces(mesh)

SS_s=GetSurface(mesh,SS_j)
SS_countTris=SS_countTris+CountTriangles(SS_s)
Next

If SS_countTris>MaxCountTrisToCaster
If Stencil_DebugMode=1 RuntimeError "ERROR: Limit Exceed!, Entity CountTriangles > "+MaxCountTrisToCaster
Else

StencilCaster.ShadowCasters= New ShadowCasters
CountCS=CountCS+1
StencilCaster\N=CountCS
StencilCaster\entity=mesh

WriteI ( mesh + S_ShadowStructOffset, mesh)


StencilCaster\Alpha#=S_MeshAlpha#
StencilCaster\hiden=StencilEntityHidden(mesh)

StencilReceiver.ShadowReceivers= New ShadowReceivers
StencilReceiver\entity=mesh
StencilReceiver\hiden=StencilEntityHidden(mesh)
StencilReceiver\Shadowed=2
StencilCaster\recAdr=Handle(StencilReceiver.ShadowReceivers)
StencilReceiver\Alpha#=S_MeshAlpha#

S_adr=Handle(StencilCaster.ShadowCasters)
StencilCaster\ThisCasterHandle=S_adr
StencilCaster\S_range=S_range
StencilCaster\ZfailOFF= ZfailOFF
StencilCaster\SoftSelfShadingMODE=SoftSelfShadingMODE

StencilCaster\on=on
SadowMesh=CreateVolume(S_adr)
CreateSbox(S_adr,CameraZnear)

ten.ShadowVolumes=Object.ShadowVolumes(StencilCaster\adres)
S_ct=0

For S_jj=1 To CountSurfaces(mesh)
S_s=GetSurface(mesh,S_jj)
For S_ii=0 To CountTriangles(S_s)-1
WriteInt(Stencil_fils,ten\Ta[S_ct+S_ii])
WriteInt(Stencil_fils,ten\Tb[S_ct+S_ii])
WriteInt(Stencil_fils,ten\Tc[S_ct+S_ii])
Next
S_ct=S_ct+CountTriangles(S_s)+1
Next

EndIf

EndIf
EndIf
Next

WriteInt(Stencil_fils,S_TimeCR)
CloseFile Stencil_fils
;EndIf

Else
;RABOTAYET=RABOTAYET+1

For S_SEntityChild.S_SEntityChildren=Each S_SEntityChildren
mesh = S_SEntityChild\Entity

If mesh
If EntityClass(mesh)="Mesh"

SS_countTris=0
For SS_j=1 To CountSurfaces(mesh)
SS_s=GetSurface(mesh,SS_j)
SS_countTris=SS_countTris+CountTriangles(SS_s)
Next

If SS_countTris>MaxCountTrisToCaster
If Stencil_DebugMode=1 RuntimeError "ERROR: Limit Exceed!, Entity CountTriangles > "+MaxCountTrisToCaster
Else

StencilCaster.ShadowCasters= New ShadowCasters
StencilCaster\entity=mesh

WriteI ( mesh + S_ShadowStructOffset, mesh)

StencilCaster\Alpha#=S_MeshAlpha#
StencilCaster\hiden=StencilEntityHidden(mesh)

StencilReceiver.ShadowReceivers= New ShadowReceivers
StencilReceiver\entity=mesh
StencilReceiver\hiden=StencilEntityHidden(mesh)
StencilReceiver\Shadowed=2
StencilCaster\recAdr=Handle(StencilReceiver.ShadowReceivers)
StencilReceiver\Alpha#=S_MeshAlpha#

ten.ShadowVolumes = New ShadowVolumes
StencilCaster\adres=Handle(ten.ShadowVolumes )
ten\CounCasters=ten\CounCasters+1
CountCS=CountCS+1
StencilCaster\N=CountCS
StencilCaster\on=on
StencilCaster\ZfailOFF= ZfailOFF
StencilCaster\SoftSelfShadingMODE=SoftSelfShadingMODE

StencilCaster\ShadowVolume=CreateMesh(S_StencilSysPivot)
EntityFX StencilCaster\ShadowVolume,17
NameEntity StencilCaster\ShadowVolume,"StencilShadow_volume"
;EntityAlpha StencilCaster\ShadowVolume,0.0001
StencilCaster\ShadowUpperAndLowerHats=CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowUpperAndLowerHats,"StencilShadow_volume"
EntityAlpha StencilCaster\ShadowUpperAndLowerHats,0;.0001
EntityFX StencilCaster\ShadowUpperAndLowerHats,1

StencilCaster\ShadowLowerSurface=CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowLowerSurface,"StencilShadow_volume"
EntityAlpha StencilCaster\ShadowLowerSurface,0
EntityFX StencilCaster\ShadowLowerSurface,1
HideEntity StencilCaster\ShadowLowerSurface

S_sm=StencilCaster\ShadowVolume
S_sSp=StencilCaster\ShadowUpperAndLowerHats
StencilCaster\S_range=S_range
StencilCaster\on=on
EntityFX S_sm,17
S_ss=CreateSurface(S_sm)
S_ss2=CreateSurface(S_sSp);StencilCaster\ShadowUpperAndLowerHats)
;S_ss3=CreateSurface(S_sm)
S_ss4=CreateSurface(S_sSp)
S_ss5=CreateSurface(StencilCaster\ShadowLowerSurface)
S_ct=0
For S_jj=1 To CountSurfaces(mesh)
S_s=GetSurface(mesh,S_jj)
For S_ii=0 To CountTriangles(S_s)-1
ten\Ta[S_ct+S_ii]=ReadInt(Stencil_fils)
ten\Tb[S_ct+S_ii]=ReadInt(Stencil_fils)
ten\Tc[S_ct+S_ii]=ReadInt(Stencil_fils)
Next
S_ct=S_ct+CountTriangles(S_s)+1
Next
S_adr=Handle(StencilCaster.ShadowCasters)
StencilCaster\ThisCasterHandle=S_adr
UpdateTrisNormals(S_adr)
CreateSbox(S_adr,CameraZnear)
	StencilCaster\dx#=-1
	StencilCaster\dy#=-1
	StencilCaster\dz#=-1

EndIf

EndIf
EndIf
Next

S_TimeCR=ReadInt(Stencil_fils)
CloseFile Stencil_fils
SadowMesh=S_sm
EndIf


EndIf;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

EndIf
;EndIf

Return SadowMesh

EndIf
End Function

Function CopyCaster(mesh,Entity,S_range=-1,on=-1,Alpha#=-1,ZfailOFF=-1)
For StencilCaster.ShadowCasters= Each ShadowCasters
;If StencilCaster\entity=entity2 S_adr=StencilCaster\adres
If StencilCaster\entity=entity
S_adr=StencilCaster\adres
S_Sbbox = StencilCaster\bbox
S_EntityRadius#=StencilCaster\radius#

StencilReceiver.ShadowReceivers=Object.ShadowReceivers( StencilCaster\recAdr )
If Alpha#=-1 Alpha#=StencilReceiver\Alpha

If S_range=-1 S_range=StencilCaster\S_range

If on=-1 on=StencilCaster\on
If SoftSelfShadingMODE=-1 SoftSelfShadingMODE=StencilCaster\SoftSelfShadingMODE
If ZfailOFF=-1  ZfailOFF=StencilCaster\ZfailOFF


StencilCaster.ShadowCasters= New ShadowCasters
StencilCaster\adres=S_adr

CountCS = CountCS+1
StencilCaster\N=CountCS

ten.ShadowVolumes=Object.ShadowVolumes(StencilCaster\adres)
ten\CounCasters=ten\CounCasters+1

StencilCaster\entity=mesh
StencilCaster\hiden=StencilEntityHidden(mesh)

WriteI ( mesh + S_ShadowStructOffset, mesh)

StencilReceiver.ShadowReceivers= New ShadowReceivers
StencilReceiver\entity=mesh
StencilReceiver\hiden=StencilEntityHidden(mesh)
StencilReceiver\Shadowed=2
StencilReceiver\Alpha= Alpha

StencilCaster\recAdr=Handle(StencilReceiver.ShadowReceivers)

StencilCaster\radius#=S_EntityRadius#


StencilCaster\copy=1
StencilCaster\S_range=S_range

StencilCaster\on= on
StencilCaster\Alpha= Alpha
StencilCaster\SoftSelfShadingMODE=SoftSelfShadingMODE
StencilCaster\SoftSelfShadingMODE=SoftSelfShadingMODE


If S_Sbbox
StencilCaster\bbox = 1
;StencilCaster\bbox = CreateBox4()
; EntityColor StencilCaster\bbox ,0,0,255
; EntityAlpha StencilCaster\bbox ,.3
; EntityFX StencilCaster\bbox ,17
; CreateReceiver StencilCaster\bbox,0
EndIf

StencilCaster\ShadowVolume= CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowVolume,"StencilShadow_volume"
StencilCaster\ShadowUpperAndLowerHats= CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowUpperAndLowerHats,"StencilShadow_volume"
EntityFX StencilCaster\ShadowUpperAndLowerHats,1
EntityAlpha StencilCaster\ShadowUpperAndLowerHats,0.0

StencilCaster\ShadowLowerSurface=CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowLowerSurface,"StencilShadow_volume"
EntityAlpha StencilCaster\ShadowLowerSurface,0
EntityFX StencilCaster\ShadowLowerSurface,1
HideEntity StencilCaster\ShadowLowerSurface

EntityFX StencilCaster\ShadowVolume,17
;EntityAlpha StencilCaster\ShadowVolume,0.0001
S_ss=CreateSurface(StencilCaster\ShadowVolume)
S_ss2=CreateSurface(StencilCaster\ShadowUpperAndLowerHats)
;S_ss3=CreateSurface(StencilCaster\ShadowVolume)
S_ss4=CreateSurface(StencilCaster\ShadowUpperAndLowerHats)
S_ss5=CreateSurface(StencilCaster\ShadowLowerSurface)
Return StencilCaster\ShadowVolume
Exit
EndIf
Next
End Function 

Function ChangeCaster(mesh,on=-1,S_range=-1,Alpha#=-1, SoftSelfShadingMODE=-1,ZfailOFF=-1)
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=mesh
If S_range=-1 S_range=StencilCaster\S_range

If on=-1  on=StencilCaster\on
If ZfailOFF=-1  ZfailOFF=StencilCaster\ZfailOFF
If SoftSelfShadingMODE=-1 SoftSelfShadingMODE=StencilCaster\SoftSelfShadingMODE
StencilCaster\S_range=S_range
StencilReceiver.ShadowReceivers=Object.ShadowReceivers( StencilCaster\recAdr )
If Alpha#=-1 Alpha#=StencilReceiver\Alpha
StencilReceiver\Alpha= Alpha

StencilCaster\on= on
StencilCaster\ZfailOFF= ZfailOFF
StencilCaster\SoftSelfShadingMODE=SoftSelfShadingMODE
StencilCaster\Alpha= Alpha
StencilReceiver.ShadowReceivers=Object.ShadowReceivers( StencilCaster\recAdr )
StencilReceiver\Alpha= Alpha
EndIf
Next
End Function 

Function SetPersonalLight ( entity, lightPivot=0, LType=2, LRange#=100)

For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=entity
StencilCaster\PersonalLType=LType
StencilCaster\PersonalLight=lightPivot
StencilCaster\PersonalLRange#=LRange
EndIf
Next

End Function


; Changing caster's parameters :

;++++++++++++++++++++++++++++++++++++++++[ Commans for Caster-Handle ]++++++++++++++++++++++++++++++++++++++++
;=====================================================================================================

Function CasterSoftSelfShading (CasterH%, Mode% )
StencilCaster.ShadowCasters=Object.ShadowCasters( CasterH )
StencilCaster\SoftSelfShadingMODE=Mode
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;0 - set from global SoftSelfShading mode (default)
;1 - always enabling
;2 - always disabling
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function CasterZfail ( CasterH%, Mode% )
StencilCaster.ShadowCasters=Object.ShadowCasters( CasterH )
StencilCaster\ZfailOFF= Mode 
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;0 - is defined automatically (default)
;1 - always disabling
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function CasterShadowRange ( CasterH%, Range#)
StencilCaster.ShadowCasters=Object.ShadowCasters( CasterH )
StencilCaster\S_range=range
;For StencilCaster.ShadowCasters= Each ShadowCasters
;If StencilCaster\entity=mesh StencilCaster\S_range=range
;Next
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;range - length shadow (default range=100)
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function CasterMode ( CasterH%, Mode%)
StencilCaster.ShadowCasters=Object.ShadowCasters( CasterH )
StencilCaster\on= Mode
;For StencilCaster.ShadowCasters= Each ShadowCasters
;If StencilCaster\entity=mesh StencilCaster\on= Mode
;Next
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;0 - enable shadow (default)
;1 - disable shadow
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;=====================================================================================================


;++++++++++++++++++++++++++++++++++++++++[ Commans for Entity-Handle ]++++++++++++++++++++++++++++++++++++++++
;=====================================================================================================
Function EntitySoftSelfShading ( Entity, Mode% )
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=Entity StencilCaster\SoftSelfShadingMODE=Mode
Next
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;0 - set from global SoftSelfShading mode (default)
;1 - always enabling
;2 - always disabling
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function EntityZfail ( Entity%, Mode% )
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=Entity StencilCaster\ZfailOFF= Mode 
Next
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;0 - is defined automatically (default)
;1 - always disabling
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function EntityShadowRange ( Entity%, Range#)
For StencilCaster.ShadowCasters= Each ShadowCasters
 If StencilCaster\entity=Entity StencilCaster\S_range=range
Next
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;range - length shadow (default range=100)
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function EntityMode ( Entity%, Mode%)
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=Entity StencilCaster\on= Mode
Next
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;0 - enable shadow (default)
;1 - disable shadow
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


Function EntityCullingMode ( Entity%, culling%)
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=Entity StencilCaster\culling=Not culling
Next
End Function
;
;=====================================================================================================




;Don't use this four functions:  :-)
;=====================================================================================================
Function EntityShadowNoUpdate ( Entity%, Mode%)
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=Entity StencilCaster\NoUpdate= Mode
Next
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;0 - enable updating shadow volume(default)
;1 - disable updating shadow volume
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Function EntityUserVolume ( Entity%, Volume%)
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=Entity
StencilCaster\ShadowVolume= Volume
StencilCaster\NoUpdate= 1
EndIf

Next
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Function CreateUserShadow(entity,alpha#=0,Ztech=0)
UserShadowV.UserShadowVolumes= New UserShadowVolumes
UserShadowV\entity=entity
UserShadowV\Alpha#=alpha#
UserShadowV\Ztech=Ztech
Return Handle(UserShadowV.UserShadowVolumes)
End Function
;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Function ChangeUserShadow(UserShadow,alpha#=0,Ztech=0)
UserShadowV.UserShadowVolumes= Object.UserShadowVolumes(UserShadow)
UserShadowV\entity=entity
UserShadowV\Alpha#=alpha#
UserShadowV\Ztech=Ztech
End Function
;=====================================================================================================




Function UpdateCasterGeom(mesh)
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=mesh
StencilCaster\GeomUpdate=1
CreateSbox(StencilCaster\ThisCasterHandle,CameraZnear)
EndIf
Next
End Function

Function UpdateCasterNormals(mesh)
For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\entity=mesh StencilCaster\GeomUpdate=1
Next
End Function



Function UpdateShadows(camera,actiws=1)

Local culling, Orientation


InitShadowLib()

TimeShadow = MilliSecs ( )

Stencil_Error=0
If StencilShadowLight=0
If Stencil_DebugMode=1 RuntimeError "ERROR: Light is not seted!"
Stencil_Error=1
EndIf
If Camera=0
If Stencil_DebugMode=1 RuntimeError "ERROR: Camera is not exist!"
Stencil_Error=1
Else
If Not EntityClass(Camera)="Camera"
If Stencil_DebugMode=1 RuntimeError "ERROR: Entity is not Camera!"
Stencil_Error=1
EndIf
EndIf
If Stencil_Error=0

S_cam=camera
CameraZnear# = RetF ( camera + 640)

If ZfailMode=1 GlStencil_destCL#=Sqr((EntityX(StencilShadowLight,1)-EntityX(S_cam,1)) * (EntityX(StencilShadowLight,1)-EntityX(S_cam,1)) + (EntityY(StencilShadowLight,1)-EntityY(S_cam,1)) * (EntityY(StencilShadowLight,1)-EntityY(S_cam,1)) + (EntityZ(StencilShadowLight,1)-EntityZ(S_cam,1)) * (EntityZ(StencilShadowLight,1)-EntityZ(S_cam,1)) )

S_range#=0


If Stencil_LightType=1
TFormNormal 0,0,1,StencilShadowLight,0
Stencil_LNx#=-TFormedX()
Stencil_LNy#=-TFormedY()
Stencil_LNz#=-TFormedZ()
nlx1#=Stencil_LNx#
nly1#=Stencil_LNy#
nlz1#=Stencil_LNz#
EndIf

For StencilCaster.ShadowCasters= Each ShadowCasters

StencilCaster\DrawOFF=0
culling = StencilCaster\culling

If StencilCaster\PersonalLight
Ltype=StencilCaster\PersonalLType
Stencil_light=StencilCaster\PersonalLight
lightp=StencilCaster\PersonalLight
If Ltype=1
S_Light_range#=StencilCaster\PersonalLRange
TFormNormal 0,0,1,Stencil_light,0
nlx1#=-TFormedX()
nly1#=-TFormedY()
nlz1#=-TFormedZ()
Else
S_Light_range#=StencilCaster\PersonalLRange
EndIf
If ZfailMode=1 S_destCL#=Sqr((EntityX(Stencil_light,1)-EntityX(S_cam,1)) * (EntityX(Stencil_light,1)-EntityX(S_cam,1)) + (EntityY(Stencil_light,1)-EntityY(S_cam,1)) * (EntityY(Stencil_light,1)-EntityY(S_cam,1)) + (EntityZ(Stencil_light,1)-EntityZ(S_cam,1)) * (EntityZ(Stencil_light,1)-EntityZ(S_cam,1)) )

Else
Ltype=Stencil_LightType
Stencil_light=StencilShadowLight
lightp=StencilShadowLight
S_Light_range#=Stencil_LightRange
nlx1#=Stencil_LNx#
nly1#=Stencil_LNy#
nlz1#=Stencil_LNz#
S_destCL#=GlStencil_destCL#
EndIf

;if ten\mesh=S_adr
mesh=StencilCaster\entity
S_sm=StencilCaster\ShadowVolume
S_sSp=StencilCaster\ShadowUpperAndLowerHats
S_sSh=StencilCaster\shadowBackShapka
S_dl#=Sqr((EntityX(Stencil_light,1)-EntityX(mesh,1)) * (EntityX(Stencil_light,1)-EntityX(mesh,1)) + (EntityY(Stencil_light,1)-EntityY(mesh,1)) * (EntityY(Stencil_light,1)-EntityY(mesh,1)) + (EntityZ(Stencil_light,1)-EntityZ(mesh,1)) * (EntityZ(Stencil_light,1)-EntityZ(mesh,1)))
StencilCaster\Dest#=S_dl#


If  StencilCaster\on=actiws And StencilCaster\hiden=0; And S_DestMLR#<=Stencil_LightRange*10

ten.ShadowVolumes=Object.ShadowVolumes(StencilCaster\adres)
mesh=StencilCaster\entity
S_sm=StencilCaster\ShadowVolume
S_sSp=StencilCaster\ShadowUpperAndLowerHats
S_range#=StencilCaster\S_range#
;EntityColor S_sm,255,0,0
offt=StencilCaster\offt
;zfail=StencilCaster\zfail
S_GeomUpdate=StencilCaster\GeomUpdate


If ltype=2 Or ltype=3
S_Mnx#=EntityPitch(mesh,1)
S_Mny#=EntityYaw(mesh,1)
S_Mnz#=EntityRoll(mesh,1)
Else
S_Mnx#=EntityPitch(mesh,1) - EntityPitch(Stencil_light,1)
S_Mny#=EntityYaw(mesh,1) - EntityYaw(Stencil_light,1)
S_Mnz#=EntityRoll(mesh,1) - EntityRoll(Stencil_light,1)
EndIf

If ltype=2 Or ltype=3
S_dmlx#=EntityX(mesh,1)-EntityX(Stencil_light,1)
S_dmly#=EntityY(mesh,1)-EntityY(Stencil_light,1)
S_dmlz#=EntityZ(mesh,1)-EntityZ(Stencil_light,1)
Else
S_dmlx#=EntityX(mesh,1)
S_dmly#=EntityY(mesh,1)
S_dmlz#=EntityZ(mesh,1)
EndIf

S_scalex#=aEntityScalex#(mesh)
S_scaley#=aEntityScaley#(mesh)
S_scalez#=aEntityScalez#(mesh)

If S_scalex# >= S_scaley#
S_scale# = S_scalex#
Else
If S_scaley# >= S_scalez#
S_scale# = S_scaley#
Else
S_scale# = S_scalez#
EndIf
EndIf

If S_scalex# <= S_scaley#
S_scalem# = S_scalex#
Else
If S_scaley# <= S_scalez#
S_scalem# = S_scaley#
Else
S_scalem# = S_scalez#
EndIf
EndIf

;S_scaleSr#= (S_scalex# + S_scaley# + S_scalez#) / 3.0
S_range#=S_range#/S_scalem#
S_MeshRadiusReal#= StencilCaster\radius# * S_scale#
S_MeshRadius#=S_MeshRadiusReal# + CameraZnear#*2.0
InZone=1

Stencil_LRangeExt#= S_Light_range * 5.0
;S_RLDgip#=Sqr( (S_MeshRadius#)*(S_MeshRadius#) + S_dl*S_dl)
;S_RLDn#=(S_RLDgip#*2.0)/S_MeshRadius#
If Not Ltype=1
If S_range=0
If S_dl#<S_MeshRadiusReal
S_range#=(Stencil_LRangeExt#+S_MeshRadiusReal#) ;* S_RLDn#; - S_MeshRadius#-S_dl#
Else
 If (S_dl)>Stencil_LRangeExt#
 InZone=0
 Else
S_range=(Stencil_LRangeExt# + S_MeshRadius#-S_dl#) ;* S_RLDn#;-S_MeshRadius#
 EndIf

EndIf
EndIf
Else

If S_range=0  S_range = DefaultSRange#/S_scalem
EndIf
 StencilCaster\InZone=InZone
 

; Shadow Frustum Culling -------------------------------------------------------------------------------------------------------------------------------------------------
S_Sbbox= StencilCaster\bbox
S_SbboxPass=1

If S_Sbbox=1 And ShadowFrustumCulling=1
S_rangeFBBox# = S_range*S_scale
S_RadiusFBBox# = (StencilCaster\Radius ) *S_scale
If Ltype=1
S_ScaleBox# = S_RadiusFBBox
AlignToVector FirstStencilBBox, nlx1#, nly1#, nlz1#,3
;AlignToVector S_Sbbox, nlx1#, nly1#, nlz1#,3
Else
S_ScaleBox# = S_RadiusFBBox  * (S_rangeFBBox+StencilCaster\Dest) / StencilCaster\Dest
PointEntity FirstStencilBBox,lightp
;PointEntity S_Sbbox,lightp
EndIf

PositionEntity FirstStencilBBox,EntityX( mesh,1 ) ,EntityY( mesh,1 ), EntityZ( mesh,1 )
MoveEntity FirstStencilBBox,0,0,S_RadiusFBBox - (S_rangeFBBox )
ScaleEntity FirstStencilBBox,S_ScaleBox,S_ScaleBox, S_rangeFBBox

;PositionEntity S_Sbbox,EntityX( mesh,1 ) ,EntityY( mesh,1 ), EntityZ( mesh,1 ),1
;MoveEntity S_Sbbox,0,0,S_RadiusFBBox - (S_rangeFBBox )
;ScaleEntity S_Sbbox,S_ScaleBox,S_ScaleBox, S_rangeFBBox,1

If Not EntityInView ( FirstStencilBBox,S_cam )
S_SbboxPass=0
StencilCaster\DrawOFF=1
EndIf

EndIf
;  ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

If S_SbboxPass=1

 BBCopyEntityMatrix ( mesh, S_sm, 1 ) ; ********************************************************************************************************
 BBCopyEntityMatrix ( mesh, S_sSp, 1 ) ; *******************************************************************************************************
If S_sSh  BBCopyEntityMatrix ( mesh, S_sSh, 1 ) ; ********************************************************************************************

If StencilEntityHidden(mesh)=1 Or InZone=0
HideEntity S_sm
Else
ShowEntity S_sm

If StencilCaster\ZfailOFF=1 StencilCaster\Zfail=0

EntityColor S_sm,255,0,0

If ZfailMode=1 And StencilCaster\ZfailOFF=0
StencilCaster\Zfail=0
zfail=0

S_destCM#=Sqr((EntityX(StencilCaster\entity,1)-EntityX(S_cam,1)) * (EntityX(StencilCaster\entity,1)-EntityX(S_cam,1)) + (EntityY(StencilCaster\entity,1)-EntityY(S_cam,1)) * (EntityY(StencilCaster\entity,1)-EntityY(S_cam,1)) + (EntityZ(StencilCaster\entity,1)-EntityZ(S_cam,1)) * (EntityZ(StencilCaster\entity,1)-EntityZ(S_cam,1)) )

If S_destCM#<=S_MeshRadius#
StencilCaster\Zfail=1
zfail=1
;StencilCaster\SgoMode=1
Else

If Ltype=2
;-----------------------------------------------------------------------------------------
If (S_MeshRadius# - CameraZnear#*2) >= S_dl#
StencilCaster\Zfail=1
zfail=1
;StencilCaster\SgoMode=1
Else

S_Nmlx#=(EntityX#(Stencil_light,1) - EntityX#(StencilCaster\entity,1)) / S_dl#
S_Nmly#=(EntityY#(Stencil_light,1) - EntityY#(StencilCaster\entity,1)) / S_dl#
S_Nmlz#=(EntityZ#(Stencil_light,1) - EntityZ#(StencilCaster\entity,1)) / S_dl#

S_Ncmx#=(EntityX#(S_cam,1) - EntityX#(StencilCaster\entity,1)) / S_destCM#
S_Ncmy#=(EntityY#(S_cam,1) - EntityY#(StencilCaster\entity,1)) / S_destCM#
S_Ncmz#=(EntityZ#(S_cam,1) - EntityZ#(StencilCaster\entity,1)) / S_destCM#

If (S_Nmlx# * S_Ncmx# + S_Nmly# * S_Ncmy# + S_Nmlz# * S_Ncmz#)<=0

S_Nclx#=(EntityX#(Stencil_light,1) - EntityX#(S_cam,1)) / S_destCL#
S_Ncly#=(EntityY#(Stencil_light,1) - EntityY#(S_cam,1)) / S_destCL#
S_Nclz#=(EntityZ#(Stencil_light,1) - EntityZ#(S_cam,1)) / S_destCL#

If (S_MeshRadius# / S_dl#) > Sqr( (S_Nclx#-S_Nmlx#)*(S_Nclx#-S_Nmlx#) + (S_Ncly#-S_Nmly#)*(S_Ncly#-S_Nmly#) + (S_Nclz#-S_Nmlz#)*(S_Nclz#-S_Nmlz#) )
StencilCaster\Zfail=1
zfail=1
;StencilCaster\SgoMode=1
EndIf
EndIf

EndIf
;-----------------------------------------------------------------------------------------
Else
;-----------------------------------------------------------------------------------------

S_Ncmx#=(EntityX#(S_cam,1) - EntityX#(StencilCaster\entity,1)) / S_destCM#
S_Ncmy#=(EntityY#(S_cam,1) - EntityY#(StencilCaster\entity,1)) / S_destCM#
S_Ncmz#=(EntityZ#(S_cam,1) - EntityZ#(StencilCaster\entity,1)) / S_destCM#

;(-Stencil_LNx# * S_Ncmx# - Stencil_LNx# * S_Ncmy# - Stencil_LNx# * S_Ncmz#)>=0

S_Nclx#=-nlx1#
S_Ncly#=-nly1#
S_Nclz#=-nlz1#

If (S_MeshRadius# / S_destCM#) > Sqr( (S_Nclx#-S_Ncmx#)*(S_Nclx#-S_Ncmx#) + (S_Ncly#-S_Ncmy#)*(S_Ncly#-S_Ncmy#) + (S_Nclz#-S_Ncmz#)*(S_Nclz#-S_Ncmz#) )
StencilCaster\Zfail=1
zfail=1
;StencilCaster\SgoMode=1
EndIf

;-----------------------------------------------------------------------------------------
EndIf

EndIf
EndIf


;StencilCaster\on=0
;If S_dl>Stencil_LightRange*3 StencilCaster\on=0

S_NoUpdating=0
If StencilCaster\NoUpdate=1
S_NoUpdating=1
Else
If (S_dmlx=StencilCaster\dx) And (S_dmly=StencilCaster\dy) And (S_dmlz=StencilCaster\dz) And S_Mnx=StencilCaster\deltap And S_Mny=StencilCaster\deltay And S_Mnz=StencilCaster\deltar   And (S_scalex#=StencilCaster\scalex) And (S_scaley=StencilCaster\scaley) And (S_scalez=StencilCaster\scalez) And S_GeomUpdate=0 
S_NoUpdating=1
StencilCaster\Active=0
Else
StencilCaster\Active=1
EndIf
EndIf

If S_NoUpdating=1

If zfail=1 And StencilCaster\BildShapka=0
StencilCaster\BildShapka=1

S_ss2=GetSurface(S_sSp,1)
S_ss4=GetSurface(S_sSp,2)

S_ss2CountV=CountVertices(S_ss2)
S_ss4CountV=CountVertices(S_ss4)
S_ss4CountTris4=S_ss4CountV/3
ClearSurface S_ss2,0,1
ClearSurface S_ss4,0,1

nlx1#=StencilCaster\Nx#
nly1#=StencilCaster\Ny#
nlz1#=StencilCaster\Nz#
StencilS_Lx#=StencilCaster\Lx#
StencilS_Ly#=StencilCaster\Ly#
StencilS_Lz#=StencilCaster\Lz#

destLV#=Sqr(StencilS_Lx#*StencilS_Lx# + StencilS_Ly#*StencilS_Ly# + StencilS_Lz#*StencilS_Lz# )

S_VertCount=0
VertCount2=0
VertCount3=0
VertCount4=0
VertCount5=0
S_CountTris4=0
StencilCaster\shadowTris=0
StencilCaster\shadowVerts=0

S_q=0
S_counrSm=CountSurfaces(mesh)
For S_j=1 To S_counrSm
S_s=GetSurface(mesh,S_j)
S_countTris=CountTriangles(S_s)-1
For S_i=0 To S_countTris
;--------------------------------------------------------------------------------------------------
				S_V0 = TriangleVertex(S_s, S_i, 0)
				S_V1 = TriangleVertex(S_s, S_i, 1)
				S_V2 = TriangleVertex(S_s, S_i, 2)

				StencilS_Ax# = VertexX#(S_s, S_V0);
				StencilS_Ay# = VertexY#(S_s, S_V0);
				StencilS_Az# = VertexZ#(S_s, S_V0);

				StencilS_Bx# = VertexX#(S_s, S_V1);
				StencilS_By# = VertexY#(S_s, S_V1);
				StencilS_Bz# = VertexZ#(S_s, S_V1);

				StencilS_Cx# = VertexX#(S_s, S_V2);
				StencilS_Cy# = VertexY#(S_s, S_V2);
				StencilS_Cz# = VertexZ#(S_s, S_V2);

				NTx#= ten\Tnx#[S_q+S_i]
				NTy#= ten\Tny#[S_q+S_i]
				NTz#= ten\Tnz#[S_q+S_i]

If Not ltype=1
Tx#=(StencilS_Ax#+StencilS_Bx#+StencilS_Cx#)* 0.333333333333
Ty#=(StencilS_Ay#+StencilS_By#+StencilS_Cy#)* 0.333333333333
Tz#=(StencilS_Az#+StencilS_Bz#+StencilS_Cz#)* 0.333333333333
;S_dlt#=Sqr((Tx-StencilS_Lx)*(Tx-StencilS_Lx) + (Ty-StencilS_Ly)*(Ty-StencilS_Ly) + (Tz-StencilS_Lz)*(Tz-StencilS_Lz))
nlx1#=(StencilS_Lx#-Tx#);/S_dlt#
nly1#=(StencilS_Ly#-Ty#);/S_dlt#
nlz1#=(StencilS_Lz#-Tz#);/S_dlt#
EndIf
If (NTx*NLx1 + NTy*NLy1 + NTz*NLz1)>0
;..............................................................................................................................................................................................

If Not Ltype=1 And DirectionalLightBackTrisOFF=1

If ltype=1

S_x1#= S_range *-NLx1 + StencilS_Ax
S_y1#= S_range *-NLy1 + StencilS_Ay
S_z1#= S_range *-NLz1 + StencilS_Az

S_x2#= S_range *-NLx1 + StencilS_Bx
S_y2#= S_range *-NLy1 + StencilS_By
S_z2#= S_range *-NLz1 + StencilS_Bz

S_x3#= S_range *-NLx1 + StencilS_Cx
S_y3#= S_range *-NLy1 + StencilS_Cy
S_z3#= S_range *-NLz1 + StencilS_Cz
Else

NewVector ( StencilS_Ax-StencilS_Lx, StencilS_Ay-StencilS_Ly, StencilS_Az-StencilS_Lz, S_range)
S_x1#= GetNormX#()+StencilS_Ax
S_y1#= GetNormY#()+StencilS_Ay
S_z1#= GetNormZ#()+StencilS_Az

NewVector ( StencilS_Bx-StencilS_Lx, StencilS_By-StencilS_Ly, StencilS_Bz-StencilS_Lz, S_range)
S_x2#= GetNormX#()+StencilS_Bx
S_y2#= GetNormY#()+StencilS_By
S_z2#= GetNormZ#()+StencilS_Bz

NewVector ( StencilS_Cx-StencilS_Lx, StencilS_Cy-StencilS_Ly, StencilS_Cz-StencilS_Lz, S_range)
S_x3#= GetNormX#()+StencilS_Cx
S_y3#= GetNormY#()+StencilS_Cy
S_z3#= GetNormZ#()+StencilS_Cz

EndIf
;VertCount4=VertCount4+3

 If S_CountTris4>=S_ss4CountTris4
AddVertex(S_ss4,S_x1,S_y1,S_z1)
AddVertex(S_ss4,S_x2,S_y2,S_z2)
AddVertex(S_ss4,S_x3,S_y3,S_z3)

AddVertex(S_ss2,StencilS_Ax,StencilS_Ay,StencilS_Az)
AddVertex(S_ss2,StencilS_Bx,StencilS_By,StencilS_Bz)
AddVertex(S_ss2,StencilS_Cx,StencilS_Cy,StencilS_Cz)
;EndIf
Else

AVertexCoords S_ss4,VertCount4,S_x1,S_y1,S_z1
AVertexCoords S_ss4,VertCount4+1,S_x2,S_y2,S_z2
AVertexCoords S_ss4,VertCount4+2,S_x3,S_y3,S_z3

AVertexCoords(S_ss2,VertCount2,StencilS_Ax,StencilS_Ay,StencilS_Az)
AVertexCoords(S_ss2,VertCount2+1,StencilS_Bx,StencilS_By,StencilS_Bz)
AVertexCoords(S_ss2,VertCount2+2,StencilS_Cx,StencilS_Cy,StencilS_Cz)

EndIf
VertCount4=VertCount4+3
VertCount2=VertCount2+3

AddTriangle(S_ss4,VertCount4-1,VertCount4-2,VertCount4-3)
AddTriangle(S_ss2,VertCount2-3,VertCount2-2,VertCount2-1)

S_CountTris4=S_CountTris4+1

EndIf
;..............................................................................................................................................................................................

EndIf

Next
S_q=S_q+ CountTriangles(S_s)+1
Next

EndIf

Else

;If S_SbboxPass


If zfail=1
StencilCaster\BildShapka=1
Else
StencilCaster\BildShapka=0
EndIf

If   StencilCaster\SoftSelfShadingMODE=1
S_SoftSelfShadingPass=1
Else
If SoftSelfShading=1 And StencilCaster\SoftSelfShadingMODE=0
S_SoftSelfShadingPass=1
Else
S_SoftSelfShadingPass=0
EndIf
EndIf

S_ss=GetSurface(S_sm,1)

S_ss5=GetSurface(StencilCaster\ShadowLowerSurface,1)

S_ss2=GetSurface(S_sSp,1)
S_ss4=GetSurface(S_sSp,2)

S_ss2CountV=CountVertices(S_ss2)
S_ss4CountV=CountVertices(S_ss4)
S_ss4CountTris4=S_ss4CountV/3
ClearSurface S_ss2,0,1
ClearSurface S_ss4,0,1

S_ssCountV=CountVertices(S_ss)
;S_ss3CountV=CountVertices(S_ss3)
S_ss5CountV=CountVertices(S_ss5)
ClearSurface S_ss,0,1
;ClearSurface S_ss3,0,1
ClearSurface S_ss5,0,1
VertCount5=0
light=CreatePivot(lightp)

If Ltype=2
TFormPoint 0,0,0,lightp,mesh
StencilS_Lx#=TFormedX()
StencilS_Ly#=TFormedY()
StencilS_Lz#=TFormedZ()

Else
;S_range=DefaultSRange
TFormVector 0,0,1,lightp,mesh
nlx1#=-TFormedX()
nly1#=-TFormedY()
nlz1#=-TFormedZ()
S_dnl1#=Sqr( nlx1#*nlx1# + nly1#*nly1# + nlz1#*nlz1#  )
nlx1#=nlx1# / S_dnl1#
nly1#=nly1# / S_dnl1#
nlz1#=nlz1# / S_dnl1#

If S_SoftSelfShadingPass Or zfail=1
S_GetVertexPosD=1
Else
S_GetVertexPosD=0
EndIf

EndIf

StencilCaster\Nx#=nlx1#
StencilCaster\Ny#=nly1#
StencilCaster\Nz#=nlz1#

StencilS_X=0
StencilS_Y=0
StencilS_Z=0


StencilCaster\Lx#=StencilS_Lx#
StencilCaster\Ly#=StencilS_Ly#
StencilCaster\Lz#=StencilS_Lz#

destLV#=Sqr(StencilS_Lx#*StencilS_Lx# + StencilS_Ly#*StencilS_Ly# + StencilS_Lz#*StencilS_Lz# )

S_VertCount=0
VertCount2=0
VertCount3=0
VertCount4=0
VertCount5=0
S_CountTris4=0
StencilCaster\shadowTris=0
StencilCaster\shadowVerts=0

S_q=0
S_counrSm=CountSurfaces(mesh)
For S_j=1 To S_counrSm
S_s=GetSurface(mesh,S_j)
S_countTris=CountTriangles(S_s)-1
For S_i=0 To S_countTris
;--------------------------------------------------------------------------------------------------

If S_GeomUpdate=0
				NTx#= ten\Tnx#[S_q+S_i]
				NTy#= ten\Tny#[S_q+S_i]
				NTz#= ten\Tnz#[S_q+S_i]
Else

				S_V0 = TriangleVertex(S_s, S_i, 0)
				S_V1 = TriangleVertex(S_s, S_i, 1)
				S_V2 = TriangleVertex(S_s, S_i, 2)

				StencilS_Ax# = VertexX#(S_s, S_V0);*aEntityScaleX#(mesh)
				StencilS_Ay# = VertexY#(S_s, S_V0);*aEntityScaley#(mesh)
				StencilS_Az# = VertexZ#(S_s, S_V0);*aEntityScalez#(mesh)

				StencilS_Bx# = VertexX#(S_s, S_V1);*aEntityScaleX#(mesh)
				StencilS_By# = VertexY#(S_s, S_V1);*aEntityScaley#(mesh)
				StencilS_Bz# = VertexZ#(S_s, S_V1);*aEntityScalez#(mesh)

				StencilS_Cx# = VertexX#(S_s, S_V2);*aEntityScaleX#(mesh)
				StencilS_Cy# = VertexY#(S_s, S_V2);*aEntityScaley#(mesh)
				StencilS_Cz# = VertexZ#(S_s, S_V2);*aEntityScalez#(mesh)
				
				C_Px# = StencilS_Ax#-StencilS_Bx#
				C_Py# = StencilS_Ay#-StencilS_By#
				C_Pz# = StencilS_Az#-StencilS_Bz#

				C_Qx# = StencilS_Bx#-StencilS_Cx#
				C_Qy# = StencilS_By#-StencilS_Cy#
				C_Qz# = StencilS_Bz#-StencilS_Cz#

				NTx# = C_Py#*C_Qz# - C_Pz#*C_Qy#
				NTy# = C_Pz#*C_Qx# - C_Px#*C_Qz#
				NTz# = C_Px#*C_Qy# - C_Py#*C_Qx#
EndIf

If Not ltype=1
				S_V0 = TriangleVertex(S_s, S_i, 0)
				S_V1 = TriangleVertex(S_s, S_i, 1)
				S_V2 = TriangleVertex(S_s, S_i, 2)

				StencilS_Ax# = VertexX#(S_s, S_V0);*aEntityScaleX#(mesh)
				StencilS_Ay# = VertexY#(S_s, S_V0);*aEntityScaley#(mesh)
				StencilS_Az# = VertexZ#(S_s, S_V0);*aEntityScalez#(mesh)

				StencilS_Bx# = VertexX#(S_s, S_V1);*aEntityScaleX#(mesh)
				StencilS_By# = VertexY#(S_s, S_V1);*aEntityScaley#(mesh)
				StencilS_Bz# = VertexZ#(S_s, S_V1);*aEntityScalez#(mesh)

				StencilS_Cx# = VertexX#(S_s, S_V2);*aEntityScaleX#(mesh)
				StencilS_Cy# = VertexY#(S_s, S_V2);*aEntityScaley#(mesh)
				StencilS_Cz# = VertexZ#(S_s, S_V2);*aEntityScalez#(mesh)
				
Tx#=(StencilS_Ax#+StencilS_Bx#+StencilS_Cx#)* 0.333333333333
Ty#=(StencilS_Ay#+StencilS_By#+StencilS_Cy#)* 0.333333333333
Tz#=(StencilS_Az#+StencilS_Bz#+StencilS_Cz#)* 0.333333333333
;S_dlt#=Sqr((Tx-StencilS_Lx)*(Tx-StencilS_Lx) + (Ty-StencilS_Ly)*(Ty-StencilS_Ly) + (Tz-StencilS_Lz)*(Tz-StencilS_Lz))
nlx1#=(StencilS_Lx#-Tx#);/S_dlt#
nly1#=(StencilS_Ly#-Ty#);/S_dlt#
nlz1#=(StencilS_Lz#-Tz#);/S_dlt#
;Normalise2 ( Tx#-StencilS_Lx#, Ty#-StencilS_Ly#, Tz#-StencilS_Lz#)
;nlx1#= -GetNormX#()
;nly1#= -GetNormY#()
;nlz1#= -GetNormZ#()
;Else

EndIf

If (NTx*NLx1 + NTy*NLy1 + NTz*NLz1)>0
;StencilS_Lx*NTx + StencilS_Lx*NTx + StencilS_Lx*NTx +

TrisResult(S_q+S_i)=1

Else
TrisResult(S_q+S_i)=0

CountTris=CountTris+1

EndIf

Next
S_q=S_q+ CountTriangles(S_s)+1
Next

w=1
S_q=0
S_counrSm=CountSurfaces(mesh)
For S_j=1 To S_counrSm
CountTris=0

S_s=GetSurface(mesh,S_j)
countt=CountTriangles(S_s)
counts=CountVertices(S_s)
counttall=counttall+CountTriangles(S_s)
countvall=countvall+CountVertices(S_s)
For S_i=0 To CountTriangles(S_s)-1
;If op=0

S_a=0
S_b=0
S_c=0
;S_TrisLDest#=TrisResult(S_q+S_i)
If culling
	Orientation=1
Else
	Orientation = TrisResult(S_q+S_i)
EndIf

If Orientation

;--------------------------------------------------------------------------------------------------
				S_V0 = TriangleVertex(S_s, S_i, 0)
				S_V1 = TriangleVertex(S_s, S_i, 1)
				S_V2 = TriangleVertex(S_s, S_i, 2)

				StencilS_Ax# = VertexX#(S_s, S_V0);*aEntityScaleX#(mesh)
				StencilS_Ay# = VertexY#(S_s, S_V0);*aEntityScaley#(mesh)
				StencilS_Az# = VertexZ#(S_s, S_V0);*aEntityScalez#(mesh)

				StencilS_Bx# = VertexX#(S_s, S_V1);*aEntityScaleX#(mesh)
				StencilS_By# = VertexY#(S_s, S_V1);*aEntityScaley#(mesh)
				StencilS_Bz# = VertexZ#(S_s, S_V1);*aEntityScalez#(mesh)

				StencilS_Cx# = VertexX#(S_s, S_V2);*aEntityScaleX#(mesh)
				StencilS_Cy# = VertexY#(S_s, S_V2);*aEntityScaley#(mesh)
				StencilS_Cz# = VertexZ#(S_s, S_V2);*aEntityScalez#(mesh)
;--------------------------------------------------------------------------------------------------

Tta=ten\Ta[S_q+S_i]
Ttb=ten\Tb[S_q+S_i]
Ttc=ten\Tc[S_q+S_i]

If offt=0
If Tta=0 S_a=1
If Ttb=0 S_b=1
If Ttc=0 S_c=1
EndIf

;--------------------------------------------------------------------------------------------------
If  Tta>0
If TrisResult(S_q+Tta-w)<>TrisResult(S_q+S_i) S_a=1
EndIf

;--------------------------------------------------------------------------------------------------
If  Ttb>0
If TrisResult(S_q+Ttb-w)<>TrisResult(S_q+S_i) S_b=1
EndIf

;--------------------------------------------------------------------------------------------------
If  Ttc>0
If TrisResult(S_q+Ttc-w)<>TrisResult(S_q+S_i) S_c=1
EndIf

;Else


;==================================================
 If zfail=1; Or sfail=4

If ltype=1

S_x1#= S_range *-NLx1 + StencilS_Ax
S_y1#= S_range *-NLy1 + StencilS_Ay
S_z1#= S_range *-NLz1 + StencilS_Az

S_x2#= S_range *-NLx1 + StencilS_Bx
S_y2#= S_range *-NLy1 + StencilS_By
S_z2#= S_range *-NLz1 + StencilS_Bz

S_x3#= S_range *-NLx1 + StencilS_Cx
S_y3#= S_range *-NLy1 + StencilS_Cy
S_z3#= S_range *-NLz1 + StencilS_Cz
Else

NewVector ( StencilS_Ax-StencilS_Lx, StencilS_Ay-StencilS_Ly, StencilS_Az-StencilS_Lz, S_range)
S_x1#= GetNormX#()+StencilS_Ax
S_y1#= GetNormY#()+StencilS_Ay
S_z1#= GetNormZ#()+StencilS_Az

NewVector ( StencilS_Bx-StencilS_Lx, StencilS_By-StencilS_Ly, StencilS_Bz-StencilS_Lz, S_range)
S_x2#= GetNormX#()+StencilS_Bx
S_y2#= GetNormY#()+StencilS_By
S_z2#= GetNormZ#()+StencilS_Bz

NewVector ( StencilS_Cx-StencilS_Lx, StencilS_Cy-StencilS_Ly, StencilS_Cz-StencilS_Lz, S_range)
S_x3#= GetNormX#()+StencilS_Cx
S_y3#= GetNormY#()+StencilS_Cy
S_z3#= GetNormZ#()+StencilS_Cz

EndIf

 If S_CountTris4>=S_ss4CountTris4
AddVertex(S_ss4,S_x1,S_y1,S_z1)
AddVertex(S_ss4,S_x2,S_y2,S_z2)
AddVertex(S_ss4,S_x3,S_y3,S_z3)

AddVertex(S_ss2,StencilS_Ax,StencilS_Ay,StencilS_Az)
AddVertex(S_ss2,StencilS_Bx,StencilS_By,StencilS_Bz)
AddVertex(S_ss2,StencilS_Cx,StencilS_Cy,StencilS_Cz)

Else

AVertexCoords S_ss4,VertCount4,S_x1,S_y1,S_z1
AVertexCoords S_ss4,VertCount4+1,S_x2,S_y2,S_z2
AVertexCoords S_ss4,VertCount4+2,S_x3,S_y3,S_z3

AVertexCoords(S_ss2,VertCount2,StencilS_Ax,StencilS_Ay,StencilS_Az)
AVertexCoords(S_ss2,VertCount2+1,StencilS_Bx,StencilS_By,StencilS_Bz)
AVertexCoords(S_ss2,VertCount2+2,StencilS_Cx,StencilS_Cy,StencilS_Cz)

EndIf
VertCount4=VertCount4+3
VertCount2=VertCount2+3

AddTriangle(S_ss4,VertCount4-1,VertCount4-2,VertCount4-3)
AddTriangle(S_ss2,VertCount2-3,VertCount2-2,VertCount2-1)

S_CountTris4=S_CountTris4+1


If S_a=1 Or S_c=1
S_vertexA=S_VertCount
S_VertCount=S_VertCount+1
If S_VertCount>=S_ssCountV
AddVertex(S_ss,StencilS_Ax,StencilS_Ay,StencilS_Az)
AddVertex(S_ss,S_x1,S_y1,S_z1)
Else
AVertexCoords S_ss,S_VertCount-1,StencilS_Ax,StencilS_Ay,StencilS_Az
AVertexCoords S_ss,S_VertCount,S_x1,S_y1,S_z1
EndIf
S_vertexA1=S_VertCount
S_VertCount=S_VertCount+1
EndIf

If S_a=1 Or S_b=1
S_vertexB=S_VertCount
S_VertCount=S_VertCount+1
If S_VertCount>=S_ssCountV
AddVertex(S_ss,StencilS_Bx,StencilS_By,StencilS_Bz)
AddVertex(S_ss,S_x2,S_y2,S_z2)
Else
AVertexCoords S_ss,S_VertCount-1,StencilS_Bx,StencilS_By,StencilS_Bz
AVertexCoords S_ss,S_VertCount,S_x2,S_y2,S_z2
EndIf
S_vertexB1=S_VertCount
S_VertCount=S_VertCount+1
EndIf

If S_b=1 Or S_c=1
S_vertexC=S_VertCount
S_VertCount=S_VertCount+1
If S_VertCount>=S_ssCountV
AddVertex(S_ss,StencilS_Cx,StencilS_Cy,StencilS_Cz)
AddVertex(S_ss,S_x3,S_y3,S_z3)
Else
AVertexCoords S_ss,S_VertCount-1,StencilS_Cx,StencilS_Cy,StencilS_Cz
AVertexCoords S_ss,S_VertCount,S_x3,S_y3,S_z3
EndIf
S_vertexC1=S_VertCount
S_VertCount=S_VertCount+1
EndIf

Else

If S_a=1 Or S_c=1

S_vertexA=S_VertCount
S_VertCount=S_VertCount+1
If ltype=1
S_x1#= S_range *-NLx1 + StencilS_Ax
S_y1#= S_range *-NLy1 + StencilS_Ay
S_z1#= S_range *-NLz1 + StencilS_Az
Else
;S_x1#= S_range *(StencilS_Ax-StencilS_Lx)/S_TrisLDest+StencilS_Ax
;S_y1#= S_range *(StencilS_Ay-StencilS_Ly)/S_TrisLDest+StencilS_Ay
;S_z1#= S_range *(StencilS_Az-StencilS_Lz)/S_TrisLDest+StencilS_Az
NewVector ( StencilS_Ax-StencilS_Lx, StencilS_Ay-StencilS_Ly, StencilS_Az-StencilS_Lz, S_range)
S_x1#= GetNormX#()+StencilS_Ax
S_y1#= GetNormY#()+StencilS_Ay
S_z1#= GetNormZ#()+StencilS_Az
EndIf

If S_VertCount>=S_ssCountV
AddVertex(S_ss,StencilS_Ax,StencilS_Ay,StencilS_Az)
AddVertex(S_ss,S_x1,S_y1,S_z1)
Else
AVertexCoords S_ss,S_VertCount-1,StencilS_Ax,StencilS_Ay,StencilS_Az
AVertexCoords S_ss,S_VertCount,S_x1,S_y1,S_z1
EndIf
S_vertexA1=S_VertCount
S_VertCount=S_VertCount+1
EndIf

If S_a=1 Or S_b=1

S_vertexB=S_VertCount
S_VertCount=S_VertCount+1
If ltype=1
S_x1#= S_range *-NLx1 + StencilS_Bx
S_y1#= S_range *-NLy1 + StencilS_By
S_z1#= S_range *-NLz1 + StencilS_Bz
Else
;S_x1#= S_range *(StencilS_Bx-StencilS_Lx)/S_TrisLDest+StencilS_Bx
;S_y1#= S_range *(StencilS_By-StencilS_Ly)/S_TrisLDest+StencilS_By
;S_z1#= S_range *(StencilS_Bz-StencilS_Lz)/S_TrisLDest+StencilS_Bz
NewVector ( StencilS_Bx-StencilS_Lx, StencilS_By-StencilS_Ly, StencilS_Bz-StencilS_Lz, S_range)
S_x1#= GetNormX#()+StencilS_Bx
S_y1#= GetNormY#()+StencilS_By
S_z1#= GetNormZ#()+StencilS_Bz
EndIf

If S_VertCount>=S_ssCountV
AddVertex(S_ss,StencilS_Bx,StencilS_By,StencilS_Bz)
AddVertex(S_ss,S_x1,S_y1,S_z1)
Else
AVertexCoords S_ss,S_VertCount-1,StencilS_Bx,StencilS_By,StencilS_Bz
AVertexCoords S_ss,S_VertCount,S_x1,S_y1,S_z1
EndIf
S_vertexB1=S_VertCount
S_VertCount=S_VertCount+1
EndIf

If S_b=1 Or S_c=1

S_vertexC=S_VertCount
S_VertCount=S_VertCount+1
If ltype=1
S_x1#= S_range *-NLx1 + StencilS_Cx
S_y1#= S_range *-NLy1 + StencilS_Cy
S_z1#= S_range *-NLz1 + StencilS_Cz
Else
;S_x1#= S_range *(StencilS_Cx-StencilS_Lx)/S_TrisLDest+StencilS_Cx
;S_y1#= S_range *(StencilS_Cy-StencilS_Ly)/S_TrisLDest+StencilS_Cy
;S_z1#= S_range *(StencilS_Cz-StencilS_Lz)/S_TrisLDest+StencilS_Cz
NewVector ( StencilS_Cx-StencilS_Lx, StencilS_Cy-StencilS_Ly, StencilS_Cz-StencilS_Lz, S_range)
S_x1#= GetNormX#()+StencilS_Cx
S_y1#= GetNormY#()+StencilS_Cy
S_z1#= GetNormZ#()+StencilS_Cz
EndIf

If S_VertCount>=S_ssCountV
AddVertex(S_ss,StencilS_Cx,StencilS_Cy,StencilS_Cz)
AddVertex(S_ss,S_x1,S_y1,S_z1)
Else
AVertexCoords S_ss,S_VertCount-1,StencilS_Cx,StencilS_Cy,StencilS_Cz
AVertexCoords S_ss,S_VertCount,S_x1,S_y1,S_z1
EndIf
S_vertexC1=S_VertCount
S_VertCount=S_VertCount+1
EndIf

EndIf

If S_a=1
AddTriangle(S_ss,S_vertexA,S_vertexA1,S_vertexB)
CountTris=CountTris+1
AddTriangle(S_ss,S_vertexA1,S_vertexB1,S_vertexB)
CountTris=CountTris+1
EndIf

If S_b=1
AddTriangle(S_ss,S_vertexB,S_vertexB1,S_vertexC)
CountTris=CountTris+1
AddTriangle(S_ss,S_vertexB1,S_vertexC1,S_vertexC)
CountTris=CountTris+1
EndIf

If S_c=1
AddTriangle(S_ss,S_vertexC,S_vertexC1,S_vertexA)
CountTris=CountTris+1
AddTriangle(S_ss,S_vertexC1,S_vertexA1,S_vertexA)
CountTris=CountTris+1
EndIf

;==================================================
Else

If S_SoftSelfShadingPass
;--------------------------------------------------------------------------------------------------
				S_V0 = TriangleVertex(S_s, S_i, 0)
				S_V1 = TriangleVertex(S_s, S_i, 1)
				S_V2 = TriangleVertex(S_s, S_i, 2)

				StencilS_Ax# = VertexX#(S_s, S_V0);*aEntityScaleX#(mesh)
				StencilS_Ay# = VertexY#(S_s, S_V0);*aEntityScaley#(mesh)
				StencilS_Az# = VertexZ#(S_s, S_V0);*aEntityScalez#(mesh)

				StencilS_Bx# = VertexX#(S_s, S_V1);*aEntityScaleX#(mesh)
				StencilS_By# = VertexY#(S_s, S_V1);*aEntityScaley#(mesh)
				StencilS_Bz# = VertexZ#(S_s, S_V1);*aEntityScalez#(mesh)

				StencilS_Cx# = VertexX#(S_s, S_V2);*aEntityScaleX#(mesh)
				StencilS_Cy# = VertexY#(S_s, S_V2);*aEntityScaley#(mesh)
				StencilS_Cz# = VertexZ#(S_s, S_V2);*aEntityScalez#(mesh)
;--------------------------------------------------------------------------------------------------
If (VertCount5+2)>=S_ss5CountV
AddVertex(S_ss5,StencilS_Ax,StencilS_Ay,StencilS_Az)
AddVertex(S_ss5,StencilS_Bx,StencilS_By,StencilS_Bz)
AddVertex(S_ss5,StencilS_Cx,StencilS_Cy,StencilS_Cz)
Else
AVertexCoords(S_ss5,VertCount5,StencilS_Ax,StencilS_Ay,StencilS_Az)
AVertexCoords(S_ss5,VertCount5+1,StencilS_Bx,StencilS_By,StencilS_Bz)
AVertexCoords(S_ss5,VertCount5+2,StencilS_Cx,StencilS_Cy,StencilS_Cz)
EndIf
VertCount5=VertCount5+3
AddTriangle(S_ss5,VertCount5-3,VertCount5-2,VertCount5-1)
EndIf

EndIf

Next
StencilCaster\shadowTris=StencilCaster\shadowTris+CountTris
StencilCaster\shadowVerts=StencilCaster\shadowVerts+S_VertCount
S_q=S_q+ CountTriangles(S_s)+1
;Stop
Next

S_e=1
FreeEntity light
;EndIf

EndIf
;EndIf ; -----------------


If StencilCaster\GeomUpdate=1 StencilCaster\GeomUpdate=0

StencilCaster\dx#=S_dmlx#; 
StencilCaster\dy#=S_dmly#; 
StencilCaster\dz#=S_dmlz#; 

StencilCaster\Deltap#=S_Mnx#
StencilCaster\Deltay#=S_Mny#
StencilCaster\Deltar#=S_Mnz#

StencilCaster\scalex#=S_scalex#
StencilCaster\scaley#=S_scaley#
StencilCaster\scalez#=S_scalez#

EndIf
EndIf

EndIf ;------------

Next

EndIf
TimeShadow=MilliSecs()-TimeShadow
End Function

Function RenderShadows(S_cam,S_tween#=1.0, ShadowMode_Alpha#=0)
ARenderWorld(S_cam,S_tween#, ShadowMode_Alpha#)
End Function

Function ShadowPlaneParam (ColorR, ColorG, ColorB, Blend)
Sshp_ColorR = ColorR
Sshp_ColorG = ColorG
Sshp_ColorB = ColorB
;Sshp_alpha# = alpha#
Sshp_Blend = Blend
End Function
; Change parameters Shadow plane (for Fake mode only)


; render functions:
;============================================================================================
Function RenderSceneStage1(S_cam,S_tween#=1.0,LightMode=0)

If SLibInitialized=0  InitShadowLib()

Stencil_CarrentCamera = S_cam

StencilS_Picx=EntityX(StencilShadowLight,1)
StencilS_Picy=EntityY(StencilShadowLight,1)
StencilS_Picz=EntityZ(StencilShadowLight,1)


CameraZnear# = RetF ( S_cam + 640)
;	PositionEntity AlphaFixedMesh,0,0,CameraZnear#*10
;	EntityParent AlphaFixedMesh,S_cam,0
	
For StencilReceiver.ShadowReceivers= Each ShadowReceivers

StencilReceiver\hiden=StencilEntityHidden(StencilReceiver\entity)
If StencilReceiver\hiden=0

If StencilReceiver\Shadowed=3
	If LightMode=0
		AHideEntity StencilReceiver\entity
	Else
		AShowEntity StencilReceiver\entity
	EndIf
;HideEntity StencilReceiver\entity
ElseIf StencilReceiver\Shadowed=0
	AHideEntity StencilReceiver\entity
Else
;	StencilReceiver\BrushStart = reti ( StencilReceiver\entity+652)
;;	StencilReceiver\BrushEnd = reti ( StencilReceiver\entity+584)
;	writei ( StencilReceiver\entity+580, S_LightBrushStart )
;	writei ( StencilReceiver\entity+584, S_LightBrushStart )
;	writei ( StencilReceiver\entity+652, S_LightBrushStart )
;;	writei ( StencilReceiver\entity+584, S_LightBrushEnd )
;	writei ( StencilReceiver\entity+588, 1 )
;	writei ( reti(StencilReceiver\entity+580)+4, 3)
;	writei ( reti(StencilReceiver\entity+584)+4, 3)
;	writei ( reti(StencilReceiver\entity+652)+4, 3)
EndIf
EndIf

Next
;*********************************************************************************

S_cullm=3;BBSetRenderState(22)

If LightMode=0
	For SS_Light.SShadowLights=Each SShadowLights
	SS_Light\hiden=StencilEntityHidden(SS_Light\entity)
;	HideEntity SS_Light\entity
AHideEntity SS_Light\entity
	Next
Else
	For SS_Light.SShadowLights=Each SShadowLights
	SS_Light\hiden=StencilEntityHidden(SS_Light\entity)
;	If SS_Light\hiden=0	ShowEntity SS_Light\entity
 If SS_Light\hiden=0 WriteI(  SS_Light\entity +24, 1 And reti(SS_Light\entity +24))
	Next
EndIf

;	AShowEntity AlphaFixedMesh
	CameraClsMode S_cam,1,1

	RenderWorld S_tween#

	CameraClsMode S_cam,0,0
;	AHideEntity AlphaFixedMesh
;**********************************************************************************
;WireFrame 0

RenderTris=TrisRendered()-2

	BBClear($00000004, $4080f0,1,0)

End Function
; LightMode:
;1 - shadowing
;0 - lighting
Function RenderVolums(S_cam,S_tween#=1.0)

Local S_SVsurf, S_SHsurf, S_SLHsurf, ASrcBlend, ADestBlend, AAlphaBlend, AFogMode

If Ashadowplane=0
Ashadowplane=CreateCube(S_cam) ; squished Z cube
EntityParent Ashadowplane,S_cam,0
ScaleMesh Ashadowplane,20,20,.1
MoveEntity Ashadowplane,0,0,CameraZnear+1
EntityColor Ashadowplane,0,0,0
EntityFX Ashadowplane,1+8
EntityAlpha Ashadowplane,.5
EntityBlend Ashadowplane,1
AHideEntity Ashadowplane
EndIf

SoftSelfShDraw=0

BBBeginScene ;/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

AAlphaBlend	= BBGetRenderState(27)
ASrcBlend	= BBGetRenderState(19)
ADestBlend	= BBGetRenderState(20)
   ;BBSetRenderState(22, 3)
ACullMode=BBGetRenderState(22)
AFogMode=BBGetRenderState(28)
	StencilS_Time=MilliSecs()
	BBSetRenderState(14,0)
	BBSetRenderState(52,1)
	BBSetRenderState(27,1)
	BBSetRenderState(19,  1);D3DBLEND_ZERO );
	BBSetRenderState(20, 2);D3DBLEND_ONE );
	
	BBSetRenderState(56, 8);D3DCMP_ALWAYS)
	BBSetRenderState(57, 1 )
	BBSetRenderState(58,$ffffffff)
	BBSetRenderState(59,$ffffffff)
	BBSetRenderState(  9,1)
	BBSetRenderState(  28,0)

BBSetTextureStageState 0,1,1
BBSetTextureStageState 1,1,1
BBSetTextureStageState 2,1,1
BBSetTextureStageState 3,1,1
BBSetTextureStageState 4,1,1
BBSetTextureStageState 5,1,1
BBSetTextureStageState 6,1,1
BBSetTextureStageState 7,1,1

BBSetTextureStageState 0,4,1
BBSetTextureStageState 1,4,1
BBSetTextureStageState 2,4,1
BBSetTextureStageState 3,4,1
BBSetTextureStageState 4,4,1
BBSetTextureStageState 5,4,1
BBSetTextureStageState 6,4,1
BBSetTextureStageState 7,4,1

;ShowEntity AlphaFixedMesh
;RenderWorld
;HideEntity AlphaFixedMesh

ShadowTris =0

TimeRender = MilliSecs ( )


AWireFrame=BBGetRenderState(8)

BBSetRenderState(7, 1)



 If Not ShadowVolumeAlpha>0  BBSetRenderState(8, 3)
BBSetRenderState(7, 1 )
BBSetRenderState(14,0)
	BBSetRenderState(54, 4);
	BBSetRenderState(53, 1); 
	BBSetRenderState(55, 1); 
BBSetRenderState(22,   2)
BBSetRenderState(  19,	1)
BBSetRenderState(  20,  2)

BBSetRenderState(23, 2)
BBSetRenderState(  9,1)

For StencilCaster.ShadowCasters= Each ShadowCasters
StencilReceiver.ShadowReceivers=Object.ShadowReceivers( StencilCaster\recAdr )
StencilCaster\hiden=StencilReceiver\hiden

HideEntity StencilCaster\ShadowVolume

If StencilCaster\hiden=0 And StencilCaster\on=1 And  StencilCaster\InZone=1 And  StencilCaster\DrawOFF=0

	EntityAlpha StencilCaster\ShadowVolume, ShadowVolumeAlpha#
	ShowEntity StencilCaster\ShadowVolume

	S_SVsurf = GetSurface(StencilCaster\ShadowVolume,1)
	S_SHsurf = GetSurface(StencilCaster\ShadowUpperAndLowerHats,1)
	S_SLHsurf = GetSurface(StencilCaster\ShadowUpperAndLowerHats,2)

		If StencilCaster\Zfail=1

				If StencilCaster\Active Or ShowActiveCasters=0
					EntityColor StencilCaster\ShadowVolume,ZFailColorR,ZFailColorG,ZFailColorB
				Else
					EntityColor StencilCaster\ShadowVolume,ZFailColorR/3,ZFailColorG/3,ZFailColorB/3
				EndIf

			BBSetEntityTransformMatrix (  StencilCaster\entity, 1)
			BBDrawSurface ( S_SVsurf )
			BBDrawSurface ( S_SHsurf )
			BBDrawSurface ( S_SLHsurf )

			ShadowTris =ShadowTris + CountTriangles(S_SVsurf) + CountTriangles(S_SHsurf) + CountTriangles(S_SLHsurf)

			ZfailCount=ZfailCount+1

		Else
			ZpasCount=ZpasCount+1

			ShadowTris =ShadowTris + CountTriangles(S_SVsurf)

				If StencilCaster\Active Or ShowActiveCasters=0
					EntityColor StencilCaster\ShadowVolume,ZPassColorR,ZPassColorG,ZPassColorB
				Else
					EntityColor StencilCaster\ShadowVolume,ZPassColorR/3,ZPassColorG/3,ZPassColorB/3
				EndIf

		EndIf

	EndIf
Next

 If Not ShadowVolumeAlpha>0  BBSetRenderState(8, 3)
	BBSetRenderState(14,0)
BBSetRenderState(22,   3);
	BBSetRenderState(54,5);
	BBSetRenderState(53, 1); 
	BBSetRenderState(55, 1);
BBSetRenderState(  19,	1)
BBSetRenderState(  20,  2)
BBSetRenderState(  9,1)
BBSetRenderState(23, 2)


For StencilCaster.ShadowCasters= Each ShadowCasters
	StencilReceiver.ShadowReceivers=Object.ShadowReceivers( StencilCaster\recAdr )
	StencilCaster\hiden=StencilReceiver\hiden
	If StencilCaster\hiden=0 And StencilCaster\on=1 And  StencilCaster\InZone=1 And  StencilCaster\DrawOFF=0
		If StencilCaster\Zfail=1
			BBSetEntityTransformMatrix (  StencilCaster\entity, 1)
			BBDrawSurface ( GetSurface(StencilCaster\ShadowVolume,1))
			BBDrawSurface ( GetSurface(StencilCaster\ShadowUpperAndLowerHats,1))
			BBDrawSurface ( GetSurface(StencilCaster\ShadowUpperAndLowerHats,2))
;			ShadowTris =ShadowTris +CountTriangles()
		EndIf

	EndIf
Next


;For UserShadowV.UserShadowVolumes= Each UserShadowVolumes
;UserShadowV\hiden=StencilEntityHidden(UserShadowV\entity)
;If UserShadowV\hiden=0
;EntityAlpha UserShadowV\entity,0.001
;	If UserShadowV\Ztech=0
;ZpasCount=ZpasCount+1
;HideEntity UserShadowV\entity
;	Else
;ZfailCount=ZfailCount+1
;ShowEntity UserShadowV\entity
;	EndIf
;EndIf
;Next


S_RenderedOne=1
If Not ZpasCount=0

BBSetRenderState(23, 4)
 If Not ShadowVolumeAlpha>0  BBSetRenderState(8, 3)
	BBSetRenderState(14,0)
	BBSetRenderState(53, 1);
	BBSetRenderState(54, 1); 
	BBSetRenderState(55, 4);
BBSetRenderState(  19,	1)
BBSetRenderState(  20,  2)
BBSetRenderState(  9,1)
BBSetRenderState(22, 3);2)

For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\hiden=0 And StencilCaster\on=1 And  StencilCaster\InZone=1 And  StencilCaster\DrawOFF=0

If  StencilCaster\SoftSelfShadingMODE=1 SoftSelfShDraw=1
If StencilCaster\Zfail=0

			BBSetEntityTransformMatrix (  StencilCaster\entity, 1)
			BBDrawSurface ( GetSurface(StencilCaster\ShadowVolume,1))

EndIf
EndIf
Next

;For UserShadowV.UserShadowVolumes= Each UserShadowVolumes
;If UserShadowV\hiden=0
;	If UserShadowV\Ztech=0
;ShowEntity UserShadowV\entity
;	Else
;HideEntity UserShadowV\entity
;	EndIf
;EndIf
;Next

;ShadowTris =ShadowTris +TrisRendered()
 If Not ShadowVolumeAlpha>0  BBSetRenderState(8, 3)
	BBSetRenderState(14,0)
	BBSetRenderState(53,  1);
	BBSetRenderState(54, 1);
	BBSetRenderState(55, 5);
	BBSetRenderState(22,   2);

BBSetRenderState(  19,	1)
BBSetRenderState(  20,  2)
BBSetRenderState(  9,1)


For StencilCaster.ShadowCasters= Each ShadowCasters
	StencilReceiver.ShadowReceivers=Object.ShadowReceivers( StencilCaster\recAdr )
	StencilCaster\hiden=StencilReceiver\hiden
	If StencilCaster\hiden=0 And StencilCaster\on=1 And  StencilCaster\InZone=1 And  StencilCaster\DrawOFF=0
		If StencilCaster\Zfail=0
			BBSetEntityTransformMatrix (  StencilCaster\entity, 1)
			BBDrawSurface ( GetSurface(StencilCaster\ShadowVolume,1))
		EndIf

	EndIf
Next
;ShadowTris =ShadowTris +TrisRendered()

EndIf

BBSetRenderState(23, 4)
BBSetRenderState(22, S_cullm);D3DCULL_CCW )


;For UserShadowV.UserShadowVolumes= Each UserShadowVolumes
;If UserShadowV\hiden=0
;HideEntity UserShadowV\entity
;EntityAlpha UserShadowV\entity,0
;EndIf
;Next


If SoftSelfShading=1 Or SoftSelfShDraw=1

BBSetRenderState(23, 4)
	BBSetRenderState(57,  0 )
	BBSetRenderState(14,0)
	BBSetRenderState(53,  1);
	BBSetRenderState(54, 1);
	BBSetRenderState(55, 5);
	
BBSetRenderState(  19,	1)
BBSetRenderState(  20,  2)
BBSetRenderState(  9,1)

For StencilCaster.ShadowCasters= Each ShadowCasters
If StencilCaster\hiden=0 And StencilCaster\on=1 And  StencilCaster\InZone=1 And  StencilCaster\DrawOFF=0


If StencilCaster\SoftSelfShadingMODE=1 Or (SoftSelfShading=1 And StencilCaster\SoftSelfShadingMODE=0)

			BBSetEntityTransformMatrix (  StencilCaster\entity, 1)
			S_SLHsurf = GetSurface(StencilCaster\ShadowLowerSurface,1)
			BBDrawSurface ( S_SLHsurf )
			ShadowTris =ShadowTris + CountTriangles(S_SLHsurf)
EndIf

EndIf
Next


EndIf

BBSetRenderState(7, 0)

 TimeRender = MilliSecs ( ) - TimeRender

BBSetRenderState(  9,2)

BBSetRenderState(27, AAlphaBlend)
BBSetRenderState(19, ASrcBlend)
BBSetRenderState(20, ADestBlend)
BBSetRenderState(  28, AFogMode)

BBEndScene ;/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

End Function

Function RenderSceneStage2(S_cam,S_tween#=1.0, LightMode=1)

	BBSetRenderState(14,    0 )
	;BBSetRenderState(7,      0 )
	BBSetRenderState(52, 1 )

	BBSetRenderState(8, AWireFrame)	

	BBSetRenderState(57,  1 )
	
	If LightMode=0
	BBSetRenderState(56, 4); D3DCMP_EQUAL )
	Else
	BBSetRenderState(56, 5); D3DCMP_EQUAL )
	EndIf
		
	BBSetRenderState(55, 1);D3DSTENCILOP_REPLACE )
	BBSetRenderState(53, 1);
	BBSetRenderState(54, 1);
;BBSetRenderState(  19, 5 );S_srcb)
;BBSetRenderState(  20 ,6 ); S_destb)
;BBSetRenderState(27, 1 )

For StencilReceiver.ShadowReceivers= Each ShadowReceivers
If StencilReceiver\hiden=0

If StencilReceiver\Shadowed=3
	If LightMode=0
		AHideEntity StencilReceiver\entity
	Else
		AShowEntity StencilReceiver\entity
	EndIf
;ElseIf StencilReceiver\Shadowed=2
;;EntityAlpha StencilReceiver\entity,StencilReceiver\alpha#
;ElseIf StencilReceiver\Shadowed=1
;ShowEntity StencilReceiver\entity
ElseIf StencilReceiver\Shadowed=4
AHideEntity StencilReceiver\entity
ElseIf StencilReceiver\Shadowed=0
AHideEntity StencilReceiver\entity
Else
	AShowEntity StencilReceiver\entity
	;	writei ( StencilReceiver\entity+652, 1 )
;	writei ( StencilReceiver\entity+580, StencilReceiver\BrushStart )
;	writei ( StencilReceiver\entity+584, StencilReceiver\BrushStart )
;	writei ( StencilReceiver\entity+652, StencilReceiver\BrushStart )
;	writei ( StencilReceiver\entity+584, StencilReceiver\BrushEnd )
;	writei ( StencilReceiver\entity+588, 1 )
;	writei ( reti(StencilReceiver\entity+580)+4, 1)
;	writei ( reti(StencilReceiver\entity+584)+4, 1)
;	writei ( reti(StencilReceiver\entity+652)+4, 1)
EndIf

EndIf
Next


If LightMode=0
	For SS_Light.SShadowLights=Each SShadowLights
;	HideEntity SS_Light\entity
AHideEntity SS_Light\entity
	Next
Else
	For SS_Light.SShadowLights=Each SShadowLights
	If SS_Light\hiden=0 AShowEntity SS_Light\entity
;	If SS_Light\hiden=0 WriteI(  SS_Light\entity +24, 1 And reti(SS_Light\entity +24))
	Next
EndIf
;HideEntity StencilShadowLight

;ShowEntity Ashadowplane
	RenderWorld S_tween#
;HideEntity Ashadowplane
;RenderTris=TrisRendered()

	For SS_Light.SShadowLights=Each SShadowLights
;	SS_Light\hiden=StencilEntityHidden(SS_Light\entity)
	If SS_Light\hiden=0 ShowEntity SS_Light\entity
	Next

BBSetRenderState(27, 1 )
BBSetRenderState(52,   0 )

End Function
; LightMode:
;1 - shadowing
;0 - lighting
Function RenderAlpha(S_cam,S_tween#=1.0)

If Not ShadowVolumeAlpha=0
	AShowEntity S_StencilSysPivot
	RenderEntity( S_StencilSysPivot, S_cam)
	AHideEntity S_StencilSysPivot
EndIf
 ;EndIf
 
;For UserShadowV.UserShadowVolumes= Each UserShadowVolumes
;If UserShadowV\hiden=0
;ShowEntity UserShadowV\entity
;If UserShadowV\alpha#>0
;EntityAlpha UserShadowV\entity,UserShadowV\alpha#+0.001
;EndIf
;EndIf
;Next

AlphaObjectCount=0
For StencilReceiver.ShadowReceivers= Each ShadowReceivers
If StencilReceiver\hiden=0
;If StencilReceiver\Shadowed=2
;EntityAlpha StencilReceiver\entity,0
If StencilReceiver\Shadowed=0
AShowEntity StencilReceiver\entity
AlphaObjectCount=AlphaObjectCount+1
Else
AHideEntity StencilReceiver\entity
EndIf
EndIf
Next

BBSetRenderState(22, S_cullm);D3DCULL_CCW )

AShowEntity AlphaFixedMesh

;If Ref_Blur_ON And BlurInitialized 
;ShowEntity Blur_Sprite
;EntityAlpha Blur_Sprite, Blur_Alpha
;EndIf

If AlphaObjectCount>0; Or ShadowVolumeAlpha>0
	RenderWorld S_tween#
EndIf

;If Ref_Blur_ON And BlurInitialized 
;HideEntity Blur_Sprite
;EntityAlpha Blur_Sprite, 0
;EndIf

AHideEntity AlphaFixedMesh

RenderTris=RenderTris+TrisRendered()

For StencilReceiver.ShadowReceivers= Each ShadowReceivers
If StencilReceiver\hiden=0

AShowEntity StencilReceiver\entity

EndIf
Next

; If Not ShadowVolumeAlpha=0
;	HideEntity S_StencilSysPivot
; EndIf


;For UserShadowV.UserShadowVolumes= Each UserShadowVolumes
;If UserShadowV\hiden=0 
;EntityAlpha UserShadowV\entity,0
;EndIf
;Next

	BBSetRenderState(52,   0 )
	BBSetRenderState(14, 1);True)

   CameraClsMode S_cam,1,1
StencilS_Time=MilliSecs() - StencilS_Time

;NewRenderState.ARenderState=First ARenderState
;LastRenderState(NewRenderState.ARenderState)
End Function

Function DrrawShadow(S_ShadowAlpha#=.5,S_tween#=1.0)

	BBSetRenderState(14,    0 )
;	BBSetRenderState(7,      0 )
	BBSetRenderState(52, 1 )

	BBSetRenderState(8, AWireFrame)	

	BBSetRenderState(57,  1 )
	BBSetRenderState(56, 4); D3DCMP_EQUAL )
	BBSetRenderState(55, 1);D3DSTENCILOP_REPLACE )
	BBSetRenderState(53, 1);
	BBSetRenderState(54, 1);
BBSetRenderState(  19, 5 );S_srcb)
BBSetRenderState(  20 ,6 ); S_destb)
	BBSetRenderState(27, 1 )
	BBSetRenderState(23, 8)


;HideEntity StencilShadowLight
If Ashadowplane
EntityColor Ashadowplane,Sshp_ColorR, Sshp_ColorG, Sshp_ColorB
;EntityAlpha Ashadowplane,Sshp_alpha#
EntityBlend Ashadowplane,Sshp_Blend
EndIf

AShowEntity Ashadowplane
EntityAlpha Ashadowplane,S_ShadowAlpha#
;	RenderWorld ;S_tween#
RenderEntity Ashadowplane, Stencil_CarrentCamera
AHideEntity Ashadowplane

	For SS_Light.SShadowLights=Each SShadowLights
	If SS_Light\hiden=0 ShowEntity SS_Light\entity
	Next


BBSetRenderState(23, 4)
BBSetRenderState(27, 1 )
BBSetRenderState(52,   0 )

End Function
;============================================================================================



;============================================================================================
Function CreateVolume(S_adr)

Local  vertex[65535]
Local  TRvertex[65535]

StencilCaster.ShadowCasters=Object.ShadowCasters(S_adr)
mesh=StencilCaster\entity

ten.ShadowVolumes = New ShadowVolumes
StencilCaster\adres=Handle(ten.ShadowVolumes )
ten\CounCasters=ten\CounCasters+1

RotateMesh mesh,.0001,.0001,.0001
;UpdateNormals mesh
;StencilCaster\Pivot=CreatePivot(mesh)
StencilCaster\ShadowVolume=CreateMesh(S_StencilSysPivot)
StencilCaster\ShadowUpperAndLowerHats=CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowVolume,"StencilShadow_volume"
NameEntity StencilCaster\ShadowUpperAndLowerHats,"StencilShadow_volume"

StencilCaster\ShadowLowerSurface=CreateMesh(S_StencilSysPivot)
NameEntity StencilCaster\ShadowLowerSurface,"StencilShadow_volume"
EntityAlpha StencilCaster\ShadowLowerSurface,0
EntityFX StencilCaster\ShadowLowerSurface,1
HideEntity StencilCaster\ShadowLowerSurface

EntityAlpha StencilCaster\ShadowUpperAndLowerHats,0
EntityFX StencilCaster\ShadowUpperAndLowerHats,1

EntityAlpha StencilCaster\ShadowVolume,0.0001
S_sm=StencilCaster\ShadowVolume
S_sp=StencilCaster\ShadowUpperAndLowerHats
S_sSh=StencilCaster\shadowBackShapka

EntityFX S_sm,17
S_ss=CreateSurface(S_sm)
S_ss2=CreateSurface(S_sp);StencilCaster\ShadowUpperAndLowerHats)
;S_ss3=CreateSurface(S_sm)
S_ss4=CreateSurface(S_sp)
S_ss5=CreateSurface(StencilCaster\ShadowLowerSurface)
S_e=1
StencilS_X=0
S_ct=0
S_cv=0
proc#=0.00
S_i=0

If VolumeBuildMethod=0; \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


S_TimeCR=MilliSecs()
For S_j=1 To CountSurfaces(mesh)
S_s=GetSurface(mesh,S_j)
For S_i=0 To CountTriangles(S_s)-1
S_V0 = TriangleVertex(S_s, S_i, 0)
S_V1 = TriangleVertex(S_s, S_i, 1)
S_V2 = TriangleVertex(S_s, S_i, 2)
ten\Ta[S_ct+S_i]=0
ten\Tb[S_ct+S_i]=0
ten\Tc[S_ct+S_i]=0
S_a=0:S_b=0:S_c=0

For S_q=0 To CountTriangles(S_s)-1
If Not S_q=S_i
T0=TriangleVertex(S_s, S_q, 0)
T1=TriangleVertex(S_s, S_q, 1)
T2=TriangleVertex(S_s, S_q, 2)
If (VertexX(S_s,S_V0)=VertexX(S_s,t0) And VertexY(S_s,S_V0)=VertexY(S_s,t0) And VertexZ(S_s,S_V0)=VertexZ(S_s,t0)) Or (VertexX(S_s,S_V0)=VertexX(S_s,t1) And VertexY(S_s,S_V0)=VertexY(S_s,t1) And VertexZ(S_s,S_V0)=VertexZ(S_s,t1))  Or (VertexX(S_s,S_V0)=VertexX(S_s,t2) And VertexY(S_s,S_V0)=VertexY(S_s,t2) And VertexZ(S_s,S_V0)=VertexZ(S_s,t2)) 
If (VertexX(S_s,S_V1)=VertexX(S_s,t0) And VertexY(S_s,S_V1)=VertexY(S_s,t0) And VertexZ(S_s,S_V1)=VertexZ(S_s,t0)) Or (VertexX(S_s,S_V1)=VertexX(S_s,t1) And VertexY(S_s,S_V1)=VertexY(S_s,t1) And VertexZ(S_s,S_V1)=VertexZ(S_s,t1))  Or (VertexX(S_s,S_V1)=VertexX(S_s,t2) And VertexY(S_s,S_V1)=VertexY(S_s,t2) And VertexZ(S_s,S_V1)=VertexZ(S_s,t2)) 
;If S_V0=t0 Or S_V0=t1 Or S_V0=t2
;If S_V1=t0 Or S_V1=t1 Or S_V1=t2
ten\Ta[S_ct+S_i]=S_q+S_e
trisma(S_a)=S_q+S_e
 If S_a>0 ten\Ta[S_ct+S_i]=0
S_a=S_a+1
EndIf
EndIf
If (VertexX(S_s,S_V1)=VertexX(S_s,t0) And VertexY(S_s,S_V1)=VertexY(S_s,t0) And VertexZ(S_s,S_V1)=VertexZ(S_s,t0)) Or (VertexX(S_s,S_V1)=VertexX(S_s,t1) And VertexY(S_s,S_V1)=VertexY(S_s,t1) And VertexZ(S_s,S_V1)=VertexZ(S_s,t1))  Or (VertexX(S_s,S_V1)=VertexX(S_s,t2) And VertexY(S_s,S_V1)=VertexY(S_s,t2) And VertexZ(S_s,S_V1)=VertexZ(S_s,t2)) 
If (VertexX(S_s,S_V2)=VertexX(S_s,t0) And VertexY(S_s,S_V2)=VertexY(S_s,t0) And VertexZ(S_s,S_V2)=VertexZ(S_s,t0)) Or (VertexX(S_s,S_V2)=VertexX(S_s,t1) And VertexY(S_s,S_V2)=VertexY(S_s,t1) And VertexZ(S_s,S_V2)=VertexZ(S_s,t1))  Or (VertexX(S_s,S_V2)=VertexX(S_s,t2) And VertexY(S_s,S_V2)=VertexY(S_s,t2) And VertexZ(S_s,S_V2)=VertexZ(S_s,t2)) 
;If S_V1=t0 Or S_V1=t1 Or S_V1=t2
;If S_V2=t0 Or S_V2=t1 Or S_V2=t2
ten\Tb[S_ct+S_i]=S_q+S_e
trismb(S_b)=S_q+S_e
 If S_b>0 ten\Tb[S_ct+S_i]=0
S_b=S_b+1
EndIf
EndIf
If (VertexX(S_s,S_V2)=VertexX(S_s,t0) And VertexY(S_s,S_V2)=VertexY(S_s,t0) And VertexZ(S_s,S_V2)=VertexZ(S_s,t0)) Or (VertexX(S_s,S_V2)=VertexX(S_s,t1) And VertexY(S_s,S_V2)=VertexY(S_s,t1) And VertexZ(S_s,S_V2)=VertexZ(S_s,t1))  Or (VertexX(S_s,S_V2)=VertexX(S_s,t2) And VertexY(S_s,S_V2)=VertexY(S_s,t2) And VertexZ(S_s,S_V2)=VertexZ(S_s,t2)) 
If (VertexX(S_s,S_V0)=VertexX(S_s,t0) And VertexY(S_s,S_V0)=VertexY(S_s,t0) And VertexZ(S_s,S_V0)=VertexZ(S_s,t0)) Or (VertexX(S_s,S_V0)=VertexX(S_s,t1) And VertexY(S_s,S_V0)=VertexY(S_s,t1) And VertexZ(S_s,S_V0)=VertexZ(S_s,t1))  Or (VertexX(S_s,S_V0)=VertexX(S_s,t2) And VertexY(S_s,S_V0)=VertexY(S_s,t2) And VertexZ(S_s,S_V0)=VertexZ(S_s,t2)) 
;If S_V2=t0 Or S_V2=t1 Or S_V2=t2
;If S_V0=t0 Or S_V0=t1 Or S_V0=t2
ten\Tc[S_ct+S_i]=S_q+S_e
trismc(S_c)=S_q+S_e
 If S_c>0 ten\Tc[S_ct+S_i]=0
S_c=S_c+1
EndIf
EndIf
EndIf
;If ten\Ta[S_ct+S_i]>0 And ten\Tb[S_ct+S_i]>0 And ten\Tc[S_ct+S_i]>0

If S_a>1 And S_b>1 And S_c>1
;dobro=0
Exit
EndIf


Next


If 0


 If Not S_a=1 Or S_b=1 Or S_c=1
  If Not S_a=1 And S_b=1 And S_c=1
bad.TrisMassiv=New TrisMassiv
bad\n=S_ct+S_i
For S_m=0 To S_a-1
bad\S_a[S_m]=trisma(S_m)
Next
For S_m=0 To S_b-1
bad\S_b[S_m]=trismb(S_m)
Next
For S_m=0 To S_c-1
bad\S_c[S_m]=trismc(S_m)
Next
;ten\Ta[S_ct+S_i]=0
;ten\Tb[S_ct+S_i]=0
;ten\Tc[S_ct+S_i]=0
  Else
good.TrisMassiv=New TrisMassiv
good\n=S_ct+S_i
good\na=S_a
good\nb=S_b
good\nc=S_c
For S_m=0 To S_a-1
good\S_a[S_m]=trisma(S_m)
Next
For S_m=0 To S_b-1
good\S_b[S_m]=trismb(S_m)
Next
For S_m=0 To S_c-1
good\S_c[S_m]=trismc(S_m)
Next
  EndIf
 EndIf



EndIf



S_spoligons#=CountTriangles(S_s)*proc#
If DrawProgress
If S_i>S_spoligons
Text 5,5,Int(proc#*100)+"%"
Text 5,15,S_i+"  to  "+CountTriangles(S_s)
Flip 0
Cls
proc#=proc#+.01
EndIf
;If proc=0 proc=1
EndIf

Next
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
If 0

For bad.TrisMassiv= Each TrisMassiv
  For good.TrisMassiv=Each TrisMassiv
For S_m=0 To good\na
If good\S_a[S_m]=bad\n+S_e good\S_a[S_m]=0
Next
For S_m=0 To good\nb
If good\S_b[S_m]=bad\n+S_e good\S_b[S_m]=0
Next
For S_m=0 To good\nc
If good\S_c[S_m]=bad\n+S_e good\S_c[S_m]=0
Next
  Next
Next

  For good.TrisMassiv= Each TrisMassiv
For S_m=0 To good\na
If Not good\S_a[S_m]=0 ten\Ta[good\n]=good\S_a[S_m]
Next
For S_m=0 To good\nb
If Not good\S_b[S_m]=0 ten\Tb[good\n]=good\S_b[S_m]
Next
For S_m=0 To good\nc
If Not good\S_c[S_m]=0 ten\Tc[good\n]=good\S_c[S_m]
Next
  Next

EndIf
;Delete bad
;Delete good
Delete Each TrisMassiv
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
S_ct=S_ct+CountTriangles(S_s)+S_e
proc#=0
Next

Else ; \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


S_TimeCR=MilliSecs()
For S_j=1 To CountSurfaces(mesh)
S_s=GetSurface(mesh,S_j)
For iter_i=0 To 1
For S_i=0 To CountTriangles(S_s)-1
S_V0 = TriangleVertex(S_s, S_i, 0)
S_V1 = TriangleVertex(S_s, S_i, 1)
S_V2 = TriangleVertex(S_s, S_i, 2)

S_ta=-1 : S_tb=-2 : S_tc=-3

If vertex[S_cv+S_V0]=0
	vertex[S_cv+S_V0] = S_i+1
	TRvertex[S_cv+S_V0] = 1
ElseIf vertex[S_cv+S_V0]>0
	S_ta=vertex[S_cv+S_V0];And vertex[S_cv+S_V0*2+1]=1
	S_tai=TRvertex[S_cv+S_V0]
EndIf

If vertex[S_cv+S_V1]=0
	vertex[S_cv+S_V1] = S_i+1
	TRvertex[S_cv+S_V1] = 2
ElseIf vertex[S_cv+S_V1]>0
	S_tb=vertex[S_cv+S_V1] ;And vertex[S_cv+S_V1*2+1]=2
	S_tbi=TRvertex[S_cv+S_V1]
EndIf

If vertex[S_cv+S_V2]=0
	vertex[S_cv+S_V2] = S_i+1
	TRvertex[S_cv+S_V2] = 3
ElseIf vertex[S_cv+S_V2]>0
	S_tc=vertex[S_cv+S_V2];And vertex[S_cv+S_V2*2+1]=3
	S_tci=TRvertex[S_cv+S_V2]
EndIf

;vertex[S_cv+S_V0]=0
;vertex[S_cv+S_V1]=0
;vertex[S_cv+S_V2]=0
;---------------------------------------------------------------------------------------------------------
If S_ta=S_tb
	ten\Ta[S_ct+S_i]=S_ta

		  If S_tbi + S_tai=3
			ten\Ta[S_ct+S_ta-1]=S_i+1
	ElseIf S_tbi + S_tai=5
			ten\Tb[S_ct+S_ta-1]=S_i+1
	ElseIf S_tbi + S_tai=4
			ten\Tc[S_ct+S_ta-1]=S_i+1
	EndIf
	
	vertex[S_cv+S_V0]=-1
EndIf
;---------------------------------------------------------------------------------------------------------
If S_tb=S_tc
	ten\Tb[S_ct+S_i]=S_tb

		  If S_tbi + S_tci=3
			ten\Ta[S_ct+S_tb-1]=S_i+1
	ElseIf S_tbi + S_tci=5
			ten\Tb[S_ct+S_tb-1]=S_i+1
	ElseIf S_tbi + S_tci=4
			ten\Tc[S_ct+S_tb-1]=S_i+1
	EndIf
	
	vertex[S_cv+S_V1]=-1
EndIf
;---------------------------------------------------------------------------------------------------------
If S_tc=S_ta
	ten\Tc[S_ct+S_i]=S_tc
	
		  If S_tai + S_tci=3
			ten\Ta[S_ct+S_tc-1]=S_i+1
	ElseIf S_tai + S_tci=5
			ten\Tb[S_ct+S_tc-1]=S_i+1
	ElseIf S_tai + S_tci=4
			ten\Tc[S_ct+S_tc-1]=S_i+1
	EndIf
	
	vertex[S_cv+S_V2]=-1
EndIf
;---------------------------------------------------------------------------------------------------------
Next
Next
S_ct=S_ct+CountTriangles(S_s)+S_e
S_cv=S_cv+CountVertices(S_s)*2+S_e
Next


EndIf; \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


S_TimeCR=MilliSecs()-S_TimeCR

RotateMesh mesh,-.0001,-.0001,-.0001
;S_adr=Handle(ten.ShadowVolumes ) 
UpdateTrisNormals(S_adr)
Return S_sm
End Function

Function UpdateTrisNormals(S_adr)

StencilCaster.ShadowCasters=Object.ShadowCasters(S_adr)
mesh=StencilCaster\entity
ten.ShadowVolumes=Object.ShadowVolumes(StencilCaster\adres)
S_q=0
For S_j=1 To CountSurfaces(mesh)
S_s=GetSurface(mesh,S_j)
For S_i=0 To CountTriangles(S_s)-1
;--------------------------------------------------------------------------------------------------
				S_V0 = TriangleVertex(S_s, S_i, 0)
				S_V1 = TriangleVertex(S_s, S_i, 1)
				S_V2 = TriangleVertex(S_s, S_i, 2)

				StencilS_Sax# = VertexX#(S_s, S_V0)
				StencilS_Say# = VertexY#(S_s, S_V0)
				StencilS_Saz# = VertexZ#(S_s, S_V0)

				StencilS_Sbx# = VertexX#(S_s, S_V1)
				StencilS_Sby# = VertexY#(S_s, S_V1)
				StencilS_Sbz# = VertexZ#(S_s, S_V1)

				StencilS_Scx# = VertexX#(S_s, S_V2)
				StencilS_Scy# = VertexY#(S_s, S_V2)
				StencilS_Scz# = VertexZ#(S_s, S_V2)

				C_Mx# = StencilS_Sax#-StencilS_Sbx#
				C_My# = StencilS_Say#-StencilS_Sby#
				C_Mz# = StencilS_Saz#-StencilS_Sbz#

				C_Nx# = StencilS_Sbx#-StencilS_Scx#
				C_Ny# = StencilS_Sby#-StencilS_Scy#
				C_Nz# = StencilS_Sbz#-StencilS_Scz#

				ten\Tnx[S_q+S_i] = C_My#*C_Nz# - C_Mz#*C_Ny#
				ten\Tny[S_q+S_i] = C_Mz#*C_Nx# - C_Mx#*C_Nz#
				ten\Tnz[S_q+S_i] = C_Mx#*C_Ny# - C_My#*C_Nx#
Next
S_q=S_q+ CountTriangles(S_s)+1
Next

End Function

Function SizeMesh(mesh,plus#=0)
S_EntityRadius#=0
For S_j=1 To CountSurfaces(mesh)
S_s=GetSurface(mesh,S_j)
For S_i=0 To CountVertices(S_s)-1
StencilS_X#=VertexX(S_s,S_i)
StencilS_Y#=VertexY(S_s,S_i)
StencilS_Z#=VertexZ(S_s,S_i)
S_destV#=Sqr( StencilS_X# * StencilS_X# + StencilS_Y# * StencilS_Y# + StencilS_Z# * StencilS_Z# )
If S_destV#>S_EntityRadius# S_EntityRadius# = S_destV#

If StencilS_X>S_meshx#  S_meshx#=StencilS_X
If StencilS_X<S_meshx1#  S_meshx1#=StencilS_X

If StencilS_Y>S_meshy#  S_meshy#=StencilS_Y
If StencilS_Y<S_meshy1#  S_meshy1#=StencilS_Y

If StencilS_Z>S_meshz#  S_meshz#=StencilS_Z
If StencilS_Z<S_meshz1#  S_meshz1#=StencilS_Z
Next
Next
S_sizex=S_meshx
S_sizey=S_meshy
S_sizez=S_meshz

S_sizex1=S_meshx1
S_sizey1=S_meshy1
S_sizez1=S_meshz1
End Function

Function CreateSbox(S_adr,plus#=0)
StencilCaster.ShadowCasters=Object.ShadowCasters(S_adr)
mesh=StencilCaster\entity

S_EntityRadius#=0
S_CasterCountTris=0

For S_j=1 To CountSurfaces(mesh)
S_s=GetSurface(mesh,S_j)
S_CasterCountTris=S_CasterCountTris+CountTriangles(S_s)
For S_i=0 To CountVertices(S_s)-1
StencilS_X#=VertexX(S_s,S_i)
StencilS_Y#=VertexY(S_s,S_i)
StencilS_Z#=VertexZ(S_s,S_i)

S_destV#=Sqr( StencilS_X# * StencilS_X# + StencilS_Y# * StencilS_Y# + StencilS_Z# * StencilS_Z# )
If S_destV#>S_EntityRadius# S_EntityRadius# = S_destV#

If StencilS_X>S_meshx#  S_meshx#=StencilS_X
If StencilS_X<S_meshx1#  S_meshx1#=StencilS_X

If StencilS_Y>S_meshy#  S_meshy#=StencilS_Y
If StencilS_Y<S_meshy1#  S_meshy1#=StencilS_Y

If StencilS_Z>S_meshz#  S_meshz#=StencilS_Z
If StencilS_Z<S_meshz1#  S_meshz1#=StencilS_Z
Next
Next

StencilCaster\radius#=S_EntityRadius#

S_sizex=S_meshx
S_sizey=S_meshy
S_sizez=S_meshz

S_sizex1=S_meshx1
S_sizey1=S_meshy1
S_sizez1=S_meshz1

If S_CasterCountTris>20
StencilCaster\bbox = 1;CreateBox4()
; EntityColor StencilCaster\bbox ,0,0,255
; EntityAlpha StencilCaster\bbox ,.3
; EntityFX StencilCaster\bbox ,17
; CreateReceiver StencilCaster\bbox,0
;CutEntity( StencilCaster\bbox )
EndIf

End Function

Function  CreateBox4( parent=0)
Local m, fts
;	If FirstStencilBBox>0
;m = CopyEntity( FirstStencilBBox ,parent )
;	Else
m = CreateMesh(parent)
fts=CreateSurface(m)
AddVertex fts,1,1,1
AddVertex fts,1,1,-1
AddVertex fts,-1,1,1
AddVertex fts,1,-1,1
AddVertex fts,1,-1,-1
AddVertex fts,-1,-1,1
AddVertex fts,-1,1,-1
AddVertex fts,-1,-1,-1

AddTriangle fts,0,1,3
AddTriangle fts,3,1,4
AddTriangle fts,2,0,5
AddTriangle fts,5,0,3
AddTriangle fts,6,2,5
AddTriangle fts,6,5,7
AddTriangle fts,2,1,0
AddTriangle fts,6,1,2
AddTriangle fts,5,3,7
AddTriangle fts,7,3,4
AddTriangle fts,1,6,7
AddTriangle fts,1,7,4

;FirstStencilBBox = m
;	EndIf

Return m

End Function

Function AEntityScaleX#(Entity)

	S_Componentx# = GetMatElement(Entity, 0, 0)
	S_Componenty# = GetMatElement(Entity, 0, 1)
	S_Componentz# = GetMatElement(Entity, 0, 2)	
	Return Sqr(S_Componentx#*S_Componentx# + S_Componenty#*S_Componenty# + S_Componentz#*S_Componentz#)

End Function

Function AEntityScaley#(Entity)

	S_Componentx# = GetMatElement(Entity, 1, 0)
	S_Componenty# = GetMatElement(Entity, 1, 1)
	S_Componentz# = GetMatElement(Entity, 1, 2)
	Return Sqr(S_Componentx#*S_Componentx# + S_Componenty#*S_Componenty# + S_Componentz#*S_Componentz#)

End Function

Function AEntityScalez#(Entity)

	S_Componentx# = GetMatElement(Entity, 2, 0)
	S_Componenty# = GetMatElement(Entity, 2, 1)
	S_Componentz# = GetMatElement(Entity, 2, 2)
	Return Sqr(S_Componentx#*S_Componentx# + S_Componenty#*S_Componenty# + S_Componentz#*S_Componentz#)

End Function

Function AMaxEntityScale#(Entity)

Local S_scale#, S_scalex#, S_scaley#, S_scalez#

S_scalex#=aEntityScalex#(Entity)
S_scaley#=aEntityScaley#(Entity)
S_scalez#=aEntityScalez#(Entity)

If S_scalex# >= S_scaley#
S_scale# = S_scalex#
Else
If S_scaley# >= S_scalez#
S_scale# = S_scaley#
Else
S_scale# = S_scalez#
EndIf
EndIf

Return S_scale

End Function

Function StencilEntityHidden% (Entity)
Return 1 - (1 And Reti(  Entity +24))
End Function

Function AHideEntity% (Entity)
 WriteI(  Entity +24, 0)
 End Function

Function AGetEntityAlpha# (Entity)

Return retF#( Entity+352 )

End Function

 Function AShowEntity% (Entity)
 WriteI(  Entity +24, 257)
 End Function

Function  StencilNextEntity(entity)
Return Reti(  Entity +4)
End Function

Function  StencilLastEntity(entity)
Return Reti(  Entity +8)
End Function
;============================================================================================


Function S_FindALLChildren(Entity)  ;- function for finding all childrens

If list=0 Delete Each S_SEntityChildren
S_TotalParent=GetParent (Entity)
S_meshOld=Entity

While 1

If Not S_Peremeshenie

If S_ChildNamber
S_Itmesh=GetChild (S_meshOld, S_ChildNamber)
Else
S_Itmesh=GetChild (S_meshOld,1)
EndIf
If S_Itmesh

S_meshOld=S_Itmesh

If list=0
S_SEntityChild.S_SEntityChildren=New S_SEntityChildren
S_SEntityChild\Entity=S_Itmesh
Else
S_SEntityChild2.S_SEntityChildren=New S_SEntityChildren
S_SEntityChild2\Entity=S_Itmesh
EndIf


S_ChildNamber=0
Else
S_Peremeshenie=1
EndIf

Else

S_Peremeshenie=0
S_meshParentOld=GetParent (S_meshOld)

If  S_meshParentOld = S_TotalParent
S_SEntityChild.S_SEntityChildren=New S_SEntityChildren
S_SEntityChild\Entity=Entity
Exit
EndIf

S_Cn_countcm=CountChildren(S_meshParentOld)
For S_Cn_i=1 To S_Cn_countcm
If S_meshOld=GetChild( S_meshParentOld, S_Cn_i ) S_Cnum = S_Cn_i
Next

If S_Cnum=CountChildren(S_meshParentOld)
S_meshOld = S_meshParentOld
S_Peremeshenie =1
Else
S_meshOld = S_meshParentOld

S_ChildNamber=S_Cnum+1

EndIf

EndIf

Wend

End Function
;S_FindALLChildren(Entity)
;For S_SEntityChild.S_SEntityChildren=Each S_SEntityChildren
;Child =  S_SEntityChild\Entity
;Next

Function AStretchRect ( src_buffer, src_x,src_y,src_width,src_height, dest_buffer, dest_x,dest_y, dest_width,dest_height, Zbuffer=0 )
	SrcSurf =		reti(src_buffer+12);
	DescSurf =  	reti(dest_buffer+12)
	BBBlit (src_x,src_y,src_width,src_height, SrcSurf, DescSurf, dest_x,dest_y, dest_width,dest_height, Zbuffer)
End Function


;Version 0.7.5

;====================================[PostProcess System]====================================

; ==================[ -total- ]========================
Const BUMPENVMAP=0
Const BUMPENVMAPLUMINANCE=1

Global BUMPENVMAP_SUPPORT ; Variable for test supported BumpEnvMap shader type
Global BUMPENVMAPLUMINANCE_SUPPORT ; Variable for test supported BumpEnvMapLuminance shader type

Global Screen_texture ; texture which use all refracting entitis and rest effects
; ================================================

; ==================[ -Refract- ]======================
Global Ref_Refract_ON=1 ; enabling/disabling Refract
Global AlwaysUpdateTex = 0; Updating refractive Texture Always
Global PixelDistortionRenderMethod=1
;=================================================

; ==================[ -Glow- ]=======================
Global Ref_Glow_ON=0 ; enabling/disabling Glow
Global Ref_Glow_DarkPower= 4; pover range: 0-8
Global Ref_Glow_BlurPower=3; pover range: >0
Global Ref_CountBlSpr#=6 ; Count bluring sprites
Global Ref_BlSprAlpha#=0.2 ; bluring sprites Alpha  ( coorect value ~ 1/Ref_CountBlSpr )
Global Glow_Blend=0; Bleding-type for drawing glow quade: 0 - ADD(standart), 1 - ADD_SMOOTH(maxRGB)
Global Glow_Adaptive_Exposure = 0 ; Adaptive Eye for Bloom
Global Glow_HDR=0; HDR-rendering for scene( use with Glow_Adaptive_Exposure ! ) // Don't use this ;)
Global Glow_HDRBloom_OFF=0
Global Glow_HDR_AdaptivePower#= 0.5
Global Glow_HDR_min=30
Global Glow_HDR_max=255
Global Glow_HDR_multiply#=1
Global Glow_HDR_GreyFilter=0
Global Glow_Adaptive_Speed# = .1 ; Adaptive speed
;=================================================

; ==================[ -Blur- ]=========================
Global Ref_Blur_ON=0 ; enabling/disabling Blur
Global Blur_Alpha#=0.5 ; blur pover
Global Blur_RadialPower#=0.0 ; Radial bluring pover
;=================================================

; ==============[ -Depth of Field- ]======================
;CreateDOF ( camera, Near#=10, Far#=100, Direction=1,  Level=3, Blur#=0.35)
;Near - Start plane for DOF
;Far -   End plane for DOF
;Direction - Bluring Direction DOF-planes (Correct Value 1 or -1)
;Level - Count Bluring DOF-planes (Quality)
;Blur - Bluring Power

Global Ref_DOF ; enabling/disabling DOF
Global Ref_NearDOF# ; Working variable ( aka Near)
Global Ref_FarDOF#  ;Working variable ( aka Far)
Global Ref_DirectionDOF ;Working variable ( aka Direction)
Global Ref_PowerDOF# ;Working variable ( aka Blur)
;=================================================


;=============================================================
Type Ref_Mesh
 	Field MType
 	Field BumpTexture
 	Field meshSourse
 	Field mesh
 	Field mesh2
 	Field Hiden
 	Field Koef#
 	Field Alpha#
 	Field OffRefProcess
 	Field WaterStructHandle
 	Field LastX#,LastY#,LastZ#
End Type 
 
Type Ref_light 
 	Field entity 
 	Field range# 
 	Field scale# 
 	Field intensity# 
 	Field flicker# 
 	Field flickerrange# 
 	Field r#,g#,b# 
End Type 
Global Ref_brush


Global Refract_PixelDistortion=0
Global Refract_PixelDistortionQuade=0
Global Refract_BumpScale#= -0.2
Global BUMSHADERTYPE=0

Global PP_FrameCorrectID
Global CullModeFixMesh
Global Blur_Sprite
Global Ref_FXcam
Global Ref_GlowSysSpr
Global Ref_Glow
Global Ref_DOFSysSpr
Global Ref_RefractSysPivot
Global Ref_SystemCorrectedPiv
Global R_comx#=1
Global R_comy#=1
Global RefTexSize#=0
Global D_Width#
Global D_Height#
Global Ref_GlowSizeW# = 256
Global Ref_GlowSizeH# = 256
Global RGlowTexSize# = 256
Global RTexGlowCoordX# = 1
Global RTexGlowCoordY# = 1
Global RezGlowScrKoef#=1
Global Ref_GlowCompX#
Global Ref_GlowCompY#
Global Ref_Glow_Alpha# = 0.5
Global Ref_SmallBluringTex
Global Ref_SmallBluringTex2
Global Ref_SmallBluringTexFirst
Global Ref_AdaptateSysTex
Global Ref_AdaptateTexSize = 32
Global Ref_GlowColorMask#
Global Ref_Glow_OfffSet#
Global Ref_SceneGlowValue#
Global Glow_surface
Global Ref_drawMesh
Dim Ref_BloomSpr(36)
Dim Ref_BloomSpr2(36)
Global Ref_fms0
Global Ref_fms
Global Ref_fms2
Global Ref_SceneBloomSpr
Global Ref_SceneBloomSpr2
Global Ref_koef#
Global RezScreenKoef#
Global Ref_CamZn#
Global Ref_CamZf#
Global Ref_cameraFxLocal
Global Ref_QualityDOF
Global Ref_LevelDOF#

Dim Ref_DOFSpr(36)

	Type DOFSprites
		Field SprPiv
		Field Spr[36]
	End Type
	
Global Ref_DOFTexture1
Global Ref_DOFTexture2
Global Ref_Ocean
Global Ref_OceanRefract
Global Ref_OceanReflectTexture
Global Ref_OceanReflectiveW
Global Ref_OceanReflectiveH
Global Ref_CameraOFFSET# = 20000
Global Glow_CopyTexMethod=1 

Global RefLibInitialized=0
Global GlowInitialized=0
Global BlurInitialized=0
Global DOFInitialized
Global RefBrashCreated=0
Global  Refract_textureLast
Global  Refract_textureLast1
Global  Refract_textureLast2
Global  Screen_textureUpdated
Global Ref_copyW
Global Ref_copyH
;=============================================================

; Initialized PostProcess system, Width,Height - resolution for screen_texture(Change to resolution does not correct work with DOF)
Function PostProcessInit(Width#=0, Height#=0) 

InitShadowLib()

If  RefLibInitialized=0

Direct3D7=SystemProperty$("Direct3D7")
Direct3DDevice7=SystemProperty$("Direct3DDevice7")
DirectDraw7=SystemProperty$("DirectDraw7")
AppHWND=SystemProperty$("AppHWND")
AppHINSTANCE=SystemProperty$("AppHINSTANCE")
; If Not SetSystemProperties(Direct3D7,Direct3DDevice7,DirectDraw7,AppHWND,AppHINSTANCE) RuntimeError "ְ殮㮡"

If Width#=0 Or Height#=0
	
	Ref_copyW=GraphicsWidth()
	Ref_copyH=GraphicsHeight()
Else
	RezScrH#=Height
	RezScrW#=Width
	
	Ref_copyW=Width
	Ref_copyH=Height
EndIf

RezScrH#=GraphicsHeight()
RezScrW#=GraphicsWidth()
	
RezScreenKoef#= RezScrH / RezScrW


 If GraphicsWidth()<=512
 RefTexSize#=512
 ElseIf GraphicsWidth()<=1024
 RefTexSize#=1024
 ElseIf GraphicsWidth()<=2048
 RefTexSize#=2048
 ElseIf GraphicsWidth()>2048
 RefTexSize#=4096
 EndIf
 R_comx#= GraphicsWidth() / RefTexSize#;
 R_comy#= GraphicsHeight() / RefTexSize#;

 Screen_texture = CreateTexture( Ref_copyW, Ref_copyH, 256+48);
 CreateRenderTexture Screen_texture, Ref_copyW, Ref_copyH, 0
; CopyTarget (   reti(TextureBuffer(Screen_texture) + 12) , reti(BackBuffer() + 12) )

 ;Refract_textureLast2 = CreateTexture( RefTexSize, RefTexSize, 256);
Refract_textureLast1 = Screen_texture
Refract_textureLast=Refract_textureLast1

 Ref_brush = CreateBrush(255,255,255) 
 BrushBlend Ref_brush,1
 BrushFX Ref_brush,1+8
 TextureBlend Screen_texture,2
 BrushTexture Ref_brush,Screen_texture,0,0

 Ref_RefractSysPivot = CreatePivot()
 HideEntity Ref_RefractSysPivot
 CutEntity Ref_RefractSysPivot

CullModeFixMesh=CreateMesh(Ref_RefractSysPivot)
CMFMsurf = CreateSurface(CullModeFixMesh)
AddVertex  CMFMsurf, 0, 0, 0
EntityOrder CullModeFixMesh,-990
EntityFX CullModeFixMesh,1+8
EntityAlpha CullModeFixMesh,1
EntityBlend CullModeFixMesh,1

Refract_PixelDistortionQuade = CreateMesh(CullModeFixMesh)
	Ref_sf = CreateSurface( Refract_PixelDistortionQuade)
	AddVertex Ref_sf, -1, 1, 0,      0, 0
	AddVertex Ref_sf, 1, 1, 0,       0 ,1
	AddVertex Ref_sf, -1, -1, 0,     1, 0
	AddVertex Ref_sf, 1, -1, 0,      1, 1
HideEntity Refract_PixelDistortionQuade
 ;Ref_cameraFxLocal=CreateCamera()

 RefLibInitialized=1
 EndIf
End Function


Function CreateBlur ( camera, BlurPower#=0, RadialPower#=0)
PostProcessInit()
If BlurInitialized=0
Ref_Blur_ON=1
Blur_Alpha = BlurPower
Blur_RadialPower = RadialPower
InitRender()
Ref_CamZn# = RetF ( camera + 640)

Blur_Sprite = CreateMesh(camera)
	Ref_sf = CreateSurface( Blur_Sprite)
	AddVertex Ref_sf, -1, 1, 0,  0, 				                0
	AddVertex Ref_sf, 1, 1, 0,   1 ,  0
	AddVertex Ref_sf, -1, -1, 0, 0,  				                1
	AddVertex Ref_sf, 1, -1, 0,  1,   1
	AddTriangle Ref_sf, 0, 1, 2
	AddTriangle Ref_sf, 3, 2, 1

RezScrH#=GraphicsHeight()
RezScrW#=GraphicsWidth()
RezScreenKoef#= RezScrH / RezScrW

sprp# = (Ref_CamZn+10.0) / RezScrW


ScaleEntity  Blur_Sprite, Ref_CamZn+10., (Ref_CamZn+10)*RezScreenKoef, 1 ;ScaleMesh
PositionEntity  Blur_Sprite,-sprp#, sprp#, Ref_CamZn+10;PositionMesh
EntityTexture Blur_Sprite, Screen_texture
EntityFX Blur_Sprite,1+8
EntityOrder Blur_Sprite,-1
EntityAlpha Blur_Sprite, Alpha
EntityBlend Blur_Sprite,1
CreateReceiver Blur_Sprite,0

BlurInitialized=1
EndIf
End Function

Function FreeBlur ()
If BlurInitialized=1
 Deletereceiver Blur_Sprite
 FreeEntity Blur_Sprite
 Ref_Blur_ON=0
 Rend_InitRender=0
BlurInitialized=0
EndIf
End Function



; RGlowSizeW or RGlowSizeH:  0 - 512 (or correct size from screen resolution),   RGlow_OfffSet - Bluring size
Function CreateGlow ( camera, RGlowSizeW#=200, RGlowSizeH#=150, RGlow_OfffSet#=0.35, Alpha#=1)
PostProcessInit()
If GlowInitialized=0

InitRender()

;Ref_GlowCompX
 
Ref_Glow_Alpha# = Alpha
Ref_GlowSizeW = RGlowSizeW
Ref_GlowSizeH = RGlowSizeH
Ref_Glow_OfffSet = RGlow_OfffSet

RGlowTexSize=256

If RGlowSizeW<=16
RGlowTexSize=16
ElseIf RGlowSizeW<=32
RGlowTexSize=32
ElseIf RGlowSizeW<=64
RGlowTexSize=64
ElseIf RGlowSizeW<=128
RGlowTexSize=128
ElseIf RGlowSizeW<=256
RGlowTexSize=256
ElseIf RGlowSizeW<=512
RGlowTexSize=512
ElseIf RGlowSizeW<=1024
RGlowTexSize=1024
EndIf

RTexGlowCoordX# = (Ref_GlowSizeW)/RGlowTexSize
RTexGlowCoordY# = (Ref_GlowSizeH)/RGlowTexSize
RezGlowScrKoef# = Ref_GlowSizeH#/Ref_GlowSizeW#

 Ref_SmallBluringTex = CreateTexture( RGlowTexSize, RGlowTexSize,1 + 256)
  CreateRenderTexture Ref_SmallBluringTex, RGlowTexSize, RGlowTexSize, 0
 
 Ref_SmallBluringTex2 = CreateTexture( RGlowTexSize, RGlowTexSize,1 + 256)
 CreateRenderTexture Ref_SmallBluringTex2, RGlowTexSize, RGlowTexSize, 0

Ref_AdaptateSysTex = CreateTexture( Ref_AdaptateTexSize, Ref_AdaptateTexSize, 1)

If Glow_HDR
	Screen_TextureSystemRT2= CreateTexture( GraphicsWidth(), GraphicsHeight(), 256+48+1);
	CreateRenderTexture Screen_TextureSystemRT2, GraphicsWidth(), GraphicsHeight(), 0
	CopyTarget (   reti(TextureBuffer(Screen_TextureSystemRT2) + 12) , reti(BackBuffer() + 12) )
	TextureBlend Screen_TextureSystemRT2,5
	TextureCoords Screen_TextureSystemRT2,1
	ChangeRenderTarget (  RetI (TextureBuffer(Screen_TextureSystemRT2) + 12) )
EndIf
 
Ref_FXcam = CreateCamera()
CameraViewport Ref_FXcam, 0, 0, Ref_GlowSizeW, Ref_GlowSizeH
Ref_GlowSysSpr=CreatePivot(Ref_FXcam)
PositionEntity  Ref_GlowSysSpr, 0, 0, 1

sprpT# = 1.0/(RGlowTexSize)
sprpTMW# = 2.0/(Ref_GlowSizeW)
sprpTMH# = 2.0/(Ref_GlowSizeH)
sprpL# = 20.0/(RGlowTexSize)
sprpR# = 20.0/(RGlowTexSize)
 
 For Ref_i=0 To Ref_CountBlSpr-1
 
 Ref_BloomSpr(Ref_i) = CreateMesh(Ref_GlowSysSpr)

 
	Ref_sf = CreateSurface( Ref_BloomSpr(Ref_i))
	
	AddVertex Ref_sf, -1+sprpTMW, 1-sprpTMH, 0,   sprpT,  sprpT
	AddVertex Ref_sf, 1-sprpTMW, 1-sprpTMH, 0,    RTexGlowCoordX-sprpT , sprpT
	AddVertex Ref_sf, -1+sprpTMW, -1+sprpTMH, 0,  sprpT,  RTexGlowCoordY-sprpT
	AddVertex Ref_sf, 1-sprpTMW, -1+sprpTMH, 0,   RTexGlowCoordX-sprpT,  RTexGlowCoordY-sprpT
	
;	AddVertex Ref_sf, -1, 1, 0,   0 ,  0
;	AddVertex Ref_sf, 1, 1, 0,    RTexGlowCoordX ,  0
;	AddVertex Ref_sf, -1, -1, 0, 0 ,  RTexGlowCoordY
;	AddVertex Ref_sf, 1, -1, 0,   RTexGlowCoordX ,  RTexGlowCoordY
	
	AddTriangle Ref_sf, 0, 1, 2
	AddTriangle Ref_sf, 3, 2, 1

ScaleEntity  Ref_BloomSpr(Ref_i), 20, 20*RezGlowScrKoef, 1
 Ref_BlAngle#=Ref_BlAngle#+360/Ref_CountBlSpr
MoveEntity  Ref_BloomSpr(Ref_i),Cos#(Ref_BlAngle#) *Ref_Glow_OfffSet - sprpTMW*10.0 ,Sin#(Ref_BlAngle#)*Ref_Glow_OfffSet + sprpTMH*10.0 , 19

EntityTexture Ref_BloomSpr(Ref_i), Ref_SmallBluringTex2

EntityFX Ref_BloomSpr(Ref_i),17+8
EntityOrder Ref_BloomSpr(Ref_i),-100
EntityBlend Ref_BloomSpr(Ref_i),3
EntityAlpha Ref_BloomSpr(Ref_i), Ref_BlSprAlpha
EntityColor Ref_BloomSpr(Ref_i),0,0,0;255,255,255

Next

Ref_CamZn# = RetF ( camera + 640)

 Ref_fms0 = CreateMesh(Ref_GlowSysSpr)
	Ref_sf = CreateSurface( Ref_fms0)
	
;	AddVertex Ref_sf, -1, 1, 0,  0, 				                0
;	AddVertex Ref_sf, 1, 1, 0,   GraphicsWidth()/RefTexSize ,  0
;	AddVertex Ref_sf, -1, -1, 0, 0,  				                GraphicsHeight()/RefTexSize
;	AddVertex Ref_sf, 1, -1, 0,  GraphicsWidth()/RefTexSize ,   GraphicsHeight()/RefTexSize
	AddVertex Ref_sf, -1, 1, 0,  0, 				                0
	AddVertex Ref_sf, 1, 1, 0,   1 ,  0
	AddVertex Ref_sf, -1, -1, 0, 0,  				                1
	AddVertex Ref_sf, 1, -1, 0,  1 ,   1
	
	AddTriangle Ref_sf, 0, 1, 2
	AddTriangle Ref_sf, 3, 2, 1
EntityTexture Ref_fms0, Screen_texture;Ref_SmallBluringTex ;Screen_texture;
EntityFX Ref_fms0,17+8
EntityOrder Ref_fms0,-99
EntityBlend Ref_fms0,3
EntityAlpha Ref_fms0, 0
ScaleEntity  Ref_fms0, 20, 20*RezGlowScrKoef , 1
PositionEntity  Ref_fms0, 0, 0, 19


 Ref_fms = CreateMesh(Ref_GlowSysSpr)
	Ref_sf = CreateSurface( Ref_fms)
	
	AddVertex Ref_sf, -1, 1, 0,   0 ,  0
	AddVertex Ref_sf, 1, 1, 0,    RTexGlowCoordX ,  0
	AddVertex Ref_sf, -1, -1, 0, 0 ,  RTexGlowCoordY
	AddVertex Ref_sf, 1, -1, 0,   RTexGlowCoordX ,  RTexGlowCoordY
	AddTriangle Ref_sf, 0, 1, 2
	AddTriangle Ref_sf, 3, 2, 1


If Ref_Glow_DarkPower>8 Ref_Glow_DarkPower=8
If Ref_Glow_DarkPower<0 Ref_Glow_DarkPower=0

Ref_fms2=CopyEntity( Ref_fms, Ref_fms)

For Ref_i=0 To Ref_Glow_DarkPower-1
EntityTexture Ref_fms, Ref_SmallBluringTex, 0, Ref_i
Next

If Ref_Glow_DarkPower=0 HideEntity Ref_fms

EntityFX Ref_fms,17+8
EntityOrder Ref_fms,-99
EntityBlend Ref_fms,2
EntityAlpha Ref_fms, 0
ScaleEntity  Ref_fms, 20, 20*RezGlowScrKoef, 1

PositionEntity  Ref_fms, -20/(Ref_GlowSizeW), 20/(Ref_GlowSizeH), 19
EntityBlend Ref_fms2,3
EntityTexture Ref_fms2, Ref_SmallBluringTex2
;MoveEntity  Ref_fms2, 0., 0., 0
EntityAlpha Ref_fms2, 0
;EntityColor Ref_fms2, 300, 300, 300

CameraProjMode Ref_FXcam,0
HideEntity Ref_FXcam

Ref_SceneBloomSpr= CreateMesh(Ref_FXcam);camera)
 
RezScrH#=GraphicsHeight()
RezScrW#=GraphicsWidth()
RezScreenKoef#= RezScrH# / RezScrW#

sprpW#=	(Ref_CamZn+10) / GraphicsWidth() ;(512/RezScrW# )*0.02*0*Ref_CamZn
sprpH#=	(Ref_CamZn+10) / GraphicsWidth();/GraphicsHeight() 

	Ref_sf = CreateSurface( Ref_SceneBloomSpr )

;	AddVertex Ref_sf, -1+sprpTMW, 1-sprpTMH, 0,   sprpT,  sprpT
;	AddVertex Ref_sf, 1-sprpTMW, 1-sprpTMH, 0,    RTexGlowCoordX-sprpT , sprpT
;	AddVertex Ref_sf, -1+sprpTMW, -1+sprpTMH, 0,  sprpT,  RTexGlowCoordY-sprpT
;	AddVertex Ref_sf, 1-sprpTMW, -1+sprpTMH, 0,   RTexGlowCoordX,  RTexGlowCoordY-sprpT

	AddVertex Ref_sf, -1, 1, 0,   0 ,  0
	VertexTexCoords  Ref_sf, 0 ,0,0,1, 1
	AddVertex Ref_sf, 1, 1, 0,    RTexGlowCoordX ,  0
	VertexTexCoords  Ref_sf, 1 ,1,0,1, 1
	AddVertex Ref_sf, -1, -1, 0, 0 ,  RTexGlowCoordY
	VertexTexCoords  Ref_sf, 2 ,0,1,1, 1
	AddVertex Ref_sf, 1, -1, 0,   RTexGlowCoordX ,  RTexGlowCoordY
	VertexTexCoords  Ref_sf, 3 ,1, 1,1, 1
	
Glow_mesh = CreateMesh(Ref_SceneBloomSpr)
HideEntity Glow_mesh
Glow_surface = CreateSurface( Glow_mesh )
	AddVertex Glow_surface, -1, 1, 0,   0 ,  0
	VertexTexCoords  Glow_surface, 0 ,0,0,1, 1
	AddVertex Glow_surface, 1, 1, 0,    RTexGlowCoordX ,  0
	VertexTexCoords  Glow_surface, 1 ,1,0,1, 1
	AddVertex Glow_surface, -1, -1, 0, 0 ,  RTexGlowCoordY
	VertexTexCoords  Glow_surface, 2 ,0,1,1, 1
	AddVertex Glow_surface, 1, -1, 0,   RTexGlowCoordX ,  RTexGlowCoordY
	VertexTexCoords  Glow_surface, 3 ,1, 1,1, 1

	AddTriangle Glow_surface, 0, 1, 2
	AddTriangle Glow_surface, 3, 2, 1

PositionEntity  Ref_SceneBloomSpr,-sprpW#, sprpH#, Ref_CamZn+10.
ScaleEntity  Ref_SceneBloomSpr, Ref_CamZn+10, (Ref_CamZn+10)*RezScreenKoef, 1
EntityTexture Ref_SceneBloomSpr, Ref_SmallBluringTex2
EntityFX Ref_SceneBloomSpr,1+8
EntityOrder Ref_SceneBloomSpr,-100
EntityBlend Ref_SceneBloomSpr,3
EntityAlpha Ref_SceneBloomSpr, 0

HideEntity Ref_SceneBloomSpr

Ref_Glow_ON=1
GlowInitialized=1
EndIf

End Function

Function FreeGlow ()
If GlowInitialized=1
DelRT_rez = DeleteRenderTarget (  reti(TextureBuffer(Ref_SmallBluringTex)+12) )
; If DelRT_rez=0 RuntimeError "sfsf"
;FreeRender Ref_SmallBluringTex
FreeTexture Ref_SmallBluringTex
Ref_SmallBluringTex=0

DeleteRenderTarget (  reti(TextureBuffer(Ref_SmallBluringTex2)+12) )
;FreeRender Ref_SmallBluringTex2
 FreeTexture Ref_SmallBluringTex2
 Ref_SmallBluringTex2=0

 FreeTexture Ref_AdaptateSysTex

 FreeEntity Ref_SceneBloomSpr
 Ref_SceneBloomSpr=0
 
 FreeEntity Ref_FXcam
 Ref_FXcam=0

Ref_Glow_ON=0
GlowInitialized=0
Rend_InitRender=0
EndIf

End Function



;Depth of Field effect
Function CreateDOF ( camera, Near#=10, Far#=100, Direction=1,  Level=3, Blur#=0.35)
Local Dest#, Pos#,sprp#

PostProcessInit()

If DOFInitialized=0

If camera=0 RuntimeError "«, 樠, 롬汻 !"

Ref_DOF=1

Ref_DirectionDOF = Direction
Ref_LevelDOF# = Level
Ref_NearDOF# = Near
Ref_FarDOF# = Far
Ref_PowerDOF# = Blur
Ref_DOFSysSpr = CreatePivot()

For Ref_i=1 To Level

	Ref_DOFSpr(Ref_i) = CreatePivot(Ref_DOFSysSpr)
	Dest# = Dest + (Far-Near) / (Ref_LevelDOF)

	Pos# = (Far - Dest)

	sprp# = Pos# / Float( GraphicsWidth() )

	PositionEntity	Ref_DOFSpr(Ref_i), -sprp, sprp, Pos
	ScaleEntity		Ref_DOFSpr(Ref_i), Pos, Pos * RezScreenKoef , 0
	
Next

DOFInitialized=1

EndIf

End Function

Function FreeDOF ( )

If DOFInitialized

FreeEntity Ref_DOFSysSpr
Ref_DOF=0
DOFInitialized=0

EndIf

End Function



; Creating Pixel Distortion
Function CreatePixelDistortion( )
PostProcessInit()

Refract_PixelDistortion = 1

Screen_TextureSystemRT1= CreateTexture( GraphicsWidth(), GraphicsHeight(), 256+48);

CreateRenderTexture Screen_TextureSystemRT1, GraphicsWidth(), GraphicsHeight(), 0

;CopyTarget (   reti(TextureBuffer(Screen_TextureSystemRT1) + 12) , reti(BackBuffer() + 12) )

TextureBlend Screen_TextureSystemRT1,1

End Function


Function SetBumpShader ( BumpShader, BumpScale# )
BUMSHADERTYPE = BumpShader
Refract_BumpScale# = BumpScale
End Function
;BumpShader:
;  0 - BUMPENVMAP
;  1 - BUMPENVMAPLUMINANCE
;BumpScale: [0,1]

Function SetRefractMode( Mode ) 
Refract_PixelDistortion = Mode
End Function
; mode:
;	0 - Vertex Distortion
;	1 - Pixel Distortion




Function CreateRefractMesh(mesh,Ref_koef#=1,mesh2=0, Texture=0)
Local child

If RefLibInitialized=0
 PostProcessInit
 EndIf

 

 RefMesh.Ref_Mesh = New Ref_Mesh
 RefMesh\meshSourse = mesh
 child = reti(mesh+16)
 writei(mesh+16, 0 )  
 RefMesh\mesh = CopyEntity(mesh, Ref_RefractSysPivot)
 writei(mesh+16, child )  
  RefMesh\mesh2 = mesh2
 ;HideEntity RefMesh\mesh
PaintEntity RefMesh\mesh,Ref_brush
EntityBlend RefMesh\mesh,1
EntityFX RefMesh\mesh,1+8
EntityTexture RefMesh\mesh,Screen_texture,0,0
EntityTexture  RefMesh\mesh,No_texture,0,4
EntityTexture  RefMesh\mesh,No_texture,0,1
EntityTexture  RefMesh\mesh,No_texture,0,2
EntityTexture  RefMesh\mesh,No_texture,0,5

EntityColor RefMesh\mesh, 128, 128, 128
;EntityAlpha mesh,0

If Texture 
 	RefMesh\BumpTexture = 1
	EntityFX RefMesh\mesh,1
	EntityTexture RefMesh\mesh,Texture, 0, 0
	RefMesh\Alpha = .5
EndIf

writei (RefMesh\mesh + S_ShadowStructOffset, Handle( RefMesh.Ref_Mesh) )

  RefMesh\Koef#=Ref_koef#
Return RefMesh\mesh
 
End Function 

Function CreateRefractWater(mesh,Ref_koef#=1,mesh2=0, Texture=0)
Local child

If RefLibInitialized=0
 PostProcessInit
 EndIf
 
 RefMesh.Ref_Mesh = New Ref_Mesh 
  RefMesh\meshSourse = mesh
  child = reti(mesh+16)
 writei(mesh+16, 0 )  
 RefMesh\mesh = CopyEntity(mesh, Ref_RefractSysPivot)
 writei(mesh+16, child )  
 RefMesh\mesh2 = mesh2
  RefMesh\MType=1
;PaintEntity RefMesh\mesh,Ref_brush
EntityBlend RefMesh\mesh,1
EntityTexture RefMesh\mesh,Screen_texture,0,0
EntityTexture  RefMesh\mesh,No_texture,0,4
EntityTexture  RefMesh\mesh,No_texture,0,1
EntityTexture  RefMesh\mesh,No_texture,0,2
EntityTexture  RefMesh\mesh,No_texture,0,5
EntityFX RefMesh\mesh,16+1
;EntityAlpha mesh,0

EntityColor RefMesh\mesh, 128, 128, 128
 
If Texture 
 	RefMesh\BumpTexture = 1
	EntityFX RefMesh\mesh,1
	EntityTexture RefMesh\mesh,Texture, 0, 0
	RefMesh\Alpha = .5
EndIf

writei (RefMesh\mesh + S_ShadowStructOffset, Handle( RefMesh.Ref_Mesh) )

  RefMesh\Koef#=Ref_koef#
Return RefMesh\mesh ;Handle( RefMesh.Ref_Mesh);
 
End Function


Function CreateRefSunRays(mesh, Alpha#=1)
 RefMesh.Ref_Mesh = New Ref_Mesh 
 RefMesh\mesh = mesh
  RefMesh\Alpha# =(1 - Alpha)
RefMesh\OffRefProcess=1
End Function

Function SetRefractMesh(mesh,Ref_koef#) 
 For RefMesh.Ref_Mesh = Each Ref_Mesh 
 If mesh=RefMesh\meshSourse  RefMesh\Koef#=Ref_koef#
Next
End Function 

Function DeleteRefractObject( mesh ) 
 For RefMesh.Ref_Mesh = Each Ref_Mesh 
 	If mesh=RefMesh\meshSourse
		FreeEntity RefMesh\mesh
		Delete RefMesh.Ref_Mesh
	EndIf
Next
End Function


Function SetRefractBumpTexture(mesh, Texture, frame = 0 , index = 0 ) 
 For RefMesh.Ref_Mesh = Each Ref_Mesh 
 	If mesh = RefMesh\meshSourse
 	RefMesh\BumpTexture = 1
 	If Texture EntityTexture RefMesh\mesh,Texture, frame, index
	EntityColor RefMesh\mesh, 255, 255, 127
	RefMesh\Alpha = 0.5
 	EndIf
Next
End Function

Function SetRefractPower(mesh, Power# ) 
 For RefMesh.Ref_Mesh = Each Ref_Mesh 
 	If mesh = RefMesh\meshSourse
 	RefMesh\Alpha = 1-Power#
 	EndIf
Next
End Function

Function SetRefractLuminance(mesh, Luminance# ) 
 For RefMesh.Ref_Mesh = Each Ref_Mesh 
 	If mesh = RefMesh\meshSourse
		If RefMesh\BumpTexture<>0
			EntityColor RefMesh\mesh, 255, 255, Int(Luminance#*127.5)
		Else
			EntityColor RefMesh\mesh, Int(Luminance#*127.5), Int(Luminance#*127.5), Int(Luminance#*127.5)
		EndIf
 	EndIf
Next
End Function

 
Function Refract_Free() 
 
 For RefMesh.Ref_Mesh = Each Ref_Mesh 
  FreeEntity RefMesh\mesh 
  Delete RefMesh 
 Next 
 
End Function 



Function UpdateRefract(camera)

PostProcessInit

If Ref_Refract_ON

Local light,x#,y#,z#,n_surfs,surf,vert,mesh,n_verts,s,u#,v#,Pich#,yaw#,nlx1#,nly1#,nlz1#,Lx#,Ly#,Lz#,Cx#,Cy#,Cz#,Prodx#,Prody#

RCam_W#=Reti(  camera +588);AGetCameraViewportWidth(camera)
RCam_H#=Reti(  camera +592);AGetCameraViewportHeight(camera)
RCam_Zoom#=retF( camera + 576)
;Ref_koef#=5


TFormNormal 0,0,1,camera,0
nCx1#=TFormedX()
nCy1#=TFormedY()
nCz1#=TFormedZ()
D_Clx#=EntityX(camera,1)
D_Cly#=EntityY(camera,1)
D_Clz#=EntityZ(camera,1)

Ref_drawMesh=0

 For RefMesh.Ref_Mesh = Each Ref_Mesh
  mesh = RefMesh\meshSourse
  mesh2=RefMesh\mesh2

If EntityInView(mesh,camera) And (1 - (1 And Reti(  mesh +24)))=0 And RefMesh\OffRefProcess=0

If EntityHide(mesh)=0
 RefMesh\Hiden=0
 BBCopyEntityMatrix ( mesh, RefMesh\mesh, 0 )

;	If Refract_PixelDistortion
If RefMesh\BumpTexture<>0 And Refract_PixelDistortion
		Ref_drawMesh=1
;		EndIf
Else

Ref_drawMesh=1

D_scalex#=dEntityScalex#(mesh)
D_scaley#=dEntityScaley#(mesh)
D_scalez#=dEntityScalez#(mesh)
D_scale#=(D_scalex+D_scaley+D_scalez)/3

Ref_koef#= RefMesh\Koef#; / D_scale#

  n_surfs = CountSurfaces(mesh)
  For s = 1 To n_surfs 
   surf = GetSurface(mesh,s)
 If mesh2 surf2 = GetSurface(mesh2,s)
   n_verts = CountVertices(surf)-1 
   For vert = 0 To n_verts

If RefMesh\MType=0

TFormPoint VertexX(surf,vert),VertexY(surf,vert),VertexZ(surf,vert),mesh,0
Ref_Vx#=TFormedX()
Ref_Vy#=TFormedY()
Ref_Vz#=TFormedZ()
;EndIf

If Not Ref_koef=0

TFormNormal VertexNX(surf,vert),VertexNY(surf,vert),VertexNZ(surf,vert),mesh,0
Ref_Vnx#=TFormedX()
Ref_Vny#=TFormedY()
Ref_Vnz#=TFormedZ()

If mesh2
Ref_Vx#= (Ref_Vx#) - Ref_koef# * (VertexX(surf2,vert) - VertexX(surf,vert)) * (Ref_Vnx); 
Ref_Vy#= (Ref_Vy#) - Ref_koef#* (VertexY(surf2,vert) - VertexY(surf,vert)) * (Ref_Vny) ;
Ref_Vz#= (Ref_Vz#) - Ref_koef# * (VertexZ(surf2,vert) - VertexZ(surf,vert)) * (Ref_Vnz); 

Else

Ref_Vx#= (Ref_Vx#) - Ref_koef# * (Ref_Vnx);
Ref_Vy#= (Ref_Vy#) - Ref_koef#* (Ref_Vny) 
Ref_Vz#= (Ref_Vz#) - Ref_koef# * (Ref_Vnz); 

EndIf

EndIf

Else

 If mesh2
Ref_Vx#=VertexX(surf2,vert)*D_scalex# +  EntityX(mesh,1)
Ref_Vy#=VertexY(surf,vert)*(Ref_koef#-1)*D_scaley#  +  EntityY(mesh,1)
Ref_Vz#=VertexZ(surf2,vert)*D_scalez# +  EntityZ(mesh,1)
 Else
Ref_Vx#=VertexX(surf,vert)*D_scalex# +  EntityX(mesh,1)
Ref_Vy#=VertexY(surf,vert)*(Ref_koef#-1)*D_scaley#  +  EntityY(mesh,1)
Ref_Vz#=VertexZ(surf,vert)*D_scalez# +  EntityZ(mesh,1)
 EndIf


EndIf


CameraProject camera,Ref_Vx#,Ref_Vy#,Ref_Vz#
Prodx#=ProjectedX( )
Prody#=ProjectedY( )
;If ProjectedX( )>0 And ProjectedY( )>0
;
;If Prodx<1 Prodx=1
;If Prody<1 Prody=1
;If Prodx>RCam_W Prodx=RCam_W-1
;If Prody>RCam_H Prody=RCam_H-1



Ref_u#=( Prodx# /  RCam_W# );  * R_comx# ;
Ref_v#=( Prody# /  RCam_H# );  *R_comy#  ;

VertexTexCoords  surf,vert,Ref_u,Ref_v

   Next
   Next

EndIf

	 Else
	 RefMesh\Hiden=1
	 EndIf

  EndIf

Next

EndIf

End Function

; Render all enabled post-process effects
Function PostProcess_Render(camera, tween#=1 )
Local Ref_AlphaBlend, Ref_Cull, Ref_Zwrite, Ref_FogColorR#, Ref_FogColorG#, Ref_FogColorB#, Ref_Fog, Refract_VertexDistortionPASS

PP_FrameCorrectID = 1

RCam_X#=Reti(  camera +580)
RCam_Y#=Reti(  camera +584)
RCam_W#=Reti(  camera +588)
RCam_H#=Reti(  camera +592)
RCam_Zoom#=retF( camera + 576)
Ref_CamZn# = RetF ( camera + 640)
Ref_CamZf# = RetF ( camera + 644)
sprp# = (Ref_CamZn+10.0) / Float( GraphicsWidth() )


If BlurInitialized
	If Ref_Blur_ON
		ShowEntity Blur_Sprite
		EntityAlpha Blur_Sprite, Blur_Alpha
		ScaleEntity  Blur_Sprite,( Ref_CamZn#+10 + Blur_RadialPower)/RCam_Zoom#, (Ref_CamZn#+10+ Blur_RadialPower)/RCam_Zoom#*RezScreenKoef#, 1
;		If Glow_HDR
;			EntityTexture Blur_Sprite, Screen_RefractTextureRT2
;		Else
			EntityTexture Blur_Sprite, Screen_texture
;		EndIf
		RenderEntity (Blur_Sprite, camera)
		HideEntity Blur_Sprite
	Else
		HideEntity Blur_Sprite
	EndIf
EndIf


AUpdateWater (camera, tween#)


If  Screen_textureUpdated=0
If ( Ref_drawMesh Or AlwaysUpdateTex Or (Ref_Blur_ON And  Blur_Alpha>0 And BlurInitialized)  Or (Ref_DOF And DOFInitialized) )
	If Glow_HDR
;		AStretchRect BackBuffer(), 0,0,GraphicsWidth(),GraphicsHeight(),  TextureBuffer(Screen_TextureSystemRT2), 0,0,Ref_copyW ,Ref_copyH
		AStretchRect TextureBuffer(Screen_TextureSystemRT2), 0,0,GraphicsWidth(),GraphicsHeight(),  TextureBuffer(Screen_texture), 0,0,Ref_copyW ,Ref_copyH
	Else
		AStretchRect BackBuffer(), 0,0,GraphicsWidth(),GraphicsHeight(),  TextureBuffer(Screen_texture), 0,0,Ref_copyW ,Ref_copyH
	EndIf
	Ref_CopyTexPass=1
	Screen_textureUpdated=1
EndIf
EndIf

UpdateDOF( camera  )


;If BlurInitialized HideEntity Blur_Sprite


If Ref_drawMesh=1; 
Ref_cameraLastX# = EntityX(camera,1)
Ref_cameraLastY# = EntityY(camera,1)
Ref_cameraLastZ# = EntityZ(camera,1)


PositionEntity CullModeFixMesh,EntityX(camera,1),EntityY(camera,1),EntityZ(camera,1),1
RotateEntity CullModeFixMesh, EntityPitch(camera,1), EntityYaw(camera,1), EntityRoll(camera,1),1
ShowEntity CullModeFixMesh
ScaleEntity  CullModeFixMesh, ( Ref_CamZn#+10)/RCam_Zoom#, (Ref_CamZn#+10)/RCam_Zoom#*RezScreenKoef#, 1
MoveEntity  CullModeFixMesh,-sprp#, sprp#, Ref_CamZn+10

Refract_PixelDistortionPASS=0
Refract_VertexDistortionPASS=0

If Ref_Refract_ON

ShowEntity Ref_RefractSysPivot

TextureBlend Screen_texture,5

;	For RefMesh.Ref_Mesh = Each Ref_Mesh 
;		  RefEntity = RefMesh\mesh
;		If RefMesh\Hiden=0
;				If RefMesh\BumpTexture=0
;					Refract_VertexDistortionPASS=1
;					ShowEntity RefEntity
;					EntityAlpha RefEntity,1
;				Else
;					HideEntity RefEntity
;				EndIf
;		EndIf
;	Next

CameraClsMode camera,0,0
;If Refract_VertexDistortionPASS=1
;	 RenderEntity (Ref_RefractSysPivot, camera) ; *************************************************************************************************************
;EndIf


 For RefMesh.Ref_Mesh = Each Ref_Mesh 
  RefEntity = RefMesh\mesh
If RefMesh\Hiden=0
	If Refract_PixelDistortion

 		If RefMesh\BumpTexture<>0
 			ShowEntity RefEntity
			Refract_PixelDistortionPASS=1
			EntityAlpha RefEntity,1 -  RefMesh\Alpha#
		Else
			HideEntity RefEntity
 		EndIf
	Else
 		If RefMesh\BumpTexture=0
			ShowEntity RefEntity
			EntityAlpha RefEntity,1 ;-  RefMesh\Alpha#
		Else
			HideEntity RefEntity
		EndIf
	EndIf
EndIf

Next

EndIf


If Refract_PixelDistortion = 1 And Screen_TextureSystemRT1>0 And Refract_PixelDistortionPASS=1

Ref_OldBuff=BBGetRenderTarget ( )

ChangeRenderTarget  (  RetI (TextureBuffer(Screen_TextureSystemRT1) + 12) )

BBClear($00000001, AD3DCOLOR ( 127, 127, 128) , 1 ,0)


If PixelDistortionRenderMethod=0
	BBClear($00000004, $4080f0, 1,0)
	BBSetRenderState(52,1)
	BBSetRenderState(57, 1 )
	BBSetRenderState(58,$ffffffff)
	BBSetRenderState(59,$ffffffff)
	BBSetRenderState(55, 3);
	BBSetRenderState(54, 1); 
	BBSetRenderState(53, 1);
	BBSetRenderState(56, 8)
EndIf


EndIf

;BBSetRenderState 27,0
; RenderWorld()
 RenderEntity (Ref_RefractSysPivot, camera) ; *************************************************************************************************************
CameraClsMode camera,1,1

If Refract_PixelDistortion = 1 And Screen_TextureSystemRT1>0 And Refract_PixelDistortionPASS=1

ChangeRenderTarget   (  Ref_OldBuff )


Ref_Fog=BBGetRenderState(28)
BBSetRenderState ( 28, 0 )

BBSaveTextureStates (0)
BBSaveTextureStates (1)
BBSaveTextureMatrix (16)
BBSaveTextureMatrix (17)

BBBeginScene
	
Ref_AlphaBlend = BBGetRenderState(27)
Ref_Cull =BBGetRenderState(22)
Ref_Zwrite =BBGetRenderState(14)
	BBSetRenderState 27,0

BBSetTexture  0 , reti( TextureBuffer(Screen_TextureSystemRT1)+12)
;If Glow_HDR
;	BBSetTexture  1 , reti( TextureBuffer(Screen_TextureSystemRT2)+12)
;Else
	BBSetTexture  1 , reti( TextureBuffer(Screen_texture)+12)
;EndIf

BBSetBumpMatrix (  0, 0,0, 0)
BBSetBumpMatrix (  0, 0,1, 0)
BBSetBumpMatrix (  0, 1,0, 0)
BBSetBumpMatrix (  0, 1,1, 0)
BBSetProjectionShader ( 0  , -RezScreenKoef#, 1, RCam_Zoom)
BBSetBumpShaderStages (  0, BUMSHADERTYPE )
BBSetTextureStageState 0,4,1
BBSetBumpMatrix (  0, 0,0, -Refract_BumpScale#)
BBSetBumpMatrix (  0, 0,1, -Refract_BumpScale)
BBSetBumpMatrix (  0, 1,0, 0)
BBSetBumpMatrix (  0, 1,1, Refract_BumpScale#)
BBSetProjectionShader ( 1  , -RezScreenKoef#, 1, RCam_Zoom)
BBSetTextureStageState 1,12,3
If BUMSHADERTYPE=1
	BBSetTextureStageState 1,1,5
Else
	BBSetTextureStageState 1,1,2
EndIf

BBSetTextureStageState 1,4,1


BBSetTextureStageState 2,1,1
BBSetTextureStageState 3,1,1
BBSetTextureStageState 4,1,1
BBSetTextureStageState 5,1,1
BBSetTextureStageState 6,1,1
BBSetTextureStageState 7,1,1

BBSetTextureStageState 2,4,1
BBSetTextureStageState 3,4,1
BBSetTextureStageState 4,4,1
BBSetTextureStageState 5,4,1
BBSetTextureStageState 6,4,1
BBSetTextureStageState 7,4,1

If PixelDistortionRenderMethod=1


	BBClear($00000004, $4080f0, 1,0)
	BBSetRenderState(52,1)
	BBSetRenderState(57, 1 )
	BBSetRenderState(58,$ffffffff)
	BBSetRenderState(59,$ffffffff)
	BBSetRenderState(55, 3);
	BBSetRenderState(54, 1); 
	BBSetRenderState(53, 1);
	BBSetRenderState(56, 6);
	BBSetRenderState 137,0
	BBSetRenderState 7,1
	BBSetRenderState 14,1

	ARest_BMAT=0
	
For RefMesh.Ref_Mesh = Each Ref_Mesh 
 RefEntity = RefMesh\mesh
  If RefMesh\Hiden=0 And RefMesh\BumpTexture<>0
	BBSetEntityTransformMatrix (  RefEntity, 0 )
	
	If RefMesh\MType=1
		BBSetRenderState 22,1
	Else
		BBSetRenderState 22,3
	EndIf

	If RefMesh\WaterStructHandle<>0
		WaterRender.AWaters = Object.AWaters( RefMesh\WaterStructHandle )
		BumpPower#=WaterRender\BumpPower
		If WaterRender\BumpDestCorrectOFF=0
			BumpPowerDestCorrect# = BumpPower# / (WaterRender\DestWaterToCam#*0.015);  / (BumpSU#+BumpSV#)/2)
			If BumpPowerDestCorrect#>BumpPower# 	BumpPowerDestCorrect#=BumpPower#
		Else
			BumpPowerDestCorrect# = BumpPower#
		EndIf
		BBSetBumpMatrix (  0, 0,0, BumpPowerDestCorrect#)
		BBSetBumpMatrix (  0, 0,1, 0)
		BBSetBumpMatrix (  0, 1,0, 0)
		BBSetBumpMatrix (  0, 1,1, BumpPowerDestCorrect#)
		BBSetProjectionShader ( 1  , -RezScreenKoef#, 1, RCam_Zoom)
		ARest_BMAT = 1
	Else
			If ARest_BMAT
				BBSetBumpMatrix (  0, 0,0, Refract_BumpScale#)
				BBSetBumpMatrix (  0, 0,1, 0)
				BBSetBumpMatrix (  0, 1,0, 0)
				BBSetBumpMatrix (  0, 1,1, Refract_BumpScale#)
				BBSetProjectionShader ( 1  , -RezScreenKoef#, 1, RCam_Zoom)
				ARest_BMAT=0
			EndIf
	EndIf
	
	For Ref_sf_i=1 To CountSurfaces(RefEntity)
	 Ref_sf = GetSurface(RefEntity, Ref_sf_i)
	 BBDrawSurface ( Ref_sf)
	Next


	
  EndIf
Next

Else
	BBSetRenderState(52,1)
	BBSetRenderState(57, 1 )
	BBSetRenderState(55, 1);
	BBSetRenderState(54, 1); 
	BBSetRenderState(53, 1);
	BBSetRenderState(56, 3);
	BBSetRenderState 137,0
	BBSetRenderState 7,0
	BBSetRenderState 14,0

	BBSetEntityTransformMatrix (  CullModeFixMesh, 0 )
	
	BBDrawPrimitive ( 5, reti(GetSurface(Refract_PixelDistortionQuade,1)+28)  , 4 ,0)
EndIf

	BBSetRenderState(52,0)
	BBSetRenderState 137,1
	BBSetRenderState 27,Ref_AlphaBlend
	BBSetRenderState 7,1
	BBSetRenderState 14,Ref_Zwrite
	BBSetRenderState 22,Ref_Cull
	BBSetRenderState ( 28, Ref_Fog )
	
BBEndScene

BBLoadTextureStates (0)
BBLoadTextureStates (1)
BBLoadTextureMatrix (16)
BBLoadTextureMatrix (17)


EndIf

PositionTexture Screen_texture, 0,0
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	For RefMesh.Ref_Mesh = Each Ref_Mesh 
		  RefEntity = RefMesh\mesh
		If RefMesh\Hiden=0
				If RefMesh\BumpTexture=0
					Refract_VertexDistortionPASS=1
					ShowEntity RefEntity
					EntityAlpha RefEntity,1
				Else
					HideEntity RefEntity
				EndIf
		EndIf
	Next
If Refract_VertexDistortionPASS=1
	CameraClsMode camera,0,0
    RenderEntity (Ref_RefractSysPivot, camera) ; *************************************************************************************************************
    CameraClsMode camera,1,1
EndIf
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HideEntity CullModeFixMesh
HideEntity Ref_RefractSysPivot

TextureBlend Screen_texture,2

EndIf


UpdateGlow( camera, Glow_CopyTexMethod);


Screen_textureUpdated = 0

PP_FrameCorrectID = 0

End Function


Function FreePostProcess()
If  RefLibInitialized=1
FreeBlur ()
FreeGlow ()
FreeDOF()

;FreeEntity Ref_cameraFxLocal
 If Screen_texture FreeTexture Screen_texture
 Screen_texture=0
 Refract_textureLast=0
  Refract_textureLast1=0
 
 FreeBrush Ref_brush
 Ref_brush=0
 
 Refract_Free() 
 RefLibInitialized=0
 EndIf
End Function




 
; These functions are Not intended for use:
; -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function UpdateGlow( camera ,Ref_GlowTexMethod )

Local Ref_GlowBufferClear, Ref_CarrentBuff, Ref_CurrentBluringTex,fillmode,Bloom_sloy
Ref_SmallBluringTexFirst=0

If Ref_Glow_ON And GlowInitialized And PP_FrameCorrectID

If Glow_HDR
	Ref_OldBuff = TextureBuffer(Screen_TextureSystemRT2)
Else
	Ref_OldBuff = BackBuffer()
EndIf

If Ref_Glow_DarkPower=0
	Ref_CurrentBluringTex = Ref_SmallBluringTex
	BBBlit (0,0,GraphicsWidth(), GraphicsHeight(), reti(Ref_OldBuff+12), reti(TextureBuffer(Ref_SmallBluringTex2)+12),  0,0, Ref_GlowSizeW, Ref_GlowSizeH, 0)
Else
	Ref_CurrentBluringTex = Ref_SmallBluringTex2
	BBBlit (0,0,GraphicsWidth(), GraphicsHeight(), reti(Ref_OldBuff+12), reti(TextureBuffer(Ref_SmallBluringTex)+12),  0,0, Ref_GlowSizeW, Ref_GlowSizeH, 0)
EndIf
;BBBlit (0,0,800 ,600, reti(BackBuffer()+12), reti(TextureBuffer(Ref_SmallBluringTex2)+12),  0,0, 200, 150)

;If Glow_Adaptive_Exposure=1
;AStretchRect ( TextureBuffer(Ref_SmallBluringTex2),  0,0, Ref_GlowSizeW, Ref_GlowSizeH ,TextureBuffer(Ref_AdaptateSysTex), 0, 0 , 32, 32 )
;EndIf

fillmode = BBgetRenderState(8)
BBSetRenderState 8,3
Ref_OldBuff=BBGetRenderTarget ( )

BBSetRenderTarget (  RetI (TextureBuffer(Ref_SmallBluringTex2) + 12) )

CameraViewport Ref_FXcam, 0, 0, Ref_GlowSizeW, Ref_GlowSizeH
ShowEntity Ref_FXcam
BBCopyEntityMatrix ( camera, Ref_FXcam, 0 )

CameraClsMode Ref_FXcam,0,0
CameraZoom Ref_FXcam, 1
ShowEntity Ref_GlowSysSpr
TextureBlend Ref_SmallBluringTex,2
TextureBlend Ref_SmallBluringTex2,2

 For Ref_i=0 To Ref_CountBlSpr-1
 HideEntity Ref_BloomSpr(Ref_i)
 Next
 
RCam_Zoom#=retF( camera + 576)
RCam_W=Reti(  camera +588);AGetCameraViewportWidth(camera)
RCam_H=Reti(  camera +592);AGetCameraViewportHeight(camera)
;	BBClear($00000001, 0 ,1,0)
;	BBClear($00000002, 0 ,1,0)

	
;If  Ref_GlowTexMethod = 1
;	EntityAlpha Ref_fms0, 1
;	ScaleEntity  Ref_SceneBloomSpr, (Ref_CamZn+10)/RCam_Zoom, ((Ref_CamZn+10)*RezScreenKoef)/RCam_Zoom, 1
;Else
;;	PositionEntity Ref_FXcam, EntityX(camera) , EntityY(camera) , EntityZ(camera)
;	ScaleEntity  Ref_SceneBloomSpr, (Ref_CamZn+10)/RCam_Zoom, (Ref_CamZn+10)*RezGlowScrKoef#/RCam_Zoom,1
;	CameraViewport camera, 0, 0, Ref_GlowSizeW, Ref_GlowSizeH
;	EntityAlpha Ref_fms0, 0
;		RenderWorld
;	CameraClsMode Ref_FXcam,0,0
;	CameraViewport camera, 0, 0, RCam_W, RCam_H
;EndIf

CameraProjMode camera,0
;EntityAlpha Ref_SceneBloomSpr, Ref_Glow_Alpha

If S_FirstEntity

S_LastEntity = CreatePivot()
Cuts_predEnt=reti(S_LastEntity+8) 
Cuts_sledEnt=reti(S_FirstEntity+4)
FXcam_predEnt=reti(Ref_FXcam+8) 
FXcam_sledEnt=reti(Ref_FXcam+4)

Writei(S_LastEntity+8, Ref_FXcam) 
Writei(S_FirstEntity+4, Ref_FXcam)
Writei(Ref_FXcam+8, S_LastEntity) 
Writei(Ref_FXcam+4, S_FirstEntity)
FreeEntity S_LastEntity

Else

PositionEntity Ref_FXcam, Ref_CameraOFFSET,Ref_CameraOFFSET,Ref_CameraOFFSET

EndIf


CameraProjMode Ref_FXcam,1

If Ref_Glow_DarkPower>0
EntityAlpha Ref_fms, 1
;EntityAlpha Ref_fms2,1
HideEntity Ref_fms2
HideEntity Ref_fms0
EntityBlend Ref_fms,1
;EntityBlend Ref_fms2,3
;EntityTexture Ref_fms, Ref_SmallBluringTex
;EntityTexture Ref_fms2, Ref_SmallBluringTex2
	BBSetRenderState 19,5
	BBSetRenderState 20,6
	
RenderWorld ; *********************************************************************************

CameraClsMode Ref_FXcam,0,0

EntityAlpha Ref_fms0, 0
EntityAlpha Ref_fms2, 0
EntityAlpha Ref_fms, 0

;BBSetRenderState(  7,0)
;BBSetRenderState(  14,0)
;BBSetRenderState(  23,8)

;Ref_GlowBufferClear = 0
Ref_SmallBluringTexFirst=Ref_SmallBluringTex2
;Ref_SmallBluringTexLast=Ref_SmallBluringTex2
;EntityTexture Ref_SceneBloomSpr, Ref_SmallBluringTex2
;TextureBlend Ref_SmallBluringTex,2
EndIf

;Ref_OldBuff , 0,0,GraphicsWidth(), GraphicsHeight() 
;TextureBuffer(Ref_CurrentBluringTex) , 0, 0, Ref_GlowSizeW, Ref_GlowSizeH
If Glow_Adaptive_Exposure=1
AStretchRect ( TextureBuffer(Ref_CurrentBluringTex) , 0, 0, Ref_GlowSizeW, Ref_GlowSizeH ,TextureBuffer(Ref_AdaptateSysTex), 0, 0 , Ref_AdaptateTexSize, Ref_AdaptateTexSize )
;AStretchRect ( TextureBuffer(Screen_TextureSystemRT2) , 0, 0, GraphicsWidth(), GraphicsHeight() ,TextureBuffer(Ref_AdaptateSysTex), 0, 0 , 32, 32 );Ref_OldBuff
Ref_SceneGlowValue# =( Ref_SceneGlowValue*(1-Glow_Adaptive_Speed) + (Float(AAverageTextureValue(Ref_AdaptateSysTex))/255)*Glow_Adaptive_Speed)
;Ref_GlowColorMask = Ref_SceneGlowValue;(Float(AAverageTextureValue(Ref_AdaptateSysTex))/255)
;Ref_GlowColorMask = 255-Ref_SceneGlowValue;((1 -  Ref_SceneGlowValue#/Glow_HDR_AdaptivePower)  - (1-Glow_HDR_AdaptivePower)/2)*255
Ref_GlowColorMask = ((1 -  Ref_SceneGlowValue#/Glow_HDR_AdaptivePower)  - (1-Glow_HDR_AdaptivePower)/2)*255
EntityColor Ref_SceneBloomSpr,Ref_GlowColorMask,Ref_GlowColorMask,Ref_GlowColorMask
EndIf

TextureBlend Ref_SmallBluringTex,3
TextureBlend Ref_SmallBluringTex2,3

	BBSetRenderState 19,5
	BBSetRenderState 20,2

If Glow_HDRBloom_OFF=0

	For Ref_J=1 To Ref_Glow_BlurPower
	
	If Ref_SmallBluringTexFirst=Ref_SmallBluringTex
	Ref_SmallBluringTexFirst=Ref_SmallBluringTex2
	Ref_SmallBluringTexLast=Ref_SmallBluringTex
	Else
	Ref_SmallBluringTexFirst=Ref_SmallBluringTex
	Ref_SmallBluringTexLast=Ref_SmallBluringTex2
	EndIf
	
	BBSetRenderTarget (  RetI (TextureBuffer(Ref_SmallBluringTexFirst) + 12) ) ; ***************************************************
	
	;If Ref_SmallBluringTexFirst = Ref_SmallBluringTex And Ref_GlowBufferClear=0
		BBClear($00000001, 0 ,1,0)
		BBClear($00000002, 0 ,1,0)
	;	Ref_GlowBufferClear = 1
	;EndIf
	;ChangeRenderTarget (  RetI (TextureBuffer(Ref_SmallBluringTexFirst) + 12) )
	;EntityTexture Ref_fms, Ref_SmallBluringTexFirst
	 For Ref_i=0 To Ref_CountBlSpr-1
	ShowEntity Ref_BloomSpr(Ref_i)
	EntityTexture Ref_BloomSpr(Ref_i), Ref_SmallBluringTexLast
	EntityAlpha Ref_BloomSpr(Ref_i), Ref_BlSprAlpha*(1-Ref_SceneGlowValue);(Ref_GlowColorMask/127);
	Next
	
	RenderWorld
	;BBSetRenderState 24, BBF2DW(0.5)
	;BBSetRenderState 33, 1
	;BBSetRenderState 60, AD3DCOLOR(0,0,0, 45)
	; BBDrawBlurTexture( Ref_fms, GetSurface(Ref_SceneBloomSpr,1) ,TextureBuffer(Ref_SmallBluringTexFirst) , TextureBuffer(Ref_SmallBluringTexFirst) , Ref_Glow_OfffSet/50 , Ref_CountBlSpr , 0 , 0 )
	;BBSetRenderState 33, 0
	;BBSetRenderState 24, BBF2DW(1.0)
	
	Next
EndIf

;ChangeRenderTarget (  Ref_OldBuff )
EntityAlpha Ref_SceneBloomSpr,1


TextureBlend Screen_texture,2
HideEntity Ref_GlowSysSpr
ShowEntity Ref_SceneBloomSpr
;HideEntity Ref_SceneBloomSpr
CameraViewport Ref_FXcam, 0, 0,RCam_W,RCam_H
CameraClsMode Ref_FXcam,0,0
CameraZoom Ref_FXcam, 1;RCam_Zoom

If Glow_Blend = 1
	BBSetRenderState 19,10
	BBSetRenderState 20,2
EndIf

If Glow_HDR
	ChangeRenderTarget (  RetI (BackBuffer() + 12) )
	EntityBlend Ref_SceneBloomSpr,1
	BBSetRenderState 19,5
	BBSetRenderState 20,6
Else
	BBSetRenderTarget (  Ref_OldBuff )
EndIf

	If Glow_HDR
		EntityTexture Ref_SceneBloomSpr, Screen_TextureSystemRT2,0,0
		EntityTexture Ref_SceneBloomSpr, no_texture, 0, 1
		EntityTexture Ref_SceneBloomSpr, no_texture, 0, 2
;		EntityColor Ref_SceneBloomSpr, 255 , 255, 255
;		EntityTexture Ref_SceneBloomSpr, Screen_TextureSystemRT2,0,1
		If Glow_HDRBloom_OFF=0
			If Glow_HDR_GreyFilter=0 EntityTexture Ref_SceneBloomSpr, Ref_SmallBluringTexFirst,0,1
;		Else
;			EntityTexture Ref_SceneBloomSpr, no_texture, 0, 1
		EndIf
;	BBSetTexture (  0 , reti( TextureBuffer(Screen_TextureSystemRT2)+12)  )
;	;BBSetTextureProjMatrix()
;	BBSetTexture (  1 , reti( TextureBuffer(Screen_TextureSystemRT2)+12)  )
;		BBSetCOLORARG ( 1 ,1)
;		BBSetTextureStageState ( 1 ,1 ,5)
;	BBSetTexture (  1 , reti( TextureBuffer(Ref_SmallBluringTexFirst)+12)  )
;		BBSetCOLORARG ( 1 ,1)
;		BBSetTextureStageState ( 1 ,1 ,11)
	
		Ref_GlowColorMask= Ref_GlowColorMask * Glow_HDR_multiply#
		If Ref_GlowColorMask<Glow_HDR_min Ref_GlowColorMask=Glow_HDR_min
		If Ref_GlowColorMask>Glow_HDR_max Ref_GlowColorMask=Glow_HDR_max
		
		EntityColor Ref_SceneBloomSpr,Ref_GlowColorMask,Ref_GlowColorMask,Ref_GlowColorMask
	Else
	TextureBlend Ref_SmallBluringTexFirst,2
		EntityTexture Ref_SceneBloomSpr, Ref_SmallBluringTexFirst
		EntityTexture Ref_SceneBloomSpr, no_texture, 0, 1
		EntityTexture Ref_SceneBloomSpr, no_texture, 0, 2
		EntityColor Ref_SceneBloomSpr, Ref_Glow_Alpha*255 , Ref_Glow_Alpha*255, Ref_Glow_Alpha*255
	EndIf
	 
;BBSetViewport ( 0, 0,RCam_W,RCam_H )
;BBSetEntityTransformMatrix (  Entity )
RenderWorld () ;==============================================================

BBbeginScene

If Glow_HDR
		BBSetRenderState ( 60, AD3DCOLOR(170,170,170,127));Ref_GlowColorMask,Ref_GlowColorMask,Ref_GlowColorMask, Ref_GlowColorMask) )
;		BBSetCOLORARG ( 0 ,5)
;		BBSetTextureStageState ( 0 ,5 ,2)
;		BBSetTextureStageState ( 0 ,6 ,1)
		
		If Ref_GlowColorMask<127
			BBSetTextureStageState ( 0 ,1 ,8)
		Else
			BBSetTextureStageState ( 0 ,1 ,5)
		EndIf
		
		If Glow_HDR_GreyFilter=1
		
			BBSetTextureStageState ( 1 ,1 ,18);8
			BBSetTextureStageState ( 2 ,1 ,24);8
			BBSetTextureStageState ( 0 ,4 ,2)
			BBSetCOLORARG ( 0 ,1)
			BBSetCOLORARG ( 1 ,8)
			BBSetCOLORARG ( 2 ,7)
	;		BBSetCOLORARG ( 3 ,1)
	
			BBSetALPHAARG( 0 ,5)
			BBSetALPHAARG( 1 ,4)
			BBSetALPHAARG( 2 ,5)
			BBSetTextureStageState ( 0 ,4 ,2)
			BBSetTextureStageState ( 1 ,4 ,2)
			Bloom_sloy=3
		Else
			Bloom_sloy=1
		EndIf
		
	If Glow_HDRBloom_OFF=0
		BBSetTexture (Bloom_sloy, reti( TextureBuffer(Ref_SmallBluringTexFirst)+12)	)
		If Glow_Blend = 1 
			BBSetTextureStageState ( Bloom_sloy ,1 ,11)
		Else
			BBSetTextureStageState ( Bloom_sloy ,1 ,7)
		EndIf
	Else
		BBSetTextureStageState ( Bloom_sloy ,1 ,1)
	EndIf
EndIf
BBDrawSurface(Glow_surface)
BBSetRenderState 8, fillmode
BBEndScene 

;BBDRAWRESULT = BBDrawBlurTexture( Ref_SceneBloomSpr ,TextureBuffer(Ref_SmallBluringTexFirst) , BackBuffer() , Ref_Glow_OfffSet , Ref_CountBlSpr , 0 , 0 )
CameraClsMode Ref_FXcam,1,1
HideEntity Ref_SceneBloomSpr
EntityAlpha Ref_SceneBloomSpr, 0

If Glow_Blend = 1
	BBSetRenderState 19,5
	BBSetRenderState 20,2
EndIf

HideEntity Ref_FXcam
CameraProjMode Ref_FXcam,0
CameraProjMode camera,1

PositionEntity Ref_FXcam, 0,0,0

If Glow_HDR
	BBSetRenderState 19,5
	BBSetRenderState 20,2
	BBSetCOLORARG ( 0 ,1)
	BBSetCOLORARG ( 1 ,1)
	BBSetCOLORARG ( 2 ,1)
	BBSetALPHAARG( 0 ,1)
	BBSetALPHAARG( 1 ,1)
	BBSetALPHAARG( 2 ,1)
	ChangeRenderTarget (  RetI (TextureBuffer(Screen_TextureSystemRT2) + 12) )
;If Glow_HDR
;	ChangeRenderTarget (  RetI (TextureBuffer(Screen_TextureSystemRT2) + 12) )
;	BBClear($00000001, AD3DCOLOR ( 0, 0, 0) , 1 ,0)
;EndIf
;	BBClear($00000004, 0 ,1,0)
;	BBClear($00000002, 0 ,1,0)
;	BBClear($00000001, 0 ,1,0)
EndIf
;BBSetRenderState(  7,1)
;BBSetRenderState(  14,1)
;BBSetRenderState(  23,4) 

If S_FirstEntity
S_LastEntity = CreatePivot()
Writei(S_LastEntity+8, Cuts_predEnt) 
Writei(S_FirstEntity+4, Cuts_sledEnt)
Writei(Ref_FXcam+8, FXcam_predEnt) 
Writei(Ref_FXcam+4, FXcam_sledEnt)
FreeEntity S_LastEntity
EndIf

EndIf

 End Function

 Function AAverageTextureValue( Texture, AverType=0 )
Local Tex_buf, Tex_W, Tex_H, current_pix, x, y
Local Average_sum=0, Average_value=0

Tex_buf = TextureBuffer( Texture)
Tex_W = TextureWidth( Texture )
Tex_H = TextureHeight( Texture )

LockBuffer  Tex_buf

For y=0 To Tex_H-1
For x=0 To Tex_W-1
Average_value = AD3DAVERAGECOLOR (  ReadPixelFast(x,y, Tex_buf) )
Average_sum = Average_sum+Average_value
Next
Next

UnlockBuffer  Tex_buf

Return Average_sum / (Tex_W*Tex_H)

 End Function

Function UpdateDOF( camera  )
Local SpriteDOF, pos#, CurrentRenderBuffer,CurrentRenderTex

If Ref_DOF And DOFInitialized And PP_FrameCorrectID

RCam_Zoom#=retF( camera + 576)
ScaleEntity Ref_DOFSysSpr, 1/RCam_Zoom#, 1/RCam_Zoom#, 1

For Ref_i=1 To Ref_LevelDOF
	Dest# = Dest + (Ref_FarDOF-Ref_NearDOF) / (Ref_LevelDOF)
	Pos# = (Ref_FarDOF - Dest)
	sprp# = Pos# / Ref_copyW
	PositionEntity	Ref_DOFSpr(Ref_i), -sprp, sprp, Pos
	ScaleEntity		Ref_DOFSpr(Ref_i), Pos, Pos * RezScreenKoef , 0
Next

 RenderIdle(Ref_DOFSysSpr, camera )

BBSaveTextureStates (0)
BBSaveTextureStates (1)
BBSaveTextureStates (2)
BBSaveTextureStates (3)
BBSaveTextureStates (4)
BBSaveTextureStates (5)
BBSaveTextureStates (6)

BBSaveTextureMatrix (16)
BBSaveTextureMatrix (17)
BBSaveTextureMatrix (18)
BBSaveTextureMatrix (19)
BBSaveTextureMatrix (20)
BBSaveTextureMatrix (21)
BBSaveTextureMatrix (22)


;BBSetRenderState ( 7, 1 )
;BBSetRenderState ( 14, 1 )
;	BBClear($00000004, $4080f0,1,0)
;
;	BBSetRenderState(52, 1 )
;
;	BBSetRenderState(57,  1 )
;	BBSetRenderState(59,  1 )
;	BBSetRenderState(58, $FFFFFFFF)
;	BBSetRenderState(56, 4);
;	BBSetRenderState(55, 4);
;	BBSetRenderState(53, 1);
;	BBSetRenderState(54, 1);

	If Glow_HDR
		CurrentRenderTex = Screen_TextureSystemRT2
		CurrentRenderBuffer = Screen_TextureSystemRT2
	Else
		CurrentRenderTex = Screen_texture
		CurrentRenderBuffer = BackBuffer()
	EndIf

Ref_OldBuff=BBGetRenderTarget ( )
ChangeRenderTarget  (  RetI (TextureBuffer(CurrentRenderTex) + 12) )

;BBClear($00000004, $4080f0, 1,0)
;	BBSetRenderState(52,1)
;	BBSetRenderState(57, 1 )
;	BBSetRenderState(58,$ffffffff)
;	BBSetRenderState(59,$ffffffff)
;	BBSetRenderState(55, 3);
;	BBSetRenderState(54, 1); 
;	BBSetRenderState(53, 1);
;	BBSetRenderState(56, 6);

If Ref_DirectionDOF=1
	For Ref_i=1 To Ref_LevelDOF-1
		SpriteDOF = Ref_DOFSpr(Ref_i)
		pos = Ref_PowerDOF*.05/(Ref_LevelDOF) ;/ (Ref_FarDOF+Ref_NearDOF - EntityZ#(SpriteDOF))
		BBDrawBlurTexture( 0 ,  SpriteDOF, 0 ,TextureBuffer(CurrentRenderTex) , TextureBuffer(CurrentRenderTex) , pos , 4 , 1 , 0 )
	Next
		BBSetRenderState(52, 0 )
	SpriteDOF = Ref_DOFSpr(Ref_LevelDOF)
	ChangeRenderTarget   (  Ref_OldBuff )
	pos = Ref_PowerDOF*.05/(Ref_LevelDOF); / (Ref_FarDOF+Ref_NearDOF - EntityZ#(SpriteDOF))
	BBDrawBlurTexture( 0 , SpriteDOF , 0 ,TextureBuffer(CurrentRenderTex) , CurrentRenderBuffer   ,  pos , 1 , 1 , 0 )
;	0.1 * Ref_PowerDOF / (Ref_FarDOF/EntityZ#(SpriteDOF))
Else
	BBSetRenderState ( 23, 7 )
	For Ref_i=1 To Ref_LevelDOF-1
		SpriteDOF = Ref_DOFSpr((Ref_LevelDOF+1)-Ref_i)
		pos = Ref_PowerDOF*.05/Ref_LevelDOF; / (EntityZ#(SpriteDOF))
		BBDrawBlurTexture( 0 ,  SpriteDOF, 0 ,TextureBuffer(CurrentRenderTex) , TextureBuffer(CurrentRenderTex) , pos , 4 , 1 , 0 )
	Next
		BBSetRenderState(52, 0 )
	SpriteDOF = Ref_DOFSpr(1)
	ChangeRenderTarget   (  Ref_OldBuff )
	pos = Ref_PowerDOF*.05/Ref_LevelDOF; / (EntityZ#(SpriteDOF))
	BBDrawBlurTexture( 0 , SpriteDOF , 0 ,TextureBuffer(CurrentRenderTex) , CurrentRenderBuffer   , pos , 4 , 1 , 0 )
	BBSetRenderState ( 23, 4 )
EndIf

;	BBSetRenderState(52, 0 )

BBLoadTextureStates (0)
BBLoadTextureStates (1)
BBLoadTextureStates (2)
BBLoadTextureStates (3)
BBLoadTextureStates (4)
BBLoadTextureStates (5)
BBLoadTextureStates (6)

BBLoadTextureMatrix (16)
BBLoadTextureMatrix (17)
BBLoadTextureMatrix (18)
BBLoadTextureMatrix (19)
BBLoadTextureMatrix (20)
BBLoadTextureMatrix (21)
BBLoadTextureMatrix (22)


EndIf
End Function

Function dEntityScaleX#(Entity)

	S_Componentx# = GetMatElement(Entity, 0, 0)
	S_Componenty# = GetMatElement(Entity, 0, 1)
	S_Componentz# = GetMatElement(Entity, 0, 2)	
	Return Sqr(S_Componentx#*S_Componentx# + S_Componenty#*S_Componenty# + S_Componentz#*S_Componentz#)

End Function

Function dEntityScaley#(Entity)

	S_Componentx# = GetMatElement(Entity, 1, 0)
	S_Componenty# = GetMatElement(Entity, 1, 1)
	S_Componentz# = GetMatElement(Entity, 1, 2)
	Return Sqr(S_Componentx#*S_Componentx# + S_Componenty#*S_Componenty# + S_Componentz#*S_Componentz#)

End Function

Function dEntityScalez#(Entity)

	S_Componentx# = GetMatElement(Entity, 2, 0)
	S_Componenty# = GetMatElement(Entity, 2, 1)
	S_Componentz# = GetMatElement(Entity, 2, 2)
	Return Sqr(S_Componentx#*S_Componentx# + S_Componenty#*S_Componenty# + S_Componentz#*S_Componentz#)

End Function

;==================[Render lib]==================
Type RenderParam
	Field newRenderTarget
	Field width
	Field height
End Type

Type RenderTargets
	Field RenderTargetObject
	Field RenderTargetAdres
	Field RenderTarget
	Field width
	Field height
End Type

RTV.RenderParam=New RenderParam
RTFree.RenderParam=New RenderParam

Global TextureRender
Global oldRenderTarget
Global Mode=60

Global Rend_InitRender=0
Global RenderTargetCount=0


Function InitRender()
If Rend_InitRender=0
oldRenderTarget=BBGetRenderTarget()
If Not oldRenderTarget RuntimeError "Can't get old RenderTarget handle"
Rend_InitRender=1
EndIf
End Function

Function CreateTextureRT(texW, texH, Zbufer=0, flag=1+256)
Local NewRenderTarget
InitRender()

tex= CreateTexture(texW, texH, flag)

NewRenderTarget =BBCreateRenderTarget ( reti(TextureBuffer(tex)+12), texW, texH, Zbufer )
Writei(TextureBuffer(tex)+12, NewRenderTarget)
Writei(TextureBuffer(tex)+16, NewRenderTarget)
Writei(TextureBuffer(tex)+92, texW)
Writei(TextureBuffer(tex)+96, texH)
Writei(TextureBuffer(tex)+56, 812)
;CopyTarget( reti(BackBuffer()+12) ,  reti(TextureBuffer(tex)+12) )

;RTV.RenderParam=First RenderParam
;
;Target.RenderTargets=New RenderTargets
;;Target\RenderTargetN=RenderTargetCount
;RenderTargetCount=RenderTargetCount+1
;
;Target\RenderTargetObject=tex
;Target\width=TextureWidth(tex)
;Target\height=TextureHeight(tex)
;Target\RenderTargetAdres=TextureBuffer(tex)
;
;If texW=0 Or texH=0
;RTV\width=TextureWidth(tex)
;RTV\height=TextureHeight(tex)
;Else
;RTV\width=texW
;RTV\height=texH
;EndIf
;
;RTV\newRenderTarget=0
;	hr=CreateRenderTarget(Target\RenderTargetAdres,RTV) ; hijack the BB texture (points rendertexture to BB texture :)
;	If hr<>0
;		RuntimeError "Render to Texture not supported!"
;	End If
;Target\RenderTarget=RTV\newRenderTarget
;
Return tex
End Function

Function CreateCubeTextureRT(texW, texH, Zbufer=0, flag=256)
Local NewRenderTarget, TexSurface, Buffer, tex, face

tex= CreateTexture(texW, texH, 128 + flag)

TexSurface = reti(TextureBuffer(tex)+12)
Buffer = TextureBuffer(tex)
;BBGetCubeFace(Buffer, i)
;For i=1 To 6
;face = BBGetCubeFace(Buffer, i)
;NewRenderTarget =BBCreateRenderTarget (  BBGetCubeFace(Buffer, 3) , texW, texH, 1 )
;Writei(TextureBuffer(tex)+20+4*3, NewRenderTarget)
NewRenderTarget =BBCreateRenderTarget (  BBGetCubeFace(Buffer, 1) , texW, texH, 1 )
Writei(TextureBuffer(tex)+20+4*1, NewRenderTarget)
NewRenderTarget =BBCreateRenderTarget (  BBGetCubeFace(Buffer, 2) , texW, texH, 1 )
Writei(TextureBuffer(tex)+20+4*2, NewRenderTarget)
NewRenderTarget =BBCreateRenderTarget (  BBGetCubeFace(Buffer, 4) , texW, texH, 1 )
Writei(TextureBuffer(tex)+20+4*4, NewRenderTarget)
NewRenderTarget =BBCreateRenderTarget (  BBGetCubeFace(Buffer, 5) , texW, texH, 1 )
Writei(TextureBuffer(tex)+20+4*5, NewRenderTarget)
NewRenderTarget =BBCreateRenderTarget (  BBGetCubeFace(Buffer, 6) , texW, texH, 1 )
Writei(TextureBuffer(tex)+20+4*6, NewRenderTarget)
;Next

Return tex

End Function

Function CreateRenderTexture(tex, texW=0, texH=0, Zbufer=1)
InitRender()

If texW=0 Or texH=0
texW=TextureWidth(tex)
texH=TextureHeight(tex)
EndIf

NewRenderTarget =BBCreateRenderTarget ( reti(TextureBuffer(tex)+12), texW, texH, Zbufer )
Writei(TextureBuffer(tex)+12, NewRenderTarget)
Writei(TextureBuffer(tex)+16, NewRenderTarget)
Writei(TextureBuffer(tex)+92, texW)
Writei(TextureBuffer(tex)+96, texH)
Writei(TextureBuffer(tex)+56, 812)

 
;;;If RTV\newRenderTarget<>0 Return
;
;RTV.RenderParam=First RenderParam
;
;Target.RenderTargets=New RenderTargets
;;Target\RenderTargetN=RenderTargetCount
;RenderTargetCount=RenderTargetCount+1
;
;Target\RenderTargetObject=tex
;Target\width=TextureWidth(tex)
;Target\height=TextureHeight(tex)
;Target\RenderTargetAdres=TextureBuffer(tex)
;
;If texW=0 Or texH=0
;RTV\width=TextureWidth(tex)
;RTV\height=TextureHeight(tex)
;Else
;RTV\width=texW
;RTV\height=texH
;EndIf
;
;RTV\newRenderTarget=0
;	hr=CreateRenderTarget(Target\RenderTargetAdres,RTV) ; hijack the BB texture (points rendertexture to BB texture :)
;	If hr<>0
;		RuntimeError "Render to Texture not supported!"
;	End If
;Target\RenderTarget=RTV\newRenderTarget

End Function

Function CreateRenderCubeTexture(tex)
InitRender()

;;If RTV\newRenderTarget<>0 Return
;RTV.RenderParam=First RenderParam
;
;Target.RenderTargets=New RenderTargets
;;Target\RenderTargetN=RenderTargetCount
;RenderTargetCount=RenderTargetCount+1
;
;Target\RenderTargetObject=tex
;Target\width=TextureWidth(tex)
;Target\height=TextureHeight(tex)
;Target\RenderTargetAdres= TextureBuffer(tex) ;(6+face)*4);TextureBuffer(tex)
;Rend_Olsbuff= TextureBuffer(tex) 
;Rend_OlsSurf7=Reti(  TextureBuffer(tex) + 12 )
;
;For Rend_i=0 To 2
;setcubeface tex, Rend_i
;Rend_RT =  Reti(  TextureBuffer(tex) + (4)*4 ) 
;WriteI ( TextureBuffer(tex) + 12 , Rend_RT)
;RTV\width=TextureWidth(tex)
;RTV\height=TextureHeight(tex)
;RTV\newRenderTarget=0
;	hr=CreateRenderTarget(Target\RenderTargetAdres,RTV) ; hijack the BB texture (points rendertexture to BB texture :)
;	If hr<>0
;		RuntimeError "Render to Texture not supported!"
;	End If
;Next
;
;WriteI (   TextureBuffer(tex) + 12 , Rend_OlsSurf7 )
;
;Target\RenderTarget=RTV\newRenderTarget
End Function

Function SetRender(TargetObj)
InitRender()

RTV.RenderParam=First RenderParam

For Target.RenderTargets=Each RenderTargets
If Target\RenderTargetObject=TargetObj
RTV\width=Target\width
RTV\height=Target\height
RTV\newRenderTarget=Target\RenderTarget
Exit
EndIf
Next

	;SetRenderTarget(RTV\newRenderTarget)
	BBSetRenderTarget (  RetI (RTV\newRenderTarget + 12) )
	
End Function

Function FreeRender(TargetObj)
RTFree.RenderParam=First RenderParam

;For Target.RenderTargets=Each RenderTargets
;If Target\RenderTargetObject=TargetObj
;RTFree\width=Target\width
;RTFree\height=Target\height
;RTFree\newRenderTarget=Target\RenderTarget
;Exit
;EndIf
;Next
;
;FreeRenderTarget(Target\RenderTargetAdres,RTFree)
End Function

Function RestoreRender()
;SetRenderTarget(oldRenderTarget)
	BBSetRenderTarget (  RetI (oldRenderTarget + 12) )
End Function

Function RenderIdle( Entity, camera, Clsmode=0 )

If S_FirstEntity

Cuts_sledEnt=reti(S_FirstEntity+4)
Writei(S_FirstEntity+4, 0)

Entity_predEnt=reti(Entity+8) 
Entity_sledEnt=reti(Entity+4)
Writei(S_FirstEntity+4, Entity)
Writei(Entity+8, S_FirstEntity) 
Writei(Entity+4, 0)

Else
RuntimeError "AShadow not initialized!"
EndIf

RCam_X#=Reti(  camera +580)
RCam_Y#=Reti(  camera +584)
RCam_W#=Reti(  camera +588)
RCam_H#=Reti(  camera +592)
RCam_Zoom#=retF( camera + 576)
Ref_CamZn# = RetF ( camera + 640)
Ref_CamZf# = RetF ( camera + 644)
CameraProjMode camera,0
CameraProjMode S_FirstEntity,1
CameraViewport S_FirstEntity, 0, 0,RCam_W,RCam_H
CameraZoom S_FirstEntity, RCam_Zoom
CameraRange S_FirstEntity, Ref_CamZn, Ref_CamZf
;BBCopyEntityMatrix ( camera, S_FirstEntity, 1 )
PositionEntity S_FirstEntity,0,0,0

If Clsmode=0
CameraClsMode S_FirstEntity,0,0
Else
If Clsmode=1 CameraClsMode S_FirstEntity,1,1
EndIf

RenderWorld


CameraProjMode camera,1
CameraProjMode S_FirstEntity,0


Writei(S_FirstEntity+4, Cuts_sledEnt)
Writei(Entity+8, Entity_predEnt) 
Writei(Entity+4, Entity_sledEnt)

 End Function


Function RenderEntity( Entity, camera, Clsmode=0, tweenmode=1 , tween#=1)

If S_FirstEntity

;S_LastEntity = CreatePivot()
;Cuts_predEnt=reti(S_LastEntity+8) 
Cuts_sledEnt=reti(S_FirstEntity+4)
Entity_predEnt=reti(Entity+8) 
Entity_sledEnt=reti(Entity+4)
;Writei(S_LastEntity+8, Entity) 
Writei(S_FirstEntity+4, Entity)
Writei(Entity+8, S_FirstEntity) 
Writei(Entity+4, 0)
;FreeEntity S_LastEntity

Else
RuntimeError "AShadow not initialized!"
EndIf

RCam_X#=Reti(  camera +580)
RCam_Y#=Reti(  camera +584)
RCam_W#=Reti(  camera +588)
RCam_H#=Reti(  camera +592)
RCam_Zoom#=retF( camera + 576)
Ref_CamZn# = RetF ( camera + 640)
Ref_CamZf# = RetF ( camera + 644)
CameraProjMode camera,0
CameraProjMode S_FirstEntity,1
CameraViewport S_FirstEntity, 0, 0,RCam_W,RCam_H
CameraZoom S_FirstEntity, RCam_Zoom
CameraRange S_FirstEntity, Ref_CamZn, Ref_CamZf

If tweenmode=1
	BBCopyEntityMatrix ( camera, S_FirstEntity, 1 )
ElseIf tweenmode=2
	BBCopyEntityMatrix ( camera, S_FirstEntity, 2 )
	BBCopyEntityMatrix ( camera, S_FirstEntity, 3 )
Else
	BBCopyEntityMatrix ( camera, S_FirstEntity, 0 )
EndIf

If Clsmode=0
CameraClsMode S_FirstEntity,0,0
Else
If Clsmode=1 CameraClsMode S_FirstEntity,1,1
EndIf

RenderWorld tween#


CameraProjMode camera,1
CameraProjMode S_FirstEntity,0


Writei(S_FirstEntity+4, Cuts_sledEnt)
Writei(Entity+8, Entity_predEnt) 
Writei(Entity+4, Entity_sledEnt)

 End Function
 
;================[Data Control System :)) ]================ 
 
Function CutEntity ( Entity ) 
Local controlObj 
 
If Entity 
 
Cuts_parent=reti(Entity+12) 
 
controlObj=CreatePivot(Cuts_parent) 
 
Cuts_predEnt=reti(Entity+8) 
Cuts_sledEnt=reti(Entity+4) 
 
If Cuts_parent 
If reti(Cuts_parent+16)=Entity  Writei(Cuts_parent+16, GetChild(Cuts_parent,2)) 
EndIf 
If Cuts_sledEnt  Writei(Cuts_sledEnt+8, Cuts_predEnt) 
If Cuts_predEnt  Writei(Cuts_predEnt+4, Cuts_sledEnt) 
 
FreeEntity controlObj 
 
Else 
RuntimeError "Entity isn't exist" 
EndIf 
 
End Function 
 
Function PasteEntity ( Entity )   
Local controlObj,Cuts_parent 
 
If Entity   
  
Cuts_parent=reti(Entity+12)  
 
 controlObj=CreatePivot(Cuts_parent)  
Cuts_predEnt=reti(controlObj+8) 
   
If Cuts_predEnt  Writei(Cuts_predEnt+4, Entity)   
Writei(controlObj+8, Entity) 
 
If Cuts_parent Writei( Entity+8, Cuts_predEnt )  
FreeEntity controlObj 
   
Else   
RuntimeError "Entity isn't exist"   
EndIf   
   
End Function

; -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function AD3DCOLOR ( Red, Gren, Blue, Alpha=255)
;Return (((Red Shl 8) Or Gren) Shl 8) Or Blue
 Return (Alpha Shl 24) Or (Red Shl 16) Or (Gren Shl 8) Or Blue
End Function

Function AD3DAVERAGECOLOR ( Pixel )
	Local r1,g1,b1,  r2,g2,b2,  S_rgb
			r1 = (Pixel Shr 16) And $ff
			g1 = (Pixel Shr 8) And $ff
			b1 = Pixel And $ff
	Return (r1+g1+b1) / 3
End Function

Function AD3DMAXRGB ( Pixel )
Local r1,g1,b1,  r2,g2,b2,  Max_rgb
			r1 = (Pixel Shr 16) And $ff
			g1 = (Pixel Shr 8) And $ff
			b1 = Pixel And $ff

If r1>b1  Max_rgb=r1  Else  Max_rgb=b1
If Max_rgb<g1  Max_rgb=g1

Return Max_rgb
End Function

Function ACreateQuade(parent=0)
Local Quade, surf

Quade = CreateMesh(parent)
	surf = CreateSurface( Quade)
	AddVertex surf, -1, 1, 0,      0, 0
	AddVertex surf, 1, 1, 0,       1 ,0
	AddVertex surf, -1, -1, 0,     0, 1
	AddVertex surf, 1, -1, 0,      1, 1
	AddTriangle surf, 0, 1, 2
	AddTriangle surf, 3, 2, 1
	
	FlipMesh Quade

	Return Quade
	
End Function

Function CreateClipPlane (Entity,VectorX#=0,VectorY#=0,VectorZ#=0, ClipeState=0) ; ClipeState value: 0-7
cp.CP_ClipPlane=New CP_ClipPlane
SetPlaneOrientation(Entity,cp,VectorX#,VectorY#,VectorZ#)
BBSetClipPlane (ClipeState,cp)
Return Handle(cp.CP_ClipPlane)
End Function

Function SetPlaneOrientation(mesh,cp.CP_ClipPlane,VectorX#,VectorY#,VectorZ#)
;	Local p1.CP_vec=New CP_vec
;	Local p4.CP_vec=New CP_vec
;	Local norm.CP_vec=New CP_vec

	;VecSet p4,0,0,0
;	surf=GetSurface(mesh,1)

	; Get the 3 plane points
	TFormPoint 0,0,0,mesh,0
;	VecSet p1,TFormedX(),TFormedY(),TFormedZ()
	CP_x#=TFormedX#()
	CP_y#=TFormedY#()
	CP_z#=TFormedZ#()

	TFormNormal 0 + VectorX# ,0 + VectorY# ,1 + Vectorz#,mesh,0
;	VecSet norm,TFormedX(),TFormedY(),TFormedZ()
	cp\a#=TFormedX#()
	cp\b#=TFormedY#()
	cp\c#=TFormedZ#()
    cp\d#=-( cp\a#*CP_x# + cp\b#*CP_y# +cp\c#*CP_z# )
	
	;cp\d=(VecDot(norm,p4,False) - VecDot(norm,p1,False))
;-( n.x*c.x + n.y*c.y + n.z*c.z );
End Function


Type AD3DMaterial

	Field diffuseColorR#
	Field diffuseColorG#
	Field diffuseColorB#
	
	Field ambientColorR#
	Field ambientColorG#
	Field ambientColorB#
	
	Field specularColorR#
	Field specularColorG#
	Field specularColorB#
	
	Field emissiveColorR#
	Field emissiveColorG#
	Field emissiveColorB#
	
	Field specularpower#

End Type

Global BBMaterial.AD3DMaterial = New AD3DMaterial
Global WaterMaterialWhite.AD3DMaterial = New AD3DMaterial
WaterMaterialWhite\ambientColorR = 1.0
WaterMaterialWhite\ambientColorG = 1.0
WaterMaterialWhite\ambientColorB = 1.0

WaterMaterialWhite\emissiveColorR = 0.0
WaterMaterialWhite\emissiveColorG = 0.0
WaterMaterialWhite\emissiveColorB = 0.0

Global WaterUpdate_Screen_texture
Global AWater_PlanesCount

Type ARefBumpTextures
	Field Texture
	Field DU#, DV#
	Field ScaleU#, ScaleV#
	Field SizeW, SizeH
End Type

Type AWaterStates
	Field X#, Y#, Z#
	Field ScaleX#, ScaleY#, ScaleZ#

	Field WaterColorR
	Field WaterColorG
	Field WaterColorB
	
	Field BumpTexture
	Field BumpPower#
	Field BumpDestCorrectOFF

	Field Fresnel
	Field Fresnelintensity
	Field GradientCubeMap
	Field UnderWaterFog 
	
	Field RefractTexture
	
	Field Reflective
	Field BumpReflectOFF
	Field UnderWaterReflective
	Field ReflectSizeW, ReflectSizeH
	
	Field Entity
	Field Texture, texkoef#
	Field ReflectWTexture
	Field WaterCP.CP_ClipPlane
	Field WaterMaterial.AD3DMaterial
	
	Field Refractive
	
	Field BumpShader

End Type

Type AWaters
	Field Entity
	Field Quade
	Field Show
	Field UnderWater
	
	Field BumpTexture
	Field BumpPower#
	Field BumpDestCorrectOFF

	Field Fresnel
	Field Fresnelintensity
	Field GradientCubeMap
	Field UnderWaterFog 

	Field RefractTexture
	
	Field Reflective
	Field BumpReflectOFF
	Field UnderWaterReflective
	Field ReflectSizeW, ReflectSizeH
	Field Refractive
	Field BumpShader
	
	Field Texture, RefTextBuffer
	Field ReflectWTexture
	Field LinkedWater
	Field texkoef#
	Field WaterCP.CP_ClipPlane
	Field DestWaterToCam#
	Field WaterMaterial.AD3DMaterial

End Type

Global WaterState.AWaterStates = New AWaterStates

Type CP_vec
	Field x#,y#,z#
End Type

Type CP_ClipPlane
	Field a#,b#,c#,d#
End Type

Global BBClipPlane.CP_ClipPlane=New CP_ClipPlane

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Bump maps control and seting
Function ASetBumpTexture ( Texture )
;RefBumpTexture.ARefBumpTextures = New ARefBumpTextures
;RefBumpTexture\Texture = Texture
;RefBumpTexture\ScaleU = 1
;RefBumpTexture\ScaleV = 1
;RefBumpTexture\SizeW = TextureWidth(Texture)
;RefBumpTexture\SizeH =  TextureHeight(Texture)
Return Texture;Handle(RefBumpTexture.ARefBumpTextures)
End Function
;
Function ABumpTextureTransform ( BumpTextureHandle , DU# , DV# , ScaleU#=1 , ScaleV#=1 )
;RefBumpTexture.ARefBumpTextures = Object.ARefBumpTextures( BumpTextureHandle )
;RefBumpTexture\DU# = DU#
;RefBumpTexture\DV# = DV#
;RefBumpTexture\ScaleU# = ScaleU#
;RefBumpTexture\ScaleV# = ScaleV#
PositionTexture BumpTextureHandle, DU#, DV#
ScaleTexture BumpTextureHandle, ScaleU#, ScaleV#
End Function

Function ADeleteBumpTexture ( BumpTextureHandle )
;RefBumpTexture.ARefBumpTextures = Object.ARefBumpTextures(BumpTextureHandle)
;Delete RefBumpTexture
End Function
;
Function TextureConvertH2UVL( Texture, Scale#=1, LuminanceTexture=0 )
Local Tex_buf, Tex_W, Tex_H, current_pix, R_pix, L_pix, D_pix, U_pix 
Local Sec_img, img_buf,  x,y,  Pix_dU, Pix_dV,  Lum_texOn=0, Lum_texBuf, Lum_pix=255,AlphaP

;AlphaP=Alpha#*255: If AlphaP>255 AlphaP=255

Tex_buf = TextureBuffer( Texture)
Tex_W = TextureWidth( Texture )
Tex_H = TextureHeight( Texture )

If LuminanceTexture>0
Lum_texOn=1
Lum_texBuf = TextureBuffer( LuminanceTexture)
EndIf

Sec_img =  CreateImage( Tex_W, Tex_H ,1)
img_buf = ImageBuffer(Sec_img)

CopyRect 0, 0, Tex_W, Tex_H, 0, 0 , Tex_buf, img_buf

LockBuffer  Tex_buf
LockBuffer  img_buf
LockBuffer  Lum_texBuf

For y=0 To Tex_H-1
For x=0 To Tex_W-1

current_pix= AD3DAVERAGECOLOR ( ReadPixelFast(x,y, img_buf) )

If Lum_texOn  Lum_pix = AD3DAVERAGECOLOR ( ReadPixelFast(x,y, Lum_texBuf) )

R_pix= AD3DAVERAGECOLOR ( ReadPixelFast(x+1,y, img_buf) )

L_pix= AD3DAVERAGECOLOR ( ReadPixelFast(x-1,y, img_buf) )

If y = Tex_H-1
D_pix= R_pix
Else
D_pix= AD3DAVERAGECOLOR ( ReadPixelFast(x,y+1, img_buf) )
EndIf

If y = 0
U_pix= R_pix
Else
U_pix= AD3DAVERAGECOLOR ( ReadPixelFast(x,y-1, img_buf) )
EndIf


Pix_dU =  Abs(Scale# * ( L_pix-R_pix ) + 127 )
Pix_dV =  Abs(Scale# * ( U_pix-D_pix ) + 127 )

;If current_pix<L_pix Or current_pix<R_pix
;Pix_dU = Abs( Scale# * (L_pix - current_pix) + 127)
;If  Pix_dU<(current_pix-R_pix)  Pix_dU = Abs( Scale# * (current_pix-R_pix) + 127)
;EndIf

If Pix_dU>255 Pix_dU=255: If Pix_dV>255 Pix_dV=255
If Pix_dU<0 Pix_dU=0: If Pix_dV<0 Pix_dV=0


Result_pix =  (((Pix_dU  Shl 8) Or  Pix_dV  ) Shl 8) Or Lum_pix

WritePixelFast x,y, Result_pix, Tex_buf

Next 
Next

UnlockBuffer  Tex_buf
UnlockBuffer  img_buf
UnlockBuffer  Lum_texBuf

FreeImage Sec_img

End Function
; Convert Height map to Bump map (for Pixel Distortion)
Function TextureAddLuminance( Texture,  LuminanceTexture, LuminanceScale#=1 )
Local Tex_buf, Tex_W, Tex_H, current_pix
Local r1,g1,b1, Lum_texOn=0, Lum_texBuf, Lum_value#

Tex_buf = TextureBuffer( Texture)
Tex_W = TextureWidth( Texture )
Tex_H = TextureHeight( Texture )

Lum_texBuf = TextureBuffer( LuminanceTexture)

LockBuffer  Tex_buf
LockBuffer  Lum_texBuf

For y=0 To Tex_H-1
For x=0 To Tex_W-1

current_pix=  ReadPixelFast(x,y, Tex_buf)
			r1 = (current_pix Shr 16) And $ff
			g1 = (current_pix Shr 8) And $ff
Lum_value = AD3DAVERAGECOLOR ( ReadPixelFast(x,y, Lum_texBuf) ) * LuminanceScale#
If Lum_value<0 Lum_value=0 :   If Lum_value>255 Lum_value=255 

WritePixelFast x,y,  AD3DCOLOR(r1, g1, Int(150) ) , Tex_buf

Next 
Next

UnlockBuffer  Tex_buf
UnlockBuffer  Lum_texBuf


End Function

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



;Version 0.3
;=======================================[Water Engine]==========================================

;Snandart settings:
WaterState\X=0
WaterState\Y=0
WaterState\Z=0
WaterState\ScaleX = 1
WaterState\ScaleY = 1
WaterState\ScaleZ = 1

WaterState\ReflectSizeW = 256
WaterState\ReflectSizeH = 256

WaterState\WaterColorR = 255
WaterState\WaterColorG = 255
WaterState\WaterColorB = 255

WaterState\BumpTexture = WaterNormalMap
WaterState\BumpPower= 0.2
WaterState\BumpDestCorrectOFF = 0

WaterState\GradientCubeMap = 0

WaterState\RefractTexture=0

WaterState\Reflective=1
WaterState\BumpReflectOFF = 0
WaterState\UnderWaterReflective=0
WaterState\Refractive=1
WaterState\BumpShader = 0

WaterState\Entity = 0

Function ACreateRenderWater ( set=1, WaterState.AWaterStates )

Local X#=0, Y#=0, Z#=0
Local ReflectSizeW#=256, ReflectSizeH#=256
Local ScaleX#=1, ScaleY#=1, ScaleZ#=1
Local WaterColorR#=255
Local WaterColorG#=255
Local WaterColorB#=255
Local BumpTexture=0, GradientCubeMap=0, Fresnel=0,Fresnelintensity=0,RefractTexture=0
Local BumpPower#=0.2, BumpDestCorrectOFF=0
Local Reflective=1, BumpReflectOFF=0
Local UnderWaterReflective=0,UnderWaterFog=0
Local Refractive=1,BumpShader=0
Local Entity, WaterRefractMesh

WaterRender.AWaters = New AWaters
AWater_PlanesCount = AWater_PlanesCount+1

If Not set=0
X#=WaterState\X
Y#=WaterState\Y
Z#=WaterState\Z
ReflectSizeW#=WaterState\ReflectSizeW
ReflectSizeH#=WaterState\ReflectSizeH
ScaleX#=WaterState\ScaleX
ScaleY#=WaterState\ScaleZ
ScaleZ#=WaterState\ScaleY
WaterColorR=WaterState\WaterColorR
WaterColorG=WaterState\WaterColorG
WaterColorB=WaterState\WaterColorB
BumpTexture=WaterState\BumpTexture
BumpPower#=WaterState\BumpPower
BumpDestCorrectOFF = WaterState\BumpDestCorrectOFF
Fresnel = WaterState\Fresnel
Fresnelintensity = WaterState\Fresnelintensity
GradientCubeMap=WaterState\GradientCubeMap
UnderWaterFog = WaterState\UnderWaterFog
RefractTexture = WaterState\RefractTexture
Reflective=WaterState\Reflective
BumpReflectOFF=WaterState\BumpReflectOFF
UnderWaterReflective=WaterState\UnderWaterReflective
Refractive=WaterState\Refractive
BumpShader = WaterState\BumpShader
Entity= WaterState\Entity
EndIf

If Entity=0
WaterRender\Quade = 1
WaterRender\Entity=ACreateQuade()
CreateReceiver WaterRender\Entity,0
EntityAlpha WaterRender\Entity,0
PositionEntity  WaterRender\Entity, X#, Y#, Z#
ScaleEntity  WaterRender\Entity, ScaleX#, ScaleY#, ScaleZ#
RotateEntity WaterRender\Entity,-90,0,0
Else
WaterRender\Entity=Entity
WaterRender\Quade = 0
EndIf

If Refractive>0 And BumpTexture<>0
WaterRefractMesh = CreateRefractWater(WaterRender\Entity)

RefMesh.Ref_Mesh=Object.Ref_Mesh( reti(WaterRefractMesh+S_ShadowStructOffset) )
RefMesh\WaterStructHandle = Handle( WaterRender.AWaters )

;RefBumpTexture.ARefBumpTextures = Object.ARefBumpTextures( BumpTexture )
SetRefractBumpTexture  WaterRender\Entity, BumpTexture;RefBumpTexture\Texture
;EntityFX  WaterRender\Entity, 16+1+8
;EntityAlpha WaterRender\Entity,0
EndIf


WaterRender\ReflectWTexture = WaterState\ReflectWTexture

If WaterRender\ReflectWTexture = 0
	 WaterRender\ReflectSizeW=ReflectSizeW
	 WaterRender\ReflectSizeH=ReflectSizeH
	 WaterRender\Texture = CreateTextureRT( ReflectSizeW, ReflectSizeH , 1 , 1 + 256 )
	 WaterRender\texkoef = ReflectSizeW / ReflectSizeH
	 WaterRender\WaterCP.CP_ClipPlane=New CP_ClipPlane
	 WaterRender\WaterCP\a = 0
	 WaterRender\WaterCP\b = 1
	 WaterRender\WaterCP\c = 0
	 WaterRender\WaterCP\d = -EntityY(WaterRender\Entity,1)
Else
	WaterRender2.AWaters = Object.AWaters( WaterRender\ReflectWTexture )
	WaterRender\ReflectWTexture = WaterRender2\Texture
	WaterRender2\LinkedWater = Handle(WaterRender.AWaters)
	
	 WaterRender\ReflectSizeW=TextureWidth(WaterRender\ReflectWTexture)
	 WaterRender\ReflectSizeH=TextureHeight(WaterRender\ReflectWTexture)
	 WaterRender\texkoef = WaterRender\ReflectSizeW / WaterRender\ReflectSizeH
	 WaterRender\Texture = WaterRender\ReflectWTexture
	 WaterRender\WaterCP.CP_ClipPlane=New CP_ClipPlane
	 WaterRender\WaterCP\a = 0
	 WaterRender\WaterCP\b = 1
	 WaterRender\WaterCP\c = 0
	 WaterRender\WaterCP\d = -EntityY(WaterRender\Entity,1)
EndIf
; SetPlaneOrientation(Entity, WaterRender\WaterCP,0,0,0)

WaterRender\BumpTexture =  BumpTexture
WaterRender\BumpPower =  BumpPower#
WaterRender\BumpDestCorrectOFF = BumpDestCorrectOFF

WaterRender\Fresnel = Fresnel
WaterRender\Fresnelintensity = Fresnelintensity
WaterRender\GradientCubeMap =  GradientCubeMap
WaterRender\UnderWaterFog = UnderWaterFog

WaterRender\RefractTexture = RefractTexture
WaterRender\Reflective =  Reflective
WaterRender\BumpReflectOFF = BumpReflectOFF
WaterRender\UnderWaterReflective =  UnderWaterReflective
WaterRender\Refractive =  Refractive
WaterRender\BumpShader = BumpShader
 
 WaterRender\WaterMaterial.AD3DMaterial=New AD3DMaterial
 WaterRender\WaterMaterial\diffuseColorR = 0
 WaterRender\WaterMaterial\diffuseColorG = 0
 WaterRender\WaterMaterial\diffuseColorB = 0

If GradientCubeMap=0 Or Fresnel=0
	 WaterRender\WaterMaterial\ambientColorR = WaterColorR / 255.0
	 WaterRender\WaterMaterial\ambientColorG = WaterColorG / 255.0
	 WaterRender\WaterMaterial\ambientColorB = WaterColorB / 255.0
 Else
	 WaterRender\WaterMaterial\ambientColorR = 255;WaterColorR / 255;
	 WaterRender\WaterMaterial\ambientColorG = 255;WaterColorG / 255;
	 WaterRender\WaterMaterial\ambientColorB = (255-Fresnelintensity ) / (255.0);
 EndIf

 WaterRender\WaterMaterial\specularColorR = 0
 WaterRender\WaterMaterial\specularColorG = 0
 WaterRender\WaterMaterial\specularColorB = 0

 WaterRender\WaterMaterial\emissiveColorR = 0
 WaterRender\WaterMaterial\emissiveColorG = 0
 WaterRender\WaterMaterial\emissiveColorB = 0

; ResetWaterStates ()

Return  Handle(WaterRender.AWaters)

End Function

Function ASetWaterTransform (WaterHandle, X#=0, Y#=0, Z#=0,  ScaleX#=1, ScaleY#=1, ScaleZ#=1)
WaterRender.AWaters = Object.AWaters( WaterHandle )

PositionEntity WaterRender\Entity, X#, Y#, Z#
ScaleEntity WaterRender\Entity, ScaleX#, ScaleY#, ScaleZ#

 End Function

Function ASetWaterBumpTexture (WaterHandle, WaterNormalMap)
WaterRender.AWaters = Object.AWaters( WaterHandle )

WaterRender\BumpTexture =  WaterNormalMap

 End Function

Function ASetWaterStates ( WaterHandle, WaterState.AWaterStates )

WaterRender.AWaters = Object.AWaters( WaterHandle )

WaterColorR=WaterState\WaterColorR
WaterColorG=WaterState\WaterColorG
WaterColorB=WaterState\WaterColorB
BumpTexture=WaterState\BumpTexture
BumpPower#=WaterState\BumpPower
Reflective=WaterState\Reflective
UnderWaterReflective=WaterState\UnderWaterReflective
Refractive=WaterState\Refractive

WaterRender\BumpTexture =  WaterState\BumpTexture
WaterRender\BumpPower =  WaterState\BumpPower#
WaterRender\BumpDestCorrectOFF = WaterState\BumpDestCorrectOFF

WaterRender\Fresnel = WaterState\Fresnel
WaterRender\Fresnelintensity = WaterState\Fresnelintensity
WaterRender\GradientCubeMap = WaterState\GradientCubeMap
WaterRender\UnderWaterFog = WaterState\UnderWaterFog

WaterRender\RefractTexture = WaterState\RefractTexture

WaterRender\Reflective =  WaterState\Reflective
WaterRender\UnderWaterReflective =  WaterState\UnderWaterReflective
WaterRender\Refractive =  WaterState\Refractive
WaterRender\BumpReflectOFF=WaterState\BumpReflectOFF
WaterRender\BumpShader = WaterState\BumpShader

If Entity WaterRender\Entity = WaterState\Entity 
 
 WaterRender\WaterMaterial\diffuseColorR = 0
 WaterRender\WaterMaterial\diffuseColorG = 0
 WaterRender\WaterMaterial\diffuseColorB = 0

If WaterState\GradientCubeMap=0 Or WaterRender\Fresnel=0
	WaterRender\WaterMaterial\ambientColorR = WaterColorR / 255.0
	WaterRender\WaterMaterial\ambientColorG = WaterColorG / 255.0
	WaterRender\WaterMaterial\ambientColorB = WaterColorB / 255.0
 Else
	WaterRender\WaterMaterial\ambientColorR = 255;WaterColorR / 255;
	WaterRender\WaterMaterial\ambientColorG = 255;WaterColorG / 255;
	WaterRender\WaterMaterial\ambientColorB = (255-WaterRender\Fresnelintensity ) / (255.0);
 EndIf

 WaterRender\WaterMaterial\specularColorR = 0
 WaterRender\WaterMaterial\specularColorG = 0
 WaterRender\WaterMaterial\specularColorB = 0

 WaterRender\WaterMaterial\emissiveColorR = 0
 WaterRender\WaterMaterial\emissiveColorG = 0
 WaterRender\WaterMaterial\emissiveColorB = 0

; ResetWaterStates ()

End Function

Function AWaterReflectResize ( WaterHandle, Width, Height )

If Width>0 And Height>0

WaterRender.AWaters = Object.AWaters( WaterHandle )

WaterState\ReflectSizeW = Width
WaterState\ReflectSizeH = Height

DeleteRenderTarget reti(TextureBuffer(WaterRender\Texture) + 12)
FreeTexture WaterRender\Texture
WaterRender\Texture = CreateTextureRT( Width, Height , 1 , 1 + 256 )
WaterRender\texkoef = WaterState\ReflectSizeW / WaterState\ReflectSizeH

Return 1

EndIf

Return 0

End Function

Function AGetWaterReflectTexture(WaterHandle)
	WaterRender.AWaters = Object.AWaters( WaterHandle )
	Return WaterHandle;WaterRender\Texture
End Function

Function AGetWaterEntity ( WaterHandle )

WaterRender.AWaters = Object.AWaters( WaterHandle )
Return  WaterRender\Entity

End Function


Function AGetWaterStates ( WaterHandle )
WaterRender.AWaters = Object.AWaters( WaterHandle )

WaterState\ReflectSizeW =  WaterRender\ReflectSizeW
WaterState\ReflectSizeH =  WaterRender\ReflectSizeH


WaterState\BumpTexture =  WaterRender\BumpTexture
WaterState\BumpPower =  WaterRender\BumpPower
WaterState\BumpDestCorrectOFF = WaterRender\BumpDestCorrectOFF

WaterState\Fresnel = WaterRender\Fresnel
WaterState\Fresnelintensity = WaterRender\Fresnelintensity
WaterState\GradientCubeMap = WaterRender\GradientCubeMap
WaterState\UnderWaterFog = WaterState\UnderWaterFog

WaterState\RefractTexture = WaterRender\RefractTexture

WaterState\Reflective =  WaterRender\Reflective
WaterState\BumpReflectOFF=WaterRender\BumpReflectOFF
WaterState\UnderWaterReflective =  WaterRender\UnderWaterReflective
WaterState\Refractive =  WaterRender\Refractive
WaterState\BumpShader = WaterRender\BumpShader


 WaterState\WaterMaterial.AD3DMaterial =  WaterRender\WaterMaterial.AD3DMaterial
 WaterState\Texture  =  WaterRender\Texture
 WaterState\texkoef  =  WaterRender\texkoef
 WaterState\WaterCP.CP_ClipPlane =  WaterRender\WaterCP.CP_ClipPlane

  WaterState\Entity  =  WaterRender\Entity
  
End Function

Function ResetWaterStates ()
WaterState\X=0
WaterState\Y=0
WaterState\Z=0
WaterState\ScaleX = 1
WaterState\ScaleY = 1
WaterState\ScaleZ = 1

WaterState\ReflectSizeW = 256
WaterState\ReflectSizeH = 256

WaterState\WaterColorR = 255
WaterState\WaterColorG = 255
WaterState\WaterColorB = 255

WaterState\BumpTexture = 0
WaterState\BumpPower= 0.2
WaterState\BumpDestCorrectOFF=0

WaterState\GradientCubeMap = 0

WaterState\RefractTexture=0

WaterState\Reflective=1
WaterState\BumpReflectOFF = 0
WaterState\UnderWaterReflective=0
WaterState\Refractive=1
WaterState\BumpShader = 0

WaterState\Entity = 0
End Function


Function ADeleteRenderWater (WaterHandle)
WaterRender.AWaters = Object.AWaters( WaterHandle )

If WaterRender\ReflectWTexture=0 FreeTexture WaterRender\Texture
FreeEntity WaterRender\Entity

Delete WaterRender
AWater_PlanesCount = AWater_PlanesCount-1

 End Function

 Function FreeWaters () ; Delete  waters (use before End Graphics and End Programm ) 
 For WaterRender.AWaters = Each AWaters
  If WaterRender\ReflectWTexture=0 FreeTexture WaterRender\Texture 
  Delete WaterRender 
 Next

 If Ref_SystemCorrectedPiv 	FreeEntity Ref_SystemCorrectedPiv
 End Function
;======================================================================================================





;System function, Not use!
Function AUpdateWater (camera, S_tween#=1.0)  ; Update Waters

If AWater_PlanesCount>0 And PP_FrameCorrectID<>0
	AUpdateWaterReflect (camera, S_tween#)
	ADrawWater (camera, S_tween#)
EndIf

End Function

Function AUpdateWaterReflect (camera, S_tween#=1.0)
WaterUpdate_Screen_texture=0

Local matrix=BBGetTransform( 2)

Local Entity,MapSizeW,MapSizeH, AttachedWater
Local fxcamera=CreateCamera()
Local DestC2Pl#, RenderReflectPASS

If Not Ref_SystemCorrectedPiv
Ref_SystemCorrectedPiv = CreatePivot()
CutEntity Ref_SystemCorrectedPiv
EndIf

;BBCopyEntityMatrix ( camera, Ref_SystemCorrectedPiv, 1 )
CopyMemory4 ( camera+88, Ref_SystemCorrectedPiv+88, 12 )
CopyMemory4 ( camera+176, Ref_SystemCorrectedPiv+176, 12 )
CopyMemory4 ( camera+516, Ref_SystemCorrectedPiv+516, 12 )

Ref_CamZn# = RetF ( camera + 640)
Ref_CamZf# = RetF ( camera + 644)
CameraRange( fxcamera, Ref_CamZn, Ref_CamZf )
RCam_Zoom#=retF( camera + 576)

Ref_FogColorR# = RetF (camera + 154*4)
Ref_FogColorG# = RetF (camera + 155*4)
Ref_FogColorB# = RetF (camera + 156*4)
CameraFogColor fxcamera, Ref_FogColorR#*255, Ref_FogColorG#*255, Ref_FogColorB#*255
CameraFogMode fxcamera, RetW (camera + 159*4);BBGetRenderState(35);RetW (camera + 159*4)
CameraFogRange fxcamera, RetF (camera + 157*4),  RetF (camera + 158*4)

CameraProjMode camera,0
CameraProjMode fxcamera,1
CameraZoom fxcamera,RCam_Zoom
CameraClsColor  fxcamera, 255*retF ( camera + 149*4), 255*retF ( camera + 150*4), 255*retF ( camera + 151*4)

For WaterRender.AWaters = Each AWaters
Entity = WaterRender\Entity

If Not WaterRender\LinkedWater=0
	WaterRender2.AWaters = Object.AWaters( WaterRender\LinkedWater )
	If (EntityInView(WaterRender2\Entity,camera)>0 And EntityHide(WaterRender2\Entity)=0)
		AttachedWater=1
	EndIf
EndIf


If (EntityInView(Entity,camera)>0 And EntityHide(Entity)=0) Or AttachedWater=1

WaterRender\Show=1
RenderReflectPASS=0
If WaterRender\Refractive>0 And WaterRender\BumpTexture>0 And WaterRender\RefractTexture=0  WaterUpdate_Screen_texture=1 

Reflective=WaterRender\Reflective
UnderWaterReflective=WaterRender\UnderWaterReflective


 WaterRender\WaterCP\d = -EntityY(WaterRender\Entity,1)
DestC2Pl# = ( WaterRender\WaterCP\a*EntityX(camera,1) +  WaterRender\WaterCP\b*EntityY(camera,1) +  WaterRender\WaterCP\c*EntityZ(camera,1) +  WaterRender\WaterCP\d)
WaterRender\DestWaterToCam# = Abs( DestC2Pl# )

;If WaterRender\ReflectWTexture=0
	
	
	If DestC2Pl#<0
		WaterRender\WaterCP\a=- WaterRender\WaterCP\a :  WaterRender\WaterCP\b=- WaterRender\WaterCP\b
		WaterRender\WaterCP\c=- WaterRender\WaterCP\c :  WaterRender\WaterCP\d=- WaterRender\WaterCP\d
		BBSetClipPlane (0, WaterRender\WaterCP)
		WaterRender\WaterCP\a=- WaterRender\WaterCP\a :  WaterRender\WaterCP\b=- WaterRender\WaterCP\b
		WaterRender\WaterCP\c=- WaterRender\WaterCP\c :  WaterRender\WaterCP\d=- WaterRender\WaterCP\d
		If UnderWaterReflective=1 RenderReflectPASS=1
		WaterRender\UnderWater=1
	Else
		If Reflective=1 RenderReflectPASS=1
		WaterRender\UnderWater=0
		BBSetClipPlane (0, WaterRender\WaterCP)
	EndIf
		If RenderReflectPASS And WaterRender\ReflectWTexture=0
		  
			If WaterRender\Quade=0 HideEntity Entity
			MapSizeW=TextureWidth(WaterRender\Texture)
			MapSizeH=TextureHeight(WaterRender\Texture)
			CameraViewport fxcamera,0,0,MapSizeW,MapSizeH
			
			PositionEntity fxcamera, EntityX(camera,1)- WaterRender\WaterCP\a*DestC2Pl*2, EntityY(camera,1)- WaterRender\WaterCP\b*DestC2Pl*2, EntityZ(camera,1)- WaterRender\WaterCP\c*DestC2Pl*2
				RotateEntity fxcamera, -EntityPitch(camera,1), EntityYaw(camera,1),  -EntityRoll(camera,1),  0
				EntityParent fxcamera,0
			;;BBCopyEntityMatrix ( camera, fxcamera, 0)
			;BBCopyMatrixToEntity ( fxcamera, 0)
			;;copymemory4 ( camera+176, fxcamera+176, 12)
			;BBSetMatrixReflect ( fxcamera, WaterRender\WaterCP, 0 )
			
				
			;Ref_OldCull = BBGetRenderState(22)
			BBSetRenderState(152, 1 )
			
			WaterRender\RefTextBuffer = TextureBuffer( WaterRender\Texture)
			
			Ref_OldBuff=BBGetRenderTarget ( )
			BBSetRenderTarget (  RetI (TextureBuffer( WaterRender\Texture) + 12) )
			
				RenderWorld ;S_tween#
				
			BBSetRenderTarget (  Ref_OldBuff )
			BBsetRenderState(152, 0 )
			
			If WaterRender\Quade=0 ShowEntity Entity
		EndIf

;Else
;	WaterRender\RefTextBuffer = TextureBuffer( WaterRender\Texture)
;EndIf

Else
WaterRender\Show=0
EndIf

Next

	ScaleEntity fxcamera,1,1,1,1
	CameraProjMode fxcamera,0
	CameraProjMode camera,1
	CameraZoom fxcamera,1

CopyMemory4 ( Ref_SystemCorrectedPiv+88, camera+88, 12 )
CopyMemory4 ( Ref_SystemCorrectedPiv+176, camera+176, 12 )
CopyMemory4 ( Ref_SystemCorrectedPiv+516, camera+516, 12 )
FreeEntity fxcamera

End Function

Function ADrawWater (camera, S_tween#=1.0)

PostProcessInit()

Local Ref_sf, Ref_sf_i, D3DCull, D3DAlpBl, BumpSU#, BumpSV#, BumpU#, BumpV#, D3Dsb, D3Ddb,D3DFog
Local fog_color, fog_n, fog_f, UnderWaterFog
Local ReflectSloy, ReflectSloyb, ReflectSloyr, ReflectSloyg
Local Entity,Quade,MapSizeW,MapSizeH
Local DestC2Pl#
Local FixedMesh = CreateMesh(camera);
Local Fsurf = CreateSurface(FixedMesh)
AddVertex(Fsurf, 100,100,100)
AddVertex(Fsurf, -100,-100,-100)
EntityFX FixedMesh,1
EntityBlend FixedMesh,3
EntityTexture FixedMesh,Simple_texture,0,0
;EntityTexture FixedMesh,Simple_texture,0,1
;EntityTexture FixedMesh,Simple_texture,0,2
;EntityTexture FixedMesh,Simple_texture,0,3
;EntityTexture FixedMesh,Simple_texture,0,4

Local ReflectSizeW#, ReflectSizeH# , texkoef#
Local BumpTexture, BumpTextureSourse
Local BumpPower#, BumpPowerDestCorrect#
Local Reflective,BumpReflectOFF
Local UnderWaterReflective,UnderWater
Local Refractive,BumpShader
Local Texture, Fresnel
Local D3DAdres0, D3DAdres2, D3DAdresU0, D3DAdresU2 , D3DAdresV0, D3DAdresV2
Local D3DZenab, D3DZwrite

;Ref_copyW=GraphicsWidth()/3
;Ref_copyH=GraphicsHeight()/3

Ref_Fog=Reti(  camera +636);BBGetRenderState(28)
fog_color=AD3DCOLOR(RetF(  camera +616)*255,RetF(  camera +620)*255,RetF(  camera +624)*255,100)  ;BBGetRenderState(34)
fog_n=Reti(  camera +628);BBGetRenderState(36)
fog_f=Reti(  camera +632);BBGetRenderState(37)

RCam_X#=Reti(  camera +580)
RCam_Y#=Reti(  camera +584)
RCam_W#=Reti(  camera +588)
RCam_H#=Reti(  camera +592)
RCam_Zoom#=retF( camera + 576)
Ref_CamZn# = RetF ( camera + 640)
Ref_CamZf# = RetF ( camera + 644)



RenderEntity ( FixedMesh, camera)


BBSaveTextureStates (0)
BBSaveTextureStates (1)
BBSaveTextureStates (2)
BBSaveTextureStates (3)
BBSaveTextureStates (4)
BBSaveTextureStates (5)
BBSaveTextureStates (6)

BBSaveTextureMatrix (16)
BBSaveTextureMatrix (17)
BBSaveTextureMatrix (18)
BBSaveTextureMatrix (19)
BBSaveTextureMatrix (20)
BBSaveTextureMatrix (21)
BBSaveTextureMatrix (22)

FreeEntity FixedMesh


If WaterUpdate_Screen_texture=1 And Refract_PixelDistortion=0
	If Glow_HDR
;		AStretchRect BackBuffer(), 0,0,GraphicsWidth(),GraphicsHeight(),  TextureBuffer(Screen_TextureSystemRT2), 0,0,Ref_copyW ,Ref_copyH
	Else
		AStretchRect BackBuffer(), 0,0,GraphicsWidth(),GraphicsHeight(),  TextureBuffer(Screen_texture), 0,0,Ref_copyW ,Ref_copyH
	EndIf
	Ref_CopyTexPass=1
	Screen_textureUpdated=1
EndIf
;	If WaterUpdate_Screen_texture=1 Screen_textureUpdated=0

D3DAlpBl = BBGetRenderState ( 27)
D3DCull = BBGetRenderState ( 22)
D3Dsb = BBGetRenderState ( 19)
D3Ddb = BBGetRenderState ( 20)
D3DZenab = BBGetRenderState(  7)
D3DZwrite = BBGetRenderState(  14)
D3DFog = BBGetRenderState(  35)
;BBSetRenderState ( 28, 1);reti(camera+640) )
;BBSetRenderState ( 28, reti(camera+640) )
;BBSetRenderState ( 36, reti(camera+640) )

BBSetRenderState  22,1
BBSetRenderState 7,1
BBSetRenderState  35,3
BBSetRenderState  28,0

SetSimpleTextureStates( 0 )
SetSimpleTextureStates( 1 )
SetSimpleTextureStates( 2 )
SetSimpleTextureStates( 3 )
SetSimpleTextureStates( 4 )
SetSimpleTextureStates( 5 )
SetSimpleTextureStates( 6 )

BBSetTextureStageState 4,1,1
BBSetTextureStageState 5,1,1
BBSetTextureStageState 6,1,1
BBSetTextureStageState 7,1,1
BBSetTextureStageState 4,4,1
BBSetTextureStageState 5,4,1
BBSetTextureStageState 6,4,1
BBSetTextureStageState 7,4,1

BBBeginScene


For WaterRender.AWaters = Each AWaters
If WaterRender\show


If Not WaterRender\Reflective=0 And WaterRender\UnderWaterReflective=0 And WaterRender\Refractive=0


Entity = WaterRender\Entity
Quade =  WaterRender\Quade

ReflectSizeW#=WaterRender\ReflectSizeW
ReflectSizeH#=WaterRender\ReflectSizeH
texkoef# = WaterRender\texkoef
If WaterRender\RefractTexture
RefractSizeW#=TextureWidth(WaterRender\RefractTexture)
RefractSizeH#=TextureHeight(WaterRender\RefractTexture)
EndIf

BumpTexture=WaterRender\BumpTexture
;If BumpTexture>0
;RefBumpTexture.ARefBumpTextures = Object.ARefBumpTextures( BumpTexture )
;BumpTextureSourse = RefBumpTexture\Texture
;BumpU# = -RefBumpTexture\DU# 
;BumpV# = -RefBumpTexture\DV#
;BumpSU# = 1/RefBumpTexture\ScaleU# 
;BumpSV# = 1/RefBumpTexture\ScaleV#
;EndIf

BumpPower#=WaterRender\BumpPower
If WaterRender\BumpDestCorrectOFF=0
	BumpPowerDestCorrect# = BumpPower# / (WaterRender\DestWaterToCam#*0.005);  / (BumpSU#+BumpSV#)/2)
	If BumpPowerDestCorrect#>BumpPower# 	BumpPowerDestCorrect#=BumpPower#
Else
	BumpPowerDestCorrect# = BumpPower#
EndIf

Reflective=WaterRender\Reflective
BumpReflectOFF = WaterRender\BumpReflectOFF
UnderWaterReflective=WaterRender\UnderWaterReflective
UnderWater=WaterRender\UnderWater
Refractive=WaterRender\Refractive
BumpShader=WaterRender\BumpShader
UnderWaterFog = WaterRender\UnderWaterFog

If UnderWater=1 And UnderWaterFog=1
	BBSetRenderState ( 34, fog_color )
	BBSetRenderState  28,1;Ref_Fog
	BBSetRenderState(36, fog_n)
	BBSetRenderState(37, fog_f)
Else
	BBSetRenderState  28,Ref_Fog
	BBSetRenderState ( 34, fog_color )
	BBSetRenderState(36, fog_n)
	BBSetRenderState(37, fog_f)
EndIf

Texture =WaterRender\Texture

Fresnel = WaterRender\Fresnel

GradientCubeMap = WaterRender\GradientCubeMap
If UnderWater=1 GradientCubeMap=0

If BumpTexture=0 Or (Refract_PixelDistortion=1 And WaterRender\RefractTexture=0) Refractive=0
If BumpTexture=0 Fresnel=0

RefractSloy = 3


BBSetTextureStageState 0,1,1
BBSetTextureStageState 1,1,1
BBSetTextureStageState 2,1,1
BBSetTextureStageState 3,1,1
BBSetTextureStageState 4,1,1
BBSetTextureStageState 5,1,1

BBSetTextureStageState 0,4,1
BBSetTextureStageState 1,4,1
BBSetTextureStageState 2,4,1
BBSetTextureStageState 3,4,1
BBSetTextureStageState 4,4,1
;BBSetTextureStageState 5,4,1

ReflectSloy=0
ReflectPass=0

If UnderWater=0 Or (UnderWater=1 And UnderWaterReflective=1)
If Reflective

ReflectPass = 1
ReflectSloyb = 0
ReflectSloyr = 1
ReflectSloyg=2

If GradientCubeMap<>0

	If BumpTexture>0 And BumpReflectOFF=0 And Fresnel>0
		ReflectSloyg = ReflectSloy+1
		ReflectSloyb = 2
		ReflectSloyr = 3
		BBSetTexture  ReflectSloy , reti( TextureBuffer(BumpTexture)+12)
		BBSetTextureStageState ( ReflectSloy ,1 ,4)
		BBSetTextureStageState ( ReflectSloy ,4 ,2);/////////////////////
		BBSetTextureStageState ( ReflectSloy ,5 ,3);3
		BBSetTextureStageState ( ReflectSloy ,6 ,3);3
		BBSetTEXCOORDINDEX ( ReflectSloy , 0 )
		BBSetTextureStageState ( ReflectSloy ,24 ,2 ) ; Or 256
		BBSetTextureStageState ( ReflectSloy + 2 ,12, 1)
		BBSetTextureStageState ( ReflectSloy + 2 ,13 ,1)
		BBSetTextureStageState ( ReflectSloy + 2 ,14 ,1)
		BBSetTextureMatrix (  reti (BumpTexture), ReflectSloy  )
	Else
		ReflectSloyg = 2;ReflectSloy
		ReflectSloyb = 0
		ReflectSloyr = 1
	EndIf
	
	BBSetTexture (  ReflectSloyg , reti( TextureBuffer(GradientCubeMap)+12)  )
	BBSetTextureTransformMatrix (  Camera, 0 , ReflectSloyg, 0, 1)
	;BBSetTextureMatrix ( ReflectSloy + 2 , 0, 0, 1, 1 )
	;BBSetTextureProjMatrix()
	BBSetBumpMatrix (  ReflectSloyg , 0,0,  0	)
	BBSetBumpMatrix (  ReflectSloyg , 0,1,  0	)
	BBSetBumpMatrix (  ReflectSloyg , 1,0,  0	)
	BBSetBumpMatrix (  ReflectSloyg , 1,1,  0	)
	If Fresnel=0
		BBSetTextureStageState ( ReflectSloyg ,1 ,4)
	Else
		BBSetTextureStageState ( ReflectSloyg ,1 ,24)
;		BBSetTexture ( ReflectSloyg+1, 0)
;		BBSetTextureStageState ( ReflectSloyg+1 ,1 ,6)
;		BBSetCOLORARG ( ReflectSloyg+1 ,4)
	EndIf
	BBSetTextureStageState ( ReflectSloyg ,4 ,2);/////////////////////
	BBSetTextureStageState ( ReflectSloyg ,2 ,2)
	BBSetTextureStageState ( ReflectSloyg ,3 ,1)
	BBSetTextureStageState ( ReflectSloyg ,5 ,1);3
	BBSetTextureStageState ( ReflectSloyg ,6 ,1);3
	BBSetTextureStageState ( ReflectSloyg ,12, 3)
	BBSetTextureStageState ( ReflectSloyg ,13 ,3)
	BBSetTextureStageState ( ReflectSloyg ,14 ,3)
	BBSetTEXCOORDINDEX ( ReflectSloyg, 3 )
	BBSetTextureStageState ( ReflectSloyg ,24 , 3 ) ; Or 256
;		BBSetTextureStageState ( ReflectSloyg+1 ,2 ,1)
;		BBSetTextureStageState ( ReflectSloyg+1 ,3 ,1)

Else
;If Refractive=1
;Else
;BBSetTextureStageState ( ReflectSloy + 1,1,4)
;EndIf
EndIf

If BumpTexture>0 And BumpReflectOFF=0
BBSetTexture  ReflectSloyb , reti( TextureBuffer(BumpTexture)+12)
BBSetBumpShaderStages (  ReflectSloyb , BumpShader )
BBSetBumpMatrix (  ReflectSloyb , 0,0, -BumpPowerDestCorrect#*2.5)
BBSetBumpMatrix (  ReflectSloyb , 0,1,	 0)
BBSetBumpMatrix (  ReflectSloyb , 1,0,	 0)
BBSetBumpMatrix (  ReflectSloyb , 1,1, -BumpPowerDestCorrect#*2.5)
BBSetTEXCOORDINDEX ( ReflectSloyb , 0 )
BBSetTextureStageState ( ReflectSloyb ,24 ,2 ) ; Or 256
BBSetTextureStageState ( ReflectSloyb ,12, 1)
BBSetTextureStageState ( ReflectSloyb ,13 ,1)
BBSetTextureStageState ( ReflectSloyb ,14 ,1)
BBSetTextureMatrix (  reti (BumpTexture), ReflectSloyb  )
Else
BBSetBumpMatrix (  ReflectSloyb , 0,0,  0	)
BBSetBumpMatrix (  ReflectSloyb , 0,1,  0	)
BBSetBumpMatrix (  ReflectSloyb , 1,0,  0	)
BBSetBumpMatrix (  ReflectSloyb , 1,1,  0	)
ReflectSloyr=0
EndIf

BBSetTextureStageState ( ReflectSloyb ,5 ,3)
BBSetTextureStageState ( ReflectSloyb ,6 ,3)


BBSetTexture  ReflectSloyr, reti( TextureBuffer(Texture)+12)
BBSetProjectionShader (  ReflectSloyr, ReflectSizeH#/ReflectSizeW#, 0.97, RCam_Zoom)
BBSetTextureStageState ( ReflectSloyr,4,1)
BBSetTextureStageState ( ReflectSloyr ,5 ,3);3
BBSetTextureStageState ( ReflectSloyr ,6 ,3);3
;BBSetTextureStageState ( ReflectSloyr ,2 ,2)
;BBSetTextureStageState ( ReflectSloyr ,3 ,1)
If GradientCubeMap=0 Or Fresnel=0
	BBSetCOLORARG ( ReflectSloyr ,1)
	BBSetTextureStageState ( ReflectSloyr,1,4)
Else
	BBSetCOLORARG ( ReflectSloyr ,3)
	BBSetTextureStageState ( ReflectSloyr,1,4)
EndIf

EndIf
EndIf


If Refractive

If ReflectPass
	If GradientCubeMap<>0
		If Fresnel=0
			RefractSloy=3
		Else
			RefractSloy=4
		EndIf
	Else
		RefractSloy=2
	EndIf
Else
 RefractSloy=0
EndIf


BBSetTexture RefractSloy , reti( TextureBuffer(BumpTexture)+12)
;BBSetTextureStageState RefractSloy ,4,2
BBSetBumpShaderStages (  RefractSloy , BumpShader )

If Not UnderWater=0 BumpPowerDestCorrect=BumpPowerDestCorrect*2

BBSetBumpMatrix (  RefractSloy , 0,0, BumpPowerDestCorrect#)
BBSetBumpMatrix (  RefractSloy , 0,1,	 0)
BBSetBumpMatrix (  RefractSloy , 1,0,	 0)
BBSetBumpMatrix (  RefractSloy , 1,1, BumpPowerDestCorrect#)
;BBSetTextureStageState (RefractSloy  ,4,2);3
;BBSetTextureStageState ( RefractSloy ,5 ,2)
;BBSetTextureStageState ( RefractSloy ,6 ,2)

;BBSetTEXCOORDINDEX ( ReflectSloy , 0 )
;BBSetTextureStageState ( ReflectSloy ,24 ,2 ) ; Or 256
;BBSetTextureStageState ( ReflectSloy + 2 ,12, 1)
;BBSetTextureStageState ( ReflectSloy + 2 ,13 ,1)
;BBSetTextureStageState ( ReflectSloy + 2 ,14 ,1)
BBSetTextureMatrix (  reti (BumpTexture), RefractSloy )

;BBSetTexture 1, reti( TextureBuffer(Screen_texture)+12)
If WaterRender\RefractTexture
	BBSetTexture  RefractSloy + 1, reti( TextureBuffer(WaterRender\RefractTexture)+12)
	BBSetProjectionShader ( RefractSloy + 1  , -RefractSizeH#/RefractSizeW#, 0.97, RCam_Zoom)
Else
	BBSetTexture  RefractSloy + 1, reti( TextureBuffer(Screen_texture)+12); Screen_texture
	BBSetProjectionShader ( RefractSloy + 1  , -RezScreenKoef#, 0.97, RCam_Zoom)
EndIf


If ReflectPass
BBSetTextureStageState (RefractSloy + 1  ,1,11) ;11
Else
BBSetTextureStageState (RefractSloy + 1  ,1,4)
EndIf
BBSetTextureStageState (RefractSloy + 1  ,4,3);3
BBSetTextureStageState ( ReflectSloy + 1 ,5 ,2)
BBSetTextureStageState ( ReflectSloy + 1 ,6 ,2)

BBSetRenderState 27,0
BBSetRenderState 19,5
BBSetRenderState 20,6
BBSetRenderState 14,1

Else

BBSetRenderState 27,1
BBSetRenderState 19,10
BBSetRenderState 20,2
BBSetRenderState 14,0
EndIf




If Refractive=1 Or ReflectPass=1;Not (UnderWater=1 And UnderWaterReflective=0 And Refractive=0)


If ReflectPass
BBSetMaterial (  WaterRender\WaterMaterial)
Else
BBSetMaterial (  WaterMaterialWhite)
EndIf
BBSetEntityTransformMatrix (  Entity, 0 )
BBSetRenderState ( 60, AD3DCOLOR(255,255,255,100) )
;BBSetRenderState 24, AD3DCOLOR(0,0,0,100)
;BBSetRenderState 25, 1

If Quade
BBDrawQuade()
Else
For Ref_sf_i=1 To CountSurfaces(Entity)
Ref_sf = GetSurface(Entity, Ref_sf_i)
BBDrawSurface ( Ref_sf)
Next
EndIf


EndIf


EndIf
EndIf
Next

BBEndScene 

BBSetRenderState  22,D3DCull
BBSetRenderState 27,D3DAlpBl
BBSetRenderState 19,D3Dsb
BBSetRenderState 20,D3Ddb
BBSetRenderState 7,D3DZenab
BBSetRenderState 14,D3DZwrite
BBSetRenderState  35,D3DFog
BBSetRenderState  28, Ref_Fog

BBLoadTextureStates (0)
BBLoadTextureStates (1)
BBLoadTextureStates (2)
BBLoadTextureStates (3)
BBLoadTextureStates (4)
BBLoadTextureStates (5)
BBLoadTextureStates (6)

BBLoadTextureMatrix (16)
BBLoadTextureMatrix (17)
BBLoadTextureMatrix (18)
BBLoadTextureMatrix (19)
BBLoadTextureMatrix (20)
BBLoadTextureMatrix (21)
BBLoadTextureMatrix (22)

BBSetBumpMatrix (  RefractSloy , 0,0, 	0)
BBSetBumpMatrix (  RefractSloy , 0,1,	0)
BBSetBumpMatrix (  RefractSloy , 1,0,	0)
BBSetBumpMatrix (  RefractSloy , 1,1, 	0)

BBSetBumpMatrix (  ReflectSloy , 0,0, 	0)
BBSetBumpMatrix (  ReflectSloy , 0,1,	0)
BBSetBumpMatrix (  ReflectSloy , 1,0,	0)
BBSetBumpMatrix (  ReflectSloy , 1,1, 	0)


BBMaterial\diffuseColorR = 1
BBMaterial\diffuseColorG = 1
BBMaterial\diffuseColorB = 1
BBMaterial\ambientColorR = 1
BBMaterial\ambientColorG = 1
BBMaterial\ambientColorB = 1
BBMaterial\specularColorR = 0
BBMaterial\specularColorG = 0
BBMaterial\specularColorB = 0
BBMaterial\emissiveColorR = 0
BBMaterial\emissiveColorG = 0
BBMaterial\emissiveColorB = 0

BBSetMaterial (  BBMaterial )


End Function

Function SetSimpleTextureStates( stage )
BBSetTextureStageState ( stage ,1 ,4)
BBSetTextureStageState ( stage ,2 ,2)
BBSetTextureStageState ( stage ,3 ,1)
BBSetTextureStageState ( stage ,4 ,3)
BBSetTextureStageState ( stage ,5 ,2)
BBSetTextureStageState ( stage ,6 ,1)
BBSetTextureStageState ( stage ,11 ,0)
BBSetTextureStageState ( stage ,12 ,1)
BBSetTextureStageState ( stage ,13 ,1)
BBSetTextureStageState ( stage ,14 ,1)
BBSetTextureStageState ( stage ,16 ,2)
BBSetTextureStageState ( stage ,17 ,2)
BBSetTextureStageState ( stage ,18 ,3)
BBSetTextureStageState ( stage ,19 ,0)
BBSetTextureStageState ( stage ,20 ,0)
BBSetTextureStageState ( stage ,21 ,1)
BBSetTextureStageState ( stage ,24 ,0)
End Function




Type A_Material
	
	Field AlphaBlend
	Field SrcBlend
	Field DestBlend
	
	Field DiffuseColor
	Field SpecularColor
	Field TFactorColor
	
	Field Specular
	
	Field ZBuffer
	Field Zwrite

	Field FogEnable

	Field Lighting

	Field ShadeMode

	Field CullMode


	Field Texture0
	Field Texture1
	Field Texture2
	Field Texture3
	Field Texture4
	Field Texture5
	Field Texture6
	Field Texture7

	Field TextureState0
	Field TextureState1
	Field TextureState2
	Field TextureState3
	Field TextureState4
	Field TextureState5
	Field TextureState6
	Field TextureState7

End Type

Type A_TextureBlends

	Field ColorOP
	Field ColorArgument1
	Field ColorArgument2

	Field AlphaOP
	Field AlphaArgument1
	Field AlphaArgument2

	Field BumpMat#[4]

	Field BumpEnvScele
	Field BumpEnvOffset

End Type

Type A_TextureStates

	Field TextureSourse

	Field TextureMatrix

	Field Blend.A_TextureBlends

	Field AdressU
	Field AdressV
	Field BorderColor

	Field CoordsGenegateType

	Field MipMapLevel
	Field MipMapLodBias
	Field MipFilter

	Field MagFilter
	Field MinFilter
	Field MaxAnisotropy

	Field TransformFlags

End Type

Type Vector3
	Field x#
	Field y#
	Field z#
End Type


Function GenerateLightForBump ( Mesh ,  Light , LType=0, LRange# = 100 )

Local L_Nx#, L_Ny#, L_Nz#, L_x#, L_y#, L_z#, L_d#
Local V_Nx#, V_Ny#, V_Nz#, V_x#, V_y#, V_z#, Dest#
Local V_Bx#, V_By#, V_Bz#
Local V_Tx#, V_Ty#, V_Tz#
Local R_x#, R_y#, R_z#
Local MeshScale#

;MeshScale = AMaxEntityScale(Mesh)
;LRange = LRange *MeshScale

Local T.Vector3 = New Vector3
Local B.Vector3 = New Vector3
Local N.Vector3 = New Vector3
Local Vp.Vector3 = New Vector3

Local L.Vector3 = New Vector3
Local Lp.Vector3 = New Vector3
Local R.Vector3 = New Vector3

Local V1.Vector3 = New Vector3
V1\x = 1
V1\y = 0
V1\z = 0

If LType=0
TFormNormal 0,0,1,Light,0
;L_Nx#=-TFormedX()
;L_Ny#=-TFormedY()
;L_Nz#=-TFormedZ()
L\x = TFormedX()
L\y = TFormedY()
L\z = TFormedZ()
Else
TFormPoint 0,0,0,Light,Mesh
Lp\x = TFormedX()
Lp\y = TFormedY()
Lp\z = TFormedZ()
;L_x# = TFormedX()
;L_y# = TFormedY()
;L_z# = TFormedZ()
;		NewVector ( L_Nx, L_Ny, L_Nz, 1)
;		L_Nx= GetNormX#()
;		L_Ny= GetNormY#()
;		L_Nz= GetNormZ#()
EndIf

;S_counrSm=CountSurfaces(mesh)
;For S_j=1 To S_counrSm
;S_s=GetSurface(mesh,S_j)
;S_countTris=CountTriangles(S_s)-1
;For S_i=0 To S_countTris

S_counrSm=CountSurfaces(Mesh)

For S_j=1 To S_counrSm

	S_s=GetSurface(Mesh,S_j)
	S_countVert=CountVertices(S_s)-1
	
	For S_i=0 To S_countVert

		; Get Vertex Normal ;--------------------------------------------------------------------------------------------------------
;		V_Nx = VertexNX(S_s, S_i)
;		V_Ny = VertexNY(S_s, S_i)
;		V_Nz = VertexNZ(S_s, S_i)

;		If Not LType = 0
;		V_x# = VertexX#(S_s, S_i)
;		V_y# = VertexY#(S_s, S_i)
;		V_z# = VertexZ#(S_s, S_i)
;		NewVector ( V_x-L_x, V_y-L_y, V_z-L_z, 1)
;		L_Nx= GetNormX#()
;		L_Ny= GetNormY#()
;		L_Nz= GetNormZ#()
;		L_d =  GetNormD#()
;		Dest = ((LRange-L_d)/LRange)
;		EndIf


;;		If  Dest>0 And -(L_Nx*V_Nx + L_Ny*V_Ny + L_Nz*V_Nz)>0 ;
;		; Get Binormal
;		V_Bx = 0
;		V_By = -V_Nz
;		V_Bz = V_Ny
;
;		;Get Tangent vector
;		V_Tx = V_Ny*V_Bz - V_Nz*V_By
;		V_Ty = -V_Nx*V_Bz
;		V_Tz = V_Nx*V_By
;
;		;Transform Light normal to Tangent Space
;		R_x = L_Nx*V_Tx + L_Ny*V_Ty + L_Nz*V_Tz
;		R_y = 					 L_Ny*V_By + L_Nz*V_Bz
;		R_z = L_Nx*V_Nx + L_Ny*V_Ny + L_Nz*V_Nz
;
;;		Dest# = Sqr( R_x*R_x + R_y*R_y + R_z*R_z)
;
;;		VertexNormal S_s, S_i,R_x/Dest , R_y/Dest, R_z/Dest
;		
;;		R_x = 0.5*R_x*Dest + 0.5
;;		R_y = 0.5*R_y*Dest + 0.5
;;		R_z = 0.5*R_z*Dest + 0.5
;		R_x = 0.5*R_x + 0.5
;		R_y = 0.5*R_y + 0.5
;		R_z = 0.5*R_z + 0.5

		N\x# = -VertexNX(S_s, S_i)
		N\y# = -VertexNY(S_s, S_i)
		N\z# = -VertexNZ(S_s, S_i)

	If Not LType = 0
		Vp\x# = VertexX#(S_s, S_i)
		Vp\y# = VertexY#(S_s, S_i)
		Vp\z# = VertexZ#(S_s, S_i)
		
		L\x# = Vp\x - Lp\x
		L\y# = Vp\y - Lp\y
		L\z# = Vp\z - Lp\z
;		L_d = VectorDist (L)
		L_d = NormalizeVector (L)
		
;	    L_d# = -(N\x*Lp\x + N\y*Lp\y+  N\z*Lp\z - ( N\x#*Vp\x# + N\y#*Vp\y# +N\z#*Vp\z# ))
		Dest = 1;((LRange-L_d)/LRange)
	Else
		Dest=1
	EndIf

V1\x = N\x+1
V1\y = N\y-1
V1\z = N\z+2
NormalizeVector (V1)
;		VertexNormal S_s, S_i, 0,0,10;N\x, N\y, N\z
ScalarLV# = DotVector (N, L);(N\x*L\x + N\y*L\y + N\z*L\z);
;		If ScalarLV#>0 ;And Dest>0
	
		CrossVector (B, V1, N)
		CrossVector (T,  N,   B)
;		
		R\x = DotVector (T, L)
		R\y = DotVector (B, L)
		R\z = DotVector (N, L)

		NormalizeVector( R )

;		R_x = 0.5*R\x*(1-ScalarLV) + 0.5
;		R_y = 0.5*R\y*(1-ScalarLV) + 0.5
;		R_z = 0.5*R\z*(1-ScalarLV) + 0.5
		R_x = (0.5*R\x + 0.5)
		R_y = (0.5*R\y + 0.5)
		R_z = (0.5*R\z + 0.5)
		
;		Normalize ( R )
	If ScalarLV#>0
;		VertexTexCoords S_s, S_i, R_x , R_y, 1, 1
		VertexColor S_s, S_i, 255, 255, Dest*127 + 128
;		VertexColor S_s, S_i, 255, 255, 255
;		VertexColor S_s, S_i, (Dest)*255, (Dest)*255, (Dest)*255
		
;		VertexColor S_s, S_i, R\x*127 + 127 , R\y*127 + 127, R\z*127 + 127
		VertexTexCoords S_s, S_i, R\x*0.5 + 0.5 , R\y*0.5 + 0.5, 1, 1
;		VertexColor S_s, S_i, 255 , 255, R\z*127 + 127
	Else
		VertexColor S_s, S_i, 255, 255, 255
;		VertexTexCoords S_s, S_i, R_x , R_y, 1, 1
		VertexTexCoords S_s, S_i, R\x*0.5 + 0.5 , R\y*0.5 + 0.5, 1, 1
;		VertexTexCoords S_s, S_i, 0.5,  0.5 , 1, 1
	EndIf
		
	Next
Next




End Function


Function  SplitMesh%(Mesh,  parent=0)
S_counrSm=CountSurfaces(Mesh)
NewMesh = CreateMesh(parent)

For S_j=1 To S_counrSm

	S_s=GetSurface(Mesh,S_j)
	S_brush = GetSurfaceBrush ( S_s )
	S_new = CreateSurface(NewMesh)
	PaintSurface S_new, S_brush
	
	S_countTr=CountTriangles(S_s)-1
	
	For S_i=0 To S_countTr

;----------------------------------------------------------------------------------------------------------------------------------------------
				S_V0 = TriangleVertex(S_s, S_i, 0)
				S_V1 = TriangleVertex(S_s, S_i, 1)
				S_V2 = TriangleVertex(S_s, S_i, 2)

				StencilS_Ax# = VertexX#(S_s, S_V0);*aEntityScaleX#(mesh)
				StencilS_Ay# = VertexY#(S_s, S_V0);*aEntityScaley#(mesh)
				StencilS_Az# = VertexZ#(S_s, S_V0);*aEntityScalez#(mesh)

				StencilS_Bx# = VertexX#(S_s, S_V1);*aEntityScaleX#(mesh)
				StencilS_By# = VertexY#(S_s, S_V1);*aEntityScaley#(mesh)
				StencilS_Bz# = VertexZ#(S_s, S_V1);*aEntityScalez#(mesh)

				StencilS_Cx# = VertexX#(S_s, S_V2);*aEntityScaleX#(mesh)
				StencilS_Cy# = VertexY#(S_s, S_V2);*aEntityScaley#(mesh)
				StencilS_Cz# = VertexZ#(S_s, S_V2);*aEntityScalez#(mesh)

				S_0U0# = VertexU# ( S_s,S_V0 ,0 )
				S_0V0# = VertexV# ( S_s,S_V0 ,0 )

				S_1U0# = VertexU# ( S_s,S_V1 ,0 )
				S_1V0# = VertexV# ( S_s,S_V1 ,0 )

				S_2U0# = VertexU# ( S_s,S_V2 ,0 )
				S_2V0# = VertexV# ( S_s,S_V2 ,0 )

				S_0U1# = VertexU# ( S_s,S_V0 ,1 )
				S_0V1# = VertexV# ( S_s,S_V0 ,1 )

				S_1U1# = VertexU# ( S_s,S_V1 ,1 )
				S_1V1# = VertexV# ( S_s,S_V1 ,1 )

				S_2U1# = VertexU# ( S_s,S_V2 ,1 )
				S_2V1# = VertexV# ( S_s,S_V2 ,1 )
				
				
				C_Px# = StencilS_Ax#-StencilS_Bx#
				C_Py# = StencilS_Ay#-StencilS_By#
				C_Pz# = StencilS_Az#-StencilS_Bz#

				C_Qx# = StencilS_Bx#-StencilS_Cx#
				C_Qy# = StencilS_By#-StencilS_Cy#
				C_Qz# = StencilS_Bz#-StencilS_Cz#

				V_Nx# = C_Py#*C_Qz# - C_Pz#*C_Qy#
				V_Ny# = C_Pz#*C_Qx# - C_Px#*C_Qz#
				V_Nz# = C_Px#*C_Qy# - C_Py#*C_Qx#
				Dest# = Sqr(V_Nx*V_Nx + V_Ny*V_Ny + V_Nz*V_Nz)
				V_Nx = V_Nx/Dest
				V_Ny = V_Ny/Dest
				V_Nz = V_Nz/Dest
;----------------------------------------------------------------------------------------------------------------------------------------------
		AddVertex ( S_new,StencilS_Ax# ,StencilS_Ay# ,StencilS_Az# )
		AddVertex ( S_new,StencilS_Bx# ,StencilS_By# ,StencilS_Bz# )
		AddVertex ( S_new,StencilS_Cx# ,StencilS_Cy# ,StencilS_Cz# )
		VertexNormal S_new, S_i*3+0, V_Nx, V_Ny, V_Nz
		VertexNormal S_new, S_i*3+1, V_Nx, V_Ny, V_Nz
		VertexNormal S_new, S_i*3+2, V_Nx, V_Ny, V_Nz
		
		VertexTexCoords S_new, S_i*3+0 ,S_0U0,S_0V0,1, 0
		VertexTexCoords S_new, S_i*3+0 ,S_0U1,S_0V1,1, 1

		VertexTexCoords S_new, S_i*3+1 ,S_1U0,S_1V0,1, 0
		VertexTexCoords S_new, S_i*3+1 ,S_1U1,S_1V1,1, 1

		VertexTexCoords S_new, S_i*3+2 ,S_2U0,S_2V0,1, 0
		VertexTexCoords S_new, S_i*3+2 ,S_2U1,S_2V1,1, 1

		AddTriangle (S_new, S_i*3+0, S_i*3+1, S_i*3+2)

	Next
Next

;Sm_brush = GetEntityBrush ( Mesh )
;PaintMesh NewMesh, Sm_brush

AFreeEntity Mesh

UpdateNormals NewMesh

Return NewMesh
				
End Function



Global ABump_Lbox, ABump_ref , ABump_Litex, ABump_Reftex, ABump_AmbientTex

Type ABumpMaps
	Field Entity
	Field SpecularMesh
	Field tex
	Field spectex
	Field lumtex
End Type

Global ACubeSize=128
Type AGlassRef
	Field Entity
	Field Cubmap
End Type

Function ASetBumpEntity ( mesh)
If mesh=0 RuntimeError "γ 衷࡭ᵨ㿠:("
Local Entity, i, name$, Entityshadow, EntityBump, brush, BlicEntity

S_FindALLChildren mesh

For S_SEntityChild.S_SEntityChildren=Each S_SEntityChildren
	Entity = S_SEntityChild\Entity

	name$=EntityName$( Entity )
	
	Entityshadow = Instr (name$, "#shadow", 1)
	If Entityshadow>0
		ChangeCaster Entity,1
	Else
		ChangeCaster Entity,0
	EndIf

	EntityBump = Instr (name$, "#bumpsp", 1)

	If EntityBump>0
		If EntityClass(Entity)="Mesh"
			brush = GetEntityBrush ( Entity )
			ABumpMap.ABumpMaps = New ABumpMaps
			ABumpMap\Entity = Entity
			ABumpMap\tex = GetBrushTexture( brush, 1)
			ABumpMap\spectex = GetBrushTexture( brush, 4)
			ABumpMap\lumtex = GetBrushTexture( brush, 5)
			EntityTexture  Entity,No_texture,0,0
			EntityTexture  Entity,No_texture,0,1
			EntityTexture  Entity,No_texture,0,2
			
			BlicEntity=CopyMesh(Entity,Entity)
			ABumpMap\SpecularMesh = BlicEntity
			For i=1 To CountChildren(BlicEntity)
				FreeEntity GetChild(BlicEntity,i)
			Next
				 UpdateNormals  Entity
			  CreateReceiver BlicEntity,3 
			  EntityTexture BlicEntity, Bump_Reftex,0,0
			  EntityTexture BlicEntity, ABumpMap\tex ,0,1
			  EntityTexture  BlicEntity,No_texture,0,3
			  EntityTexture  BlicEntity,No_texture,0,5
			  
			  EntityBlend BlicEntity,3
			  EntityColor BlicEntity,255,255,255
			  EntityFX BlicEntity,1

			EntityTexture Entity,ABumpMap\tex,0,1
			EntityTexture  Entity, Bump_Litex,0,0
  			EntityTexture  Entity, Bump_AmbientTex,0,2
			EntityTexture  Entity,No_texture,0,4
			FreeBrush brush
		EndIf
	EndIf

;
	EntityRefractb = Instr (name$, "#refb", 1)

	If EntityRefractb>0
		If EntityClass(Entity)="Mesh"
			brush = GetEntityBrush ( Entity )
			CreateRefractwater(Entity,3) ; set refractive mesh
			SetRefractBumpTexture Entity, GetBrushTexture( brush, 1)
			SetRefractLuminance( Entity,1 )
;			SetRefractPower(Entity, AgetEntityAlpha#(Entity) ) 
			EntityAlpha Entity, 0
			FreeBrush brush
		EndIf
	EndIf


	Entityglassb = Instr (name$, "#glassb", 1);glassb

	If Entityglassb>0
		If EntityClass(Entity)="Mesh"
			Aglass.AGlassRef = New AGlassRef
			Aglass\Entity = Entity
			Aglass\Cubmap = CreateTexture( ACubeSize,ACubeSize, 128+1)
			brush = GetEntityBrush ( Entity )
			EntityTexture  Entity,No_texture,0,0
			EntityTexture  Entity,No_texture,0,1
			EntityTexture  Entity,No_texture,0,2
			EntityFX Entity,1+8
;			PaintEntity Entity, brush
			CreateRefractMesh(Entity,3) ; set refractive mesh
			SetRefractBumpTexture Entity, GetBrushTexture( brush, 1)
			SetRefractLuminance( Entity,1 )
			EntityTexture Entity, Aglass\Cubmap, 0 , 0
			EntityFX Entity,1
			EntityBlend Entity,1
			EntityAlpha Entity, 0.3
			TextureBlend Aglass\Cubmap,5
			FreeBrush brush
		EndIf
	EndIf


	Entityglassb = Instr (name$, "#glassv", 1);glassb

	If Entityglassb>0
		If EntityClass(Entity)="Mesh"
			Aglass.AGlassRef = New AGlassRef
			Aglass\Entity = Entity
			Aglass\Cubmap = CreateTexture( ACubeSize,ACubeSize, 128+1)
			brush = GetEntityBrush ( Entity )
			EntityFX Entity,17
			EntityBlend Entity,1
			EntityAlpha Entity,1
			CreateRefractmesh(Entity,3) ; set refractive mesh
			SetRefractLuminance( Entity, 1 )
			EntityTexture Entity, Aglass\Cubmap, 0 , 0
			EntityBlend Entity,3
			EntityAlpha Entity,1
			EntityColor Entity, 50,50,50
			EntityShininess Entity,1
			EntityAlpha Entity,1
			FreeBrush brush
		EndIf
	EndIf
	

	Entityglassb = Instr (name$, "#env", 1);glassb
	
	If Entityglassb>0
		If EntityClass(Entity)="Mesh"
			Aglass.AGlassRef = New AGlassRef
			Aglass\Entity = Entity
			Aglass\Cubmap = CreateTexture( ACubeSize,ACubeSize, 128+1)
			brush = GetEntityBrush ( Entity )
;			tex0 = GetBrushTexture( brush, 0)
;			tex1 = GetBrushTexture( brush, 1)
			EntityTexture Entity, Aglass\Cubmap, 0 , 2
;			EntityTexture Entity,tex0
;			EntityTexture Entity,tex1
			
;			EntityFX Entity,17
			TextureBlend Aglass\Cubmap,3
			EntityShininess Entity,.7
			FreeBrush brush
		EndIf
	EndIf
	
Next
End Function


Function AReflect(Entity,camera,RTexture)
Local fxcamera = CreateCamera()

HideEntity entity

WaterMapSize=TextureWidth(RTexture)

	CameraProjMode fxcamera,1
	CameraProjMode camera,0
	CameraViewport fxcamera,0,0,WaterMapSize,WaterMapSize

PositionEntity fxcamera,EntityX(Entity,1), EntityY(Entity,1) ,EntityZ(Entity,1),1; EntityY(Entity)

; do left view
	SetCubeFace RTexture,0
	RotateEntity fxcamera,0,90,0
	RenderWorld
	CopyRect 0,0,WaterMapSize,WaterMapSize,0,0,BackBuffer(),TextureBuffer(RTexture)
	
	; do forward view
	SetCubeFace RTexture,1
	RotateEntity fxcamera,0,0,0
	RenderWorld
	CopyRect 0,0,WaterMapSize,WaterMapSize,0,0,BackBuffer(),TextureBuffer(RTexture)

	; do right view	
	SetCubeFace RTexture,2
	RotateEntity fxcamera,0,-90,0
	RenderWorld
	CopyRect 0,0,WaterMapSize,WaterMapSize,0,0,BackBuffer(),TextureBuffer(RTexture)

	; do backward view
	SetCubeFace RTexture,3
	RotateEntity fxcamera,0,180,0
	RenderWorld
	CopyRect 0,0,WaterMapSize,WaterMapSize,0,0,BackBuffer(),TextureBuffer(RTexture)

; do up view
	SetCubeFace RTexture,4
	RotateEntity fxcamera,-90,0,0
	RenderWorld
	CopyRect 0,0,WaterMapSize,WaterMapSize,0,0,BackBuffer(),TextureBuffer(RTexture)		

	SetCubeFace RTexture,5
	RotateEntity fxcamera,90,0,0
	RenderWorld
	CopyRect 0,0,WaterMapSize,WaterMapSize,0,0,BackBuffer(),TextureBuffer(RTexture)	

db=db+1

	CameraProjMode fxcamera,0
	CameraProjMode camera,1

ShowEntity entity

End Function


Function ASetGammaIntensity( n#, gamma=0 ) 

For k1=0 To 255
	SetGamma k1,k1,k1,k1*n#+gamma,k1*n#+gamma,k1*n#+gamma
Next 
UpdateGamma

End Function
